Uses
  DCore;

Type
TUpdate = class(TEvent)
end;

TUpdater = class(TEntity)
  Constructor Create(Owner: TEntity); override;
  Procedure Update;
  Procedure OnEvent(Event: TEvent); override;
end;

Var
  Factory: TFactory;
  Entity: TEntity;
  Event: TEvent;

Constructor TUpdater.Create(Owner: TEntity);
begin
  Inherited Create(Owner);
  Writeln('TUpdater.Create');
end;

Procedure TUpdater.Update;
begin
  Writeln('Update!');
end;

Procedure TUpdater.OnEvent(Event: TEvent);
begin
  Inherited OnEvent(Event);;
    If Event.IsType('TUpdate') then
      Update;
end;

Var
  Step: Integer = 0;

begin
  Inc(Step); Writeln(Step);	
  Factory := TFactory.Create(Nil);
  Inc(Step); Writeln(Step);
  Factory.RegistClass(TUpdater);
  Inc(Step); Writeln(Step);
  Entity := Factory.CreateEntity('TUpdater', Nil);
  Inc(Step); Writeln(Step);
  Event := TUpdate.Create(Nil);
  Inc(Step); Writeln(Step);
  Entity.OnEvent(Event);
  Inc(Step); Writeln(Step);
end.
