unit DBinary;

interface

Uses
  DCore;

Type
TBinaryFunc = Function(A, B: TEntity): TEntity;

TBinary = class(TEntity)
private
  FAType: TClassEntity;
  FBType: TClassEntity;
  FFunc: TBinaryFunc;
  FComm: Boolean;
public
  Procedure SetFields(AType, BType: TClassEntity; 
	              Func: TBinaryFunc; 
		      Comm: Boolean);
  Function Call(A, B: TEntity): TEntity;
end;

implementation

//
//  TBinary
//
Procedure TBinary.SetFields;
begin
  FAType := AType;
  FBType := BType;
  FFunc := Func;
  FComm := Comm;
end;

Function TBinary.Call(A, B: TEntity): TEntity;
begin
  Result := Nil;
    If (A is FAType) And (B is FBType) then begin
      Result := FFunc(A, B);
    end;
    If FComm then
      If (B is FAType) And (A is FBType) then begin
        Result := FFunc(B, A);
      end;
end;

end.
