unit DParser;

interface

Type
TArrayOfString = Array Of String;

Function DeleteLeftSpaces(S: String): String;
Function DeleteRightSpaces(S: String): String;
Function StringDeletePre(S: String; Count: Integer): String;
Function StringDeletePost(S: String; Start: Integer): String;

// S = List[0] B List[1] B ... B List[n-1]
Procedure ParseList(S: String; B: String; Var List: TArrayOfString);
// S = LBR
Procedure ParseBinary(S, B: String; Var L, R: String);

implementation

Function DeleteLeftSpaces(S: String): String;
begin
  Result := S;
    While (Length(Result) > 0) And (Result[1] in [#0..#32]) do
      Delete(Result, 1, 1);
end;

Function DeleteRightSpaces(S: String): String;
begin
  Result := S;
    While (Length(Result) > 0) And (Result[Length(Result)] in [#0..#32]) do
      Delete(Result, Length(Result), 1);
end;

Function StringDeletePre(S: String; Count: Integer): String;
begin
  Result := S;
    If Count = 0 then
      Exit;
  Delete(Result, 1, Count);
end;

Function StringDeletePost(S: String; Start: Integer): String;
begin
  Result := S;
    If Start = 0 then
      Exit;
  Delete(Result, Start, Length(Result) - Start + 1);
end;

Procedure ParseList(S: String; B: String; Var List: TArrayOfString);
begin
  SetLength(List, 1);
    While Pos(B, S) <> 0 do begin
      //List[High(List)] := StringDeletePost(S, Pos(B, S));
      //S := StringDeletePre(S, Pos(B, S) + Length(B) - 1);
      //SetLength(List, Length(List) + 1);
      ParseBinary(S, B, List[High(List)], S);
      SetLength(List, Length(List) + 1);
    end;
  List[High(List)] := S;
end;

Procedure ParseBinary(S, B: String; Var L, R: String);
begin
  L := StringDeletePost(S, Pos(B, S));
  R := StringDeletePre(S, Pos(B, S) + Length(B) - 1);
end;

end.
