unit DImage;

interface

Uses
  DUtils,
  DDebug,
  DCore;

Type
//TImageFormat = (ifRGB, ifRGBA);

TImageRGBA = Array[0..3] Of Byte;

TImage = class
private
  FTexels: Array Of Array Of TImageRGBA;
  FWidth, FHeight: Integer;
public
  Procedure SetTexel(X, Y: Integer; Texel: TImageRGBA);
  Procedure SetRed(X, Y: Integer; Red: Byte);
  Procedure SetGreen(X, Y: Integer; Green: Byte);
  Procedure SetBlue(X, Y: Integer; Blue: Byte);
  Procedure SetAlpha(X, Y: Integer; Alpha: Byte);
  Function GerTexel(X, Y: Integer): TImageRGBA;
  Function GetRed(X, Y: Integer): Byte;
  Function GetGreen(X, Y: Integer): Byte;
  Function GetBlue(X, Y: Integer): Byte;
  Function GetAlpha(X, Y: Integer): Byte;
  //Procedure SetFormat(Format: TImageFormat)  
  Procedure SetSize(Width, Height: Cardinal);
  Procedure Copy(I: TImage);
  Procedure SelfAdd(I: TImage);
  Procedure SelfMul(I: TImage);
  Procedure Add(A, B: TImage);
  Procedure Mul(A, B: TImage);
  Procedure SelfMulColor(Color: TImageColor);
  Procedure MakeGradient(Color1, Color2: TImageRGBA; Hor: Boolean = False);
  Procedure MakeCheckboard(CellWidth, CellHeight: Integer; 
                           Color1, Color2: TImageRGBA);
  Property Width: Cardinal read FWidth;
  Property Height: Cardinal read FHeight;
  Property Texels[I1, I2: Integer]: TImageRGBA read GetTexel write SetTexel;
  Property Red   [I1, I2: Integer]: Byte       read GetRed   write SetRed;
  Property Green [I1, I2: Integer]: Byte       read GetGreen write SetGreen;
  Property Blue  [I1, I2: Integer]: Byte       read GetBlue  write SetBlue;
  Property Alpha [I1, I2: Integer]: Byte       read GetAlpha write SetAlpha;
end;

Function RGBA(R, G, B, A: Byte): TImageRGB;
Function RGBAf(R, G, B, A: Single): TImageRGB;

implementation

Function RGBA(R, G, B, A: Byte): TImageRGB;
begin
  Result[0] := R;
  Result[1] := G;
  Result[2] := B;
  Result[3] := A;
end;

Function RGBAf(R, G, B, A: Single): TImageRGB;
begin
  Result := RGBA(Round(R*255), Round(G*255), Round(B*255), Round(A*255));
end;

//
//  TImage
//
Procedure TImage.SetTexel(X, Y: Integer; Texel: TImageRGBA);
begin
  FTexels[X][Y] := Texel;
end;

Procedure TImage.SetRed(X, Y: Integer; Red: Byte);
begin
  FTexels[X][Y][0] := Red;
end;

Procedure TImage.SetGreen(X, Y: Integer; Green: Byte);
begin
  FTexels[X][Y][1] := Green;
end;

Procedure TImage.SetBlue(X, Y: Integer; Blue: Byte);
begin
end;

Procedure TImage.SetAlpha(X, Y: Integer; Alpha: Byte);
begin
end;

Function TImage.GetTexel(X, Y: Integer): TImageRGBA;
begin
end;

Function TImage.GetRed(X, Y: Integer): Byte;
begin
end;

Function TImage.GetGreen(X, Y: Integer): Byte;
begin
end;

Function TImage.GetBlue(X, Y: Integer): Byte;
begin
end;

Function TImage.GetAlpha(X, Y: Integer): Byte;
begin
end;

Procedure TImage.SetSize(Width, Height: Cardinal);
begin
  FWidth := Width;
  FHeight := Height;
  SetLength(FTexels, Width, Height);
end;

Procedure TImage.Copy(I: TImage);
  Var
    X, Y: Integer;
begin
  SetSize(I.Width, I.Height);

end;

Procedure TImage.SelfAdd(I: TImage);
begin
end;

Procedure TImage.SelfMul(I: TImage);
begin
end;

Procedure TImage.Add(A, B: TImage);
begin
end;

Procedure TImage.Mul(A, B: TImage);
begin
end;

Procedure TImage.SelfMulColor(Color: TImageColor);
begin
end;

Procedure TImage.MakeGradient(Color1, Color2: TImageRGBA; Hor: Boolean = False);
begin
end;

Procedure TImage.MakeCheckboard(CellWidth, CellHeight: Integer; 
                           Color1, Color2: TImageRGBA);
begin
end;

end.
