unit GBlock;

interface

Uses
  DUtils,
  DDebug,
  DCore,

  MCore,

  GCore,
  GEvents;

implementation

Type
TBlock = class(TGameDecorator)
private
  FBody: TMathBody;
public
  Constructor Create(Owner: TEntity); override;
  Destructor Destroy; override;
  Procedure Update; override;
  Procedure Render; override;
  Procedure OnEvent(Event: TEvent); override;
end;

Constructor TBlock.Create(Owner: TEntity);
begin
  Inherited Create(Owner);
  FBody := TCircle.Create(Self);
end;

Destructor TBlock.Destroy;
begin
  FBody.Free;
  Inherited Destroy;
end;

Procedure TBlock.Update;
begin
  // TODO: update position
end;

Procedure TBlock.Render; 
begin
  // TODO: render
end;

Procedure TBlock.OnEvent(Event: TEvent);
begin
  Inherited OnEvent(Event);
    If Event.IsType('TEvReqMathBody') then 
      TEvReqMathBody(Event).Body := FBody;
end;

initialization
  Factory.RegistClass(TBlock);
end.
