unit GCircloids;

interface

Uses
  DUtils,
  DDebug,
  DCore,
  DMath,

  MCore,

  GCore,
  GEvents,
  GObjectForm;

implementation

//
//  TCicloidForm
//
Type
TCicloidForm = class(TObjectForm)
protected
  Procedure CreateBody; override; 
end;

Procedure TSubmForm.CreateBody;
begin
  FBody := TRect.Create(Self);
  TRect(FBody).A := Sub2D(Vec2D(160, 120), Vec2D(5, 5));
  TRect(FBody).B := Add2D(Vec2D(160, 120), Vec2D(5, 5));
end;

//
//  TCicloidRender
//
Type
TCicloidRender = class(TGameDecorator)
private
  R, G, B: Single;
public
  Constructor Create(Owner: TEntity); override;
  Procedure Render; override;
end;

Constructor TCicloidRender.Create(Owner: TEntity);
begin
  Inherited Create(Owner);
  R := 0.75;
  G := 0.75;
  B := 0.0;
end;

Procedure TCicloidRender.Render;
  Var
    ReqPos: TEvReqPos;
begin
  Inherited Render;
  ReqPos := TEvReqPos.Create(Self);
  Decoratable.SendEvent(ReqPos);
  glColor3f(0, 0, 0);
    With ReqPos.Pos do  
      glRectf(X-5, Y-5, X+5, Y+5);
  glColor3f(1, 1, 1);
end;

initialization
  Factory.RegistClass(TCicloidForm);
  Factory.RegistClass(TCicloidRender);
end.
