unit GEvents;

interface

Uses
  DDebug,
  DUtils,
  DMath,
  DCore,
  
  MCore,
  MCollider;

Type
TEvCollided = class(TEvent)
private
  FCol: TCollision;
  FEnt: TEntity;
public
  Constructor Create(Sender: TEntity; Col: TCollision; Ent: TEntity);
  Property Col: TCollision read FCol;
  Property Ent: TEntity read FEnt;
end;

TEvAddMathBody = class(TEvent)
private
  FBody: TMathBody;
public
  Constructor Create(Sender: TEntity; Body: TMathBody);
  Property Body: TMathBody read FBody;
end;

TEvReqMathBody = class(TEvent)
private
  FBody: TMathBody;
public
  Constructor Create(Sender: TEntity);
  Property Body: TMathBody read FBody write FBody;
end;

TEvSetPos = class(TEvent)
private
  FPos: TVec2D;
public
  Constructor Create(Sender: TEntity; Pos: TVec2D);
  Property Pos: TVec2D read FPos;
end;

TEvReqPos = class(TEvent)
private
  FPos: TVec2D;
public
  Property Pos: TVec2D read FPos write FPos;
end;

TEvReqVel = class(TEvent)
private
  FVel: TVec2D;
public
  Property Vel: TVec2D read FVel write FVel;
end;

TEvSetVel = class(TEvent)
private
  FVel: TVec2D;
public
  Constructor Create(Sender: TEntity; Vel: TVec2D);
  Property Vel: TVec2D read FVel;
end;

TEvLineBreaked = class(TEvent)
end;

TEvDamage = class(TEvent)
private
  FDamage: Single;
public
  Constructor Create(Sender: TEntity; Damage: Single);
  Property Damage: Single read FDamage;
end;

TEvPhysStep = class(TEvent)
end;

TEvKilled = class(TEvent)
end;

TEvReqHp = class(TEvent)
private
  FHp: Double;
  FMax: Double;
public
  Property Hp: Double read FHp write FHp;
  Property Max: Double read FMax write FMax;
end;

TEvReqLineLen = class(TEvent)
private
  FLen: Double;
  FMax: Double;
public
  Property Len: Double read FLen write FLen;
  Property Max: Double read FMax write FMax;
end;

TEvGameOver = class(TEvent)
end;

TEvGameWin = class(TEvent)
end;

implementation

//
//  TEvCollided
//
Constructor TEvCollided.Create(Sender: TEntity; Col: TCollision; Ent: TEntity);
begin
  Inherited Create(Sender);
  FCol := Col;
  FEnt := Ent;
end;

//
//  TEvAddMathBody
//
Constructor TEvAddMathBody.Create(Sender: TEntity; Body: TMathBody);
begin
  Inherited Create(Sender);
  FBody := Body;
end;

//
//  TEvReqMathBody
//
Constructor TEvReqMathBody.Create(Sender: TEntity);
begin
  Inherited Create(Sender);
end;

//
//  TEvSetPos
//
Constructor TEvSetPos.Create(Sender: TEntity; Pos: TVec2D);
begin
  Inherited Create(Sender);
  FPos := Pos;
end;

//
//  TEvReqVel
//
Constructor TEvSetVel.Create(Sender: TEntity; Vel: TVec2D);
begin
  Inherited Create(Sender);
  FVel := Vel;
end;

//
//  TEvDamage
//
Constructor TEvDamage.Create(Sender: TEntity; Damage: Single);
begin
  Inherited Create(Sender);
  FDamage := Damage;
end;

end.
