unit GObjectForm;

interface

Uses
  DUtils,
  DDebug,
  DCore,
  DMath,

  MCore,

  GCore,
  GEvents;


Type
TObjectForm = class(TGameDecorator)
protected
  FBody: TMathBody2D;
  Procedure CreateBody; virtual;
  Function GetPosition: TVec2D;
public
  Constructor Create(Owner: TEntity); override;
  Destructor Destroy; override;
  Procedure Update; override;
  Procedure Render; override;
  Procedure OnEvent(Event: TEvent); override;
end;

implementation

Procedure TObjectForm.CreateBody;
begin
end;

Function TObjectForm.GetPosition: TVec2D;
  Var
    ReqPos: TEvReqPos;
begin
  ReqPos := TEvReqPos.Create(Self);
  Decoratable.SendEvent(ReqPos);
  Result := ReqPos.Pos;
  ReqPos.Free;
end;

Constructor TObjectForm.Create(Owner: TEntity);
begin
  Inherited Create(Owner);
  CreateBody;
  //FBody := TCircle.Create(Self);
end;

Destructor TObjectForm.Destroy;
begin
  FBody.Free;
  Inherited Destroy;
end;

Procedure TObjectForm.Update;
  Var
    ReqPos: TEvReqPos;
begin
  Inherited Update;
  ReqPos := TEvReqPos.Create(Self);
  Decoratable.SendEvent(ReqPos);
  FBody.SetPos(ReqPos.Pos);
  ReqPos.Free;
end;

Procedure TObjectForm.Render; 
begin
  Inherited Render;
  // TODO: render
end;

Procedure TObjectForm.OnEvent(Event: TEvent);
begin
  Inherited OnEvent(Event);
    If Event.IsType('TEvReqMathBody') then 
      TEvReqMathBody(Event).Body := FBody;
end;

initialization
  //Factory.RegistClass(TObjectForm);
end.
