unit RText;

interface

Uses
  DDebug,
  DUtils,
  DCore,
  DMath,
  DParser,

  MCore,
  MCurve,
  MCollider,

  Windows,
  dglOpenGL,
  DWinApi;

Function CreateFont(Width, Height: Integer; Face: PChar): Integer; cdecl;
Procedure DeleteFont(Font: Integer); cdecl;
Procedure DrawText(Font, X, Y: Integer; Text: PChar); cdecl;

implementation

Function CreateFont;
  Var 
    font, old : HFont;
begin
  Result := glGenLists(256);
  font := Windows.CreateFont(height, width, 0, 0, 0, 0, 0, 0, 
                     RUSSIAN_CHARSET, 
                     OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                     ANTIALIASED_QUALITY, 
                     FW_BOLD or FF_DONTCARE or DEFAULT_PITCH, 
                     PChar(Face));
  SelectObject(DC, font);
  wglUseFontBitmaps(DC, 0, 256, Result);
  DeleteObject(font);
  Log.PrintLn('Created Font "' + Face + '" ' + IntToStr(Width) + 'x' + IntToStr(Height)
              + ' ' + IntToStr(Result));
end;

Procedure DeleteFont;
begin
  glDeleteLists(Font, 256);
end;

Procedure DrawText;
begin
  glRasterPos3f( x, y, 0 );
  glPushAttrib( GL_LIST_BIT );
  glListBase( font );
  glCallLists( length( text ), GL_UNSIGNED_BYTE, PChar( text ) );
  glPopAttrib;
end;

end.
