program beetles_on_sky;

uses
  Omega, OmegaPNG,
  u_Init in 'u_Init.pas',
  u_Game in 'u_Game.pas',
  u_Menu in 'u_Menu.pas';

procedure Main;
  begin
    case Scene of
      sMenu : Menu_Process;
      sGame : Game_Process;
      sDone : Done_Process;
      sLogo : Logo_Process;
    end;
  end;

  procedure Init;
  begin
    Scene := sLogo;
    AllInit;
  end;

  procedure Paint;
  begin
    case Scene of
      sMenu : Menu_Paint;
      sGame : Game_Paint;
      sDone : Done_Paint;
      sLogo : Logo_Paint;
    end;
  end;

  procedure Exit;
  begin

  end;

  begin
    LoadOMEGA('Omega.dll');
    Main_Timer := Timer_Create (@Main, 5);
    OE_REGPROCEDURE(SYS_DRAW, @Paint);
    OE_REGPROCEDURE(SYS_QUIT, @EXIT);
    OE_REGPROCEDURE(SYS_INIT, @INIT);
    OE_SetScreenOptions(600, 400, 32, 0, FALSE, FALSE);
    OE_ShowCursor(FALSE);
    OE_INIT;
  end.
