unit u_Game;

interface
uses
  Omega;

type
  TScene = ( sGame, sMenu, sDone, sLogo );

type
  PPoint = record
    Point: OEPoint;
    Enable: Boolean;
  end;

type
  PBeetle = record
    X,Y: Single;
    T: PTexture;
    F,S: Byte;
    Z,A,A2,AA: Integer;
    C: OECircle;
    S2,D,FF: Boolean;
  end;

type
  PFigure = record
    Points: array[0..99] of OEPoint;
    E: array[0..99] of boolean;
    Lines: array[0..98] of OELine;
    Done: Boolean;
    Color: Integer;
    Point_count: Integer;
  end;

var
  Pop: PSound;
  Beetles: array[0..50]of PBeetle;
  Figure: PFigure;
  Point_Count, Alpha, NC, NC2, Wi, Status: Integer;
  C1,C2,C3,C4: Byte;
  Gr, Re, Ph, Ye: Boolean;
  Scene: TScene;
  Main_Timer: POTimer;
  procedure Game_Process;
  procedure Done_Process;
  procedure Game_Paint;
  procedure Done_Paint;

implementation
uses
  u_Init, u_Menu;

procedure Done_Process;
begin
  Button_Process( @BMenu );
  if Mouse_Click( M_LBUTTON ) then
  begin
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BMenu.Rect ) then Scene := sMenu;
  end;
end;

procedure Done_Paint;
begin
  SSprite_Draw( Back, 0, 0, 600, 400, 255, 0, 1 );
  ASprite_Draw( winlose, 200, 120, 200, 60, status,255, 0, 1 );
  Button_Paint( @BMenu );
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
end;

procedure Game_Process;
var
i, j, r: integer;
begin
  for i := 0 to 49 do
  begin
    if beetles[i].D = False then
    begin
      if beetles[i].F = 1 then C1 := C1 + 1;
      if beetles[i].F = 2 then C2 := C2 + 1;
      if beetles[i].F = 3 then C3 := C3 + 1;
      if beetles[i].F = 4 then C4 := C4 + 1;
    end;
  end;
  if (C1 = 1) or (C2 = 1) or (C3 = 1) or (C4 = 1) then
  begin
    Status := 2;
    Scene := sDone;
  end;
  C1 := 0;
  C2 := 0;
  C3 := 0;
  C4 := 0;
  for i := 0 to 49 do
  begin
    if beetles[i].D then Wi := Wi + 1;
  end;
  if Wi = 50 then
  begin
    Status := 1;
    Scene := sDone;
  end;
  Wi := 0;
  {if key_press(k_enter)then
  begin
    status := 1;
    Scene := sDone;
  end;}
  for i := 0 to 49 do
  begin
    if Key_press(k_escape) then scene := smenu;
    if beetles[i].FF then
    begin
      beetles[i].AA := beetles[i].AA - 5;
      beetles[i].S := beetles[i].S + 1;
    end;
    if beetles[i].AA <= 0 then beetles[i].D := true;
    beetles[i].Z := beetles[i].Z-1;
    if beetles[i].Z = 0 then
    begin
      beetles[i].A2 := beetles[i].A2+random(360);
      beetles[i].Z := random(1000);
    end;
    if beetles[i].A > beetles[i].A2 then beetles[i].A := beetles[i].A - 1;
    if beetles[i].A < beetles[i].A2 then beetles[i].A := beetles[i].A + 1;
    beetles[i].X := beetles[i].X + M_Cos(beetles[i].A)*0.4;
    beetles[i].Y := beetles[i].Y + M_Sin(beetles[i].A)*0.4;
    beetles[i].C.cX := beetles[i].X+15;
    beetles[i].C.cY := beetles[i].Y+15;
    beetles[i].C.Radius := 10;
    if (beetles[i].y)<-beetles[i].S then beetles[i].y := 400;
    if (beetles[i].X)<-beetles[i].S then beetles[i].X := 600;
    if beetles[i].y > 400 then beetles[i].Y := 0-beetles[i].S;
    if beetles[i].x > 600 then beetles[i].x := 0-beetles[i].S;
    //if beetles[i].S2 then beetles[i].S := 40 else beetles[i].S := 30;
  end;

  for i := 0 to figure.Point_count-1 do
  for j := 0 to 49 do
  begin
    if Col_LineVsCircle(@figure.lines[i],@beetles[j].C) then
    begin
      if Mouse_Down(M_LBUTTON)then
      begin
        if beetles[j].d = false then
        begin
          beetles[j].S2 := true;
        end;
      end;
    end;
  end;
  if point_count = 99 then
  begin
    for i := 0 to 99 do
    begin
      figure.E[i] := false;
      figure.Points[i].X := -100;
      figure.Points[i].Y := -100;
    end;
    figure.point_count := point_count;
    figure.done := true;
    for i := 0 to 49 do
    begin
      if beetles[i].S2 then
      begin
        NC := NC + 1;
        case beetles[i].F of
          1:Ph := true;
          2:Re := true;
          3:Gr := true;
          4:Ye := true;
        end;
      end;
    end;
    if Ph then NC2 := NC2 + 1;
    if Re then NC2 := NC2 + 1;
    if Gr then NC2 := NC2 + 1;
    if Ye then NC2 := NC2 + 1;
    if NC > 1 then
    begin
      if NC2 = 1 then
      begin
        for i := 0 to 49 do
        begin
          if beetles[i].S2 then beetles[i].FF := true;
          Snd_Play(pop, 1, 3, 0, false);
        end;
      end;
    end;
    NC := 0;
    NC2 := 0;
    Ph := False;
    Gr := False;
    Re := False;
    Ye := False;
    for j := 0 to 49 do beetles[j].S2 := false;
    //point_count := 1;
  end;
  if point_count < 99 then
  begin
    if Mouse_Down( M_LBUTTON ) then
    begin
      if Mouse_Move then
      begin
        figure.Done := false;
        figure.color := $FFFFFF;
        figure.point_count := point_count;
        figure.points[point_count].x := mouse_x;
        figure.points[point_count].Y := mouse_y;
        figure.e[point_count] := true;
        figure.Point_count := point_count-1;
        //figure.points[point_count-1].enable := true;
        point_count := point_count + 1;
      end;
    end;
  end;

  for i := 0 to Point_count-1 do
  begin
    if figure.E[i] and figure.E[i+1] then
    begin
      figure.Lines[i].x0 := figure.points[i].X;
      figure.Lines[i].y0 := figure.points[i].Y;
      figure.Lines[i].x1 := figure.points[i+1].X;
      figure.Lines[i].y1 := figure.points[i+1].Y;
    end;
  end;

  if Mouse_Press( M_LBUTTON ) then
  begin
    for i := 0 to 99 do
    begin
      figure.E[i] := false;
      figure.Points[i].X := -100;
      figure.Points[i].Y := -100;
    end;
    for i := 0 to 49 do
    begin
      if beetles[i].S2 then
      begin
        NC := NC + 1;
        case beetles[i].F of
          1:Ph := true;
          2:Re := true;
          3:Gr := true;
          4:Ye := true;
        end;
      end;
    end;
    if Ph then NC2 := NC2 + 1;
    if Re then NC2 := NC2 + 1;
    if Gr then NC2 := NC2 + 1;
    if Ye then NC2 := NC2 + 1;
    if NC > 1 then
    begin
      if NC2 = 1 then
      begin
        for i := 0 to 49 do
        begin
          if beetles[i].S2 then beetles[i].FF := true;
          Snd_Play(pop, 1, 3, 0, false);
        end;
      end;
    end;
    NC := 0;
    NC2 := 0;
    Ph := False;
    Gr := False;
    Re := False;
    Ye := False;
    for j := 0 to 49 do beetles[j].S2 := false;
    figure.point_count := point_count;
    figure.done := true;
    point_count := 1;
   end;
end;

procedure Game_Paint;
var
i,j: integer;
begin
  SSprite_Draw( Back, 0, 0, 600, 400, 255, 0, 1 );
  for i := 0 to 100 do
  if figure.e[i] and figure.e[i+1] then
  Pr2D_Line( figure.points[i].X, figure.points[i].Y,
  figure.points[i+1].X, figure.points[i+1].Y,
  figure.color, 100, PR_SMOOTH );
  //for i := 0 to figure.Point_count -1 do
  //Pr2D_TLine(@figure.lines[i],$FFFFFF,255);
  //if figure.Done then
  //Pr2D_Polygon(figure.points, figure.Point_count-2, $FFFFFF, Alpha, PR_FILL );
  for i := 0 to 49 do
  begin
    if beetles[i].d = false then
    begin
      ASprite_Draw(beetles[i].T,beetles[i].X,beetles[i].Y,
      beetles[i].S,beetles[i].S,beetles[i].F,beetles[i].AA,beetles[i].A-270);
    end;
    //omega.Pr2D_TCircle(@beetles[i].c,$FFFFFF,255);
  end;
  omega.Pr2D_Rect(259,10,100-figure.Point_count-2,10,$FFFFFF,100,PR_FILL);
  omega.Pr2D_Rect(259,10,98,10,$FFFFFF,100,PR_DEFAULT);
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
end;

end.

