unit u_Menu;

interface
uses
  Omega;

type
  PButton = ^TButton;
  TButton = record
    Rect: OERect;
    Texture: PTexture;
    Frame, Frame1, Frame2: Integer;
    Visible: Boolean;
  end;

var
  Back, Title, Cursor, Logo, Beetle, Winlose: PTexture;
  Logo_count, Logo_alpha, Black_Alpha: Single;
  BStart, BQuit, BMenu, BBack, BNorm, BHard: TButton;
  procedure Menu_Process;
  procedure Logo_Process;
  procedure Menu_Paint;
  procedure Logo_Paint;
  procedure Button_Process( Button: PButton );
  procedure Button_Paint( Button: PButton );

implementation
uses
  u_Game, u_Init;

procedure Button_Process( Button: PButton );
begin
  if Button.Visible then
  begin
    if Col_PointInAABB( Mouse_X, Mouse_Y, @Button.Rect )
    then Button.Frame := Button.Frame2 else Button.Frame := Button.Frame1;
  end;
end;

procedure Button_Paint( Button: PButton );
begin
  if Button.Visible then
  begin
    ASprite_Draw( Button.Texture, Button.Rect.X, Button.Rect.Y,
    Button.Rect.Width, Button.Rect.Height, Button.Frame, 255, 0 );
  end;
end;

procedure Logo_Process;
var
r: integer;
begin
  logo_count := logo_count - 1;
  if logo_count <= 0 then
  begin
    logo_alpha := logo_alpha - 5;
  end;
  if logo_alpha <= 0 then
  begin
    Scene := sMenu;
    Black_Alpha := 255;
  end;
  if Key_Press( K_SPACE ) then logo_count := 0;
  if Key_Press( K_ENTER ) then logo_count := 0;
  if Key_Press( K_ESCAPE ) then logo_count := 0;
  if Mouse_Press( M_LBUTTON ) then logo_count := 0;
end;

procedure Logo_Paint;
begin
  SSprite_Draw( Logo, 100, 0, 400, 400, Round(logo_alpha) );
end;

procedure Menu_Process;
var
i,j: Integer;
begin
  if Black_Alpha > 0 then Black_Alpha := Black_Alpha - 5;
  if Key_Press( K_SPACE ) then OE_GETFPS;
  if Key_Press( K_ESCAPE ) then OE_Quit;
  Button_Process( @BStart );
  Button_Process( @BQuit );
  if Mouse_Click( M_LBUTTON ) then
  begin
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BStart.Rect ) then
    begin
      for i := 0 to 50 do
      begin
        beetles[i].T := Beetle;
        beetles[i].X := random(600);
        beetles[i].Y := random(400);
        beetles[i].F := random(4)+1;
        beetles[i].S := 30;
        beetles[i].A := random(255);
        beetles[i].Z := random(1000);
        beetles[i].AA := 255;
        beetles[i].D := false;
        beetles[i].FF := false;
        beetles[i].A2 := random(255);
      end;
      Scene := sGame;
    end;
    if Col_PointInAABB( Mouse_X, Mouse_Y, @BQuit.Rect ) then OE_Quit;
  end;
end;

procedure Menu_Paint;
var
i: Integer;
begin
  SSprite_Draw( Back, 0, 0, 600, 400, 255, 0, 1 );
  SSprite_Draw( Title, 155, 75, 290, 60 );
  Button_Paint( @BStart );
  Button_Paint( @BQuit );
  SSprite_Draw( Cursor, Mouse_X, Mouse_Y, 50, 50 );
  //ASprite_Draw( beetle, 10, 10, 30, 30, 1 );
  if Black_Alpha > 0 then Pr2D_Rect( 0, 0, 600, 400, $000000, Round(Black_Alpha), 1 );
end;

end.

