unit Main;

interface

uses     
  Windows,
  Messages,
  OpenGL,
  SysUtils,
  Global,
  Use_OpenGL,
  Use_Geom,
  Use_Landscape,
  Gen_Texture;

procedure TactTimer;
procedure Create_prog; 
procedure Kill_Prog;

implementation

procedure Add_Enemy(X,Y,A,S:single;Life,tip:integer);
Var i:integer;           {  -     }
begin
 for i:=0 to MaxE do
  if (Enemies[i].Life=0) then
  begin
   Enemies[i].Point.X:=X;
   Enemies[i].Point.Y:=Y;
   Enemies[i].angle:=A;
   Enemies[i].Speed:=S;
   Enemies[i].Life:=Life;
   Enemies[i].tip:=tip;
   break;
  end;
end;

procedure Drop_Enemy(lev:byte);{  }
begin
 Case Random(lev) of
  0:Add_Enemy(6+Random(20)/10,+Random(8)/2,180,0.1,10,0);{}
  1:Add_Enemy(6+Random(20)/10,-4-Random(12)/2,180,0.05,10,1);{}
  2:Add_Enemy(6+Random(20)/10,+Random(8)/2,180,0.12,10,2);   { }
  3:Add_Enemy(6+Random(20)/10,4-Random(16)/2,180,0.2,10,3);  {}
  4:Add_Enemy(6+Random(20)/10,-Random(8)/2,180,0.07,10,4);   {}
  5:Add_Enemy(6+Random(20)/10,-Random(16)/2,180,0.13,10,5);  { }
 end; {       -    }
end;

procedure Add_Boom(X,Y:single;R:byte;Life:integer);
Var i:integer;     {  -  }
begin              {         }
 for i:=0 to MaxB do
  if (Booms[i].Life=0) then
  begin
   Booms[i].Point.X:=X;
   Booms[i].Point.Y:=Y;
   Booms[i].Rad:=R;
   Booms[i].Life:=Life;
   break;
  end;
end;

procedure Move_Enemy;    { ,    }
Var i,x,y:integer;
begin
 if per>1 then per:=per-1   {    }
 else
 if Random(55)=0 then       {      55  }
  Drop_Enemy(6);
 for i:=0 to MaxE do        {     }
  if (Enemies[i].Life>0) then
  begin                    {    }
   Enemies[i].angle:=Enemies[i].angle+Head_Rotate(Enemies[i].angle,
    Get_A(Enemies[i].Point,Vector(-6.36,-1.7)),1);
   Enemies[i].Point:=plus(Enemies[i].Point,  {}
     Get_Vect(Enemies[i].angle,Enemies[i].Speed));
   if (Get_S(Enemies[i].Point,Vector(-6.36,-1.7))<Enemies[i].Speed) then
    begin             {   -  }
     Enemies[i].Life:=0;
     Life:=Life-1;
    end;
   X:=Round((Enemies[i].Point.X+KX)/Mash); {     }
   Y:=Round((Enemies[i].Point.Y+KY)/Mash);
   if (X>0) and (Y>0) and (X<MapX) and (Y<MapY) then
   Case Enemies[i].tip of    {,             -    }
    0:if (Map[x,y].tip=c_Rock) or (Map[x,y].tip=c_Dirt) then
       begin
        Enemies[i].Life:=0;
        Add_Boom(X,Y,20,20);
       end;{rocket}
    1:if (Map[x,y].tip=c_Air) then  {   -  }
       begin
        Enemies[i].Life:=0;
        Add_Boom(X,Y,15,20);
       end;{bur}
    2:if (Map[x,y].tip=c_Sand) or (Map[x,y].tip=c_Dirt) then
       begin
        Enemies[i].Life:=0;
        Add_Boom(X,Y,15,20);
       end;{blaster}
    3:if (Map[x,y].tip=c_Water) or (Map[x,y].tip=c_Dirt) then
       begin
        Enemies[i].Life:=0;
        Add_Boom(X,Y,15,20);
       end;{plasma}
    4:if (Map[x,y].tip=c_Sand) then    {     1  }
       begin
        Enemies[i].Life:=0;
        Add_Boom(X,Y,15,20);
       end else Add_Boom(X,Y,5,2);     {     }
       {superbur}
    5:if (Map[x,y].tip=c_Water) then
       begin
        Enemies[i].Life:=0;
        Add_Boom(X,Y,15,20);
       end else Add_Boom(X,Y,10,2);
       {superplasma}
   end;
  end;
end;

procedure Check_Keys;       { }
Var
  P:TPoint;                 
  zx,zy,MK:single;
  mp,i:integer;
begin
 GetCursorPos(P);    { }
 MX:=P.X;
 MY:=P.Y;
 MK:=0.294;
 DX:=trunc(MX*MK-4.5);
 DY:=MapY-trunc(MY*MK-22);
 CX:=trunc(MX*MK-4.5);
 CY:=trunc(MY*MK-22);           {     }
 If (CX<2) then CX:=2;
 If (CY<1) then CY:=1;
 If (CX>MapX-1) then CX:=MapX-1;
 If (CY>MapY-2) then CY:=MapY-2;
 CY:=MapY-CY;
 zx:=FX;
 zy:=FY;            {   }
 if (abs(CX-FX)>abs(CY-FY)) then mp:=abs(CX-FX)
   else mp:=abs(CY-FY);
 if (mp>0) and mbl then    {   }
 For i:=1 to mp+1 do
 begin               {    }
  zx:=zx-(FX-CX)/mp;
  zy:=zy-(FY-CY)/mp; {     ,}
  FX:=Round(zx);
  FY:=Round(zy);
  Put_Material(FX,FY);  {   22 }
 end else              { }
 if (mp>0) and mbr then {  }
 For i:=1 to mp+1 do
 begin
  zx:=zx-(FX-CX)/mp;    { }
  zy:=zy-(FY-CY)/mp;
  FX:=Round(zx);
  FY:=Round(zy);
  Get_Material(FX,FY);  {    22 }
 end;
 if (not mbl) and (not mbr) then
  begin              {  }
   clear_act;        {     }
   FX:=CX;           {   }
   FY:=CY;
  end;
 if key[27] then Kill_Prog; {Esc }
 if key[112] then begin key[112]:=false;FOOL:=not FOOL;end;{1 -   }
 if key[113] then         {2   - }
  Drop_Enemy(6);
 if key[114] then begin key[114]:=false; {3    }
  Gen_Tex(Fon,1024,1024,Random(4),0);end;
 { 1-4    }
 if key[49] then begin Gen_Tex(Fon,1024,1024,1,0); gen_level(0);key[49]:=false;end;
 if key[50] then begin Gen_Tex(Fon,1024,1024,0,0); gen_level(1);key[50]:=false;end;
 if key[51] then begin Gen_Tex(Fon,1024,1024,2,0); gen_level(2);key[51]:=false;end;
 if key[52] then begin Gen_Tex(Fon,1024,1024,3,0); gen_level(3);key[52]:=false;end;
end;

procedure Render;    {}
Var
  i,j:integer;
  procedure Set_Color(x,y:integer);  {     }
  begin
    Case Map[x,y].tip of
     c_Iron,c_Air:glColor4f(4,4,4,0);
     c_Rock:glColor4f(4,3,1,4);
     c_Dirt:glColor4f(1,5,1,5);
     c_Sand:glColor4f(5,5,1,5);
     c_Water:glColor4f(0,0,5,5);
    end;
  end;
begin
 glclear(GL_Color_Buffer_Bit xor GL_Depth_Buffer_Bit);  {}
 glLoadIdentity();     {}
 glPointSize(4);
{render}
 glEnable(GL_Texture_2d);
 glBindTexture(GL_Texture_2D,Fon);
 put_Sprite(0,0,0,14,10,5,5,5,5);   { }
 glBindTexture(GL_Texture_2D,Tex[0]);
 put_Sprite(-6.36,-1.7,1,1,1,5,5,5,5); { }
 glDisable(GL_Texture_2d);
 glColor4f(4,4,4,4);
 glBegin(GL_Quads);              {  ,  }
  glColor4f(4,3,1,4);
  glVertex2f(-6.5,4.6);glVertex2f(-6.5,4.8);
  glVertex2f(-6.5+RR*0.001,4.8);glVertex2f(-6.5+RR*0.001,4.6);
  glColor4f(1,5,1,5);
  glVertex2f(-6.5+RR*0.001,4.6);glVertex2f(-6.5+RR*0.001,4.8);
  glVertex2f(-6.5+RR*0.001+RD*0.001,4.8);glVertex2f(-6.5+RR*0.001+RD*0.001,4.6);
  glColor4f(5,5,1,5);
  glVertex2f(-6.5+RR*0.001+RD*0.001,4.6);glVertex2f(-6.5+RR*0.001+RD*0.001,4.8);
  glVertex2f(-6.5+RR*0.001+RD*0.001+RS*0.001,4.8);glVertex2f(-6.5+RR*0.001+RD*0.001+RS*0.001,4.6);
  glColor4f(0,0,5,5);
  glVertex2f(-6.5+RR*0.001+RD*0.001+RS*0.001,4.6);glVertex2f(-6.5+RR*0.001+RD*0.001+RS*0.001,4.8);
  glVertex2f(-6.5+RR*0.001+RD*0.001+RS*0.001+RW*0.001,4.8);glVertex2f(-6.5+RR*0.001+RD*0.001+RS*0.001+RW*0.001,4.6);
 glEnd;
 glBegin(GL_Quads);           {}
  glColor4f(4,4,4,4);
  glVertex2f(6.5,4.6);glVertex2f(6.5,4.8);
  glVertex2f(6.5-LIFE*0.1,4.8);glVertex2f(6.5-LIFE*0.1,4.6);
 glEnd;
 if FOOL then             {  -  ,  ,  }
 begin                    {    ,  - , }
  glBegin(GL_Points);
  for i:=1 to MapX do          {   }
   for j:=-10 to 0 do
    begin
     glNormal(1,0,0);
     glColor4f(4,3,1,4);
     glVertex2f(((i)*1)*Mash-KX,((j)*1)*Mash-KY);
    end;
  for i:=-20 to 1 do         {  }
   for j:=-10 to 60 do
    begin
     glNormal(1,0,0);
     glColor4f(4,3,1,4);
     glVertex2f(((i)*1)*Mash-KX,((j)*1)*Mash-KY);
    end;
  for i:=0 to MapX do        {  }
   for j:=0 to MapY do
    begin
     glNormal(1,0,0);
     Set_Color(i,j);
     glVertex2f(((i)*1)*Mash-KX,((j)*1)*Mash-KY);
    end;
  glend;
 end else                   { ,  }
 begin
  glBegin(GL_QUADS);
  glNormal(1,0,0);
  for i:=1 to MapX do
   for j:=-10 to 0 do
    begin
     glColor4f(4,3,1,4);
     glVertex2f(((i+1)*1)*Mash-KX,((j)*1)*Mash-KY);
     glVertex2f(((i+1)*1)*Mash-KX,((j+1)*1)*Mash-KY);
     glVertex2f(((i)*1)*Mash-KX,((j+1)*1)*Mash-KY);
     glVertex2f(((i)*1)*Mash-KX,((j)*1)*Mash-KY);
    end;
  for i:=-20 to 1 do
   for j:=-10 to 60 do
    begin
     glColor4f(4,3,1,4);
     glVertex2f(((i+1)*1)*Mash-KX,((j)*1)*Mash-KY);
     glVertex2f(((i+1)*1)*Mash-KX,((j+1)*1)*Mash-KY);
     glVertex2f(((i)*1)*Mash-KX,((j+1)*1)*Mash-KY);
     glVertex2f(((i)*1)*Mash-KX,((j)*1)*Mash-KY);
    end;
  for i:=0 to MapX do
   for j:=0 to MapY do
    begin
     Set_Color(i,j);
     glVertex2f(((i+1)*1)*Mash-KX,((j)*1)*Mash-KY);
     glVertex2f(((i+1)*1)*Mash-KX,((j+1)*1)*Mash-KY);
     glVertex2f(((i)*1)*Mash-KX,((j+1)*1)*Mash-KY);
     glVertex2f(((i)*1)*Mash-KX,((j)*1)*Mash-KY);
    end;
  glend;
 end;
 glEnable(GL_Texture_2d);   {  }
 For i:=0 to MaxE do
  if (Enemies[i].Life>0) then
   begin
    glBindTexture(GL_Texture_2D,Tex[Enemies[i].tip]);
    Put_Unit(Enemies[i].Point.X,Enemies[i].Point.Y,1,Enemies[i].angle,0.4);
   end;
 glDisable(GL_Texture_2d);
 glPointSize(8);
 glBegin(GL_Points);
 glColor4f(1,5,1,5);   {}
 glVertex2f(((DX)*1)*Mash-KX,((DY)*1)*Mash-KY);
 glEnd;
 glFlush();
 SwapBuffers(glhDC);
end;

procedure TactTimer;  { }
begin
 Check_Keys;    {    }
 Check_Phisycs; {   }
 Move_Enemy;    {  }
 Render;        {}
end;

procedure Create_prog;{ }
Var
  i,j:integer;
begin
 Mash:=0.042;       {}
 KX:=6;             { -      }
 KY:=4.75;
 ShowCursor(false);  { }
 glClearColor(1.0,1.0,1.0,0);
 enable_bind_tex;
 glShadeModel(GL_SMOOTH);
 {   }
 Gen_Tex(Tex[0],128,128,10,0);
 Gen_Tex(Tex[1],128,128,11,0);
 Gen_Tex(Tex[2],128,128,12,0);
 Gen_Tex(Tex[3],128,128,13,0);
 Gen_Tex(Tex[4],128,128,14,0);
 Gen_Tex(Tex[5],128,128,15,0);
 {generating}
 Gen_Font(glhDC);  {  ,       :(}
 glDisable(GL_Depth_Test);  {   }
 FX:=CX;
 FY:=CY;
 {}
 RF:=4000;                 {    }
 {level}
 Gen_Tex(Fon,1024,1024,1,0); {   }
 gen_level(0);
end;

procedure Kill_Prog;
begin
 ChangeDisplaySettings(devMode(nil^), 0);{ }
 KillTimer(0,TactH);     { }
 PostQuitMessage (0);
 ShowCursor(True);        { }
end;

end.
