//******************************************************************************
{  MikMod sound library
	(c) 1998, 1999, 2000, 2001 Miodrag Vallat and others - see file AUTHORS
	for complete list.

	This library is free software; you can redistribute it and/or modify
	it under the terms of the GNU Library General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Library General Public License for more details.
 
	You should have received a copy of the GNU Library General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA.   }
//*****************************************************************************/
//* Ported from C to Delphi by Khyron (Khyron@mbg-forum.de) in March 2004     */
//*****************************************************************************/
//                                                                            */
//*** By DEVIL  (devil_home@mail.ru) in February 2007 ->>                     */
//                                                                            */
//  - Linked into one main pas unit (+2 *.obj + 4 formats)                    */
//  - Some bugs and Memory Leaks fixed                                        */
//  - Wrapped (with MikMod object), some features                             */
//  - Correct copmiler options                                                */
//                                                                            */
//*****************************************************************************/
unit MikModEng;

interface
uses
  Windows, MMSystem;
  {$O+} {$R-} {$B-} {$T-} {$WARNINGS OFF} {$HINTS OFF}


type
TPersent = 0..100;

TMikMod = object
private
   Fmodule    : pointer;//PMODULE;
   curVolume  : integer;
   curTemp    : integer;
   FLoop      : boolean;

   function  GetVolume : TPersent;
   function  GetTemp   : TPersent;
   function  GetPaused ()   : boolean;
   function  GetPlaying()   : boolean;
   procedure SetVolume (Vol : TPersent);
   procedure SetTemp   (Tmp : TPersent);
   procedure SetPaused (B   : boolean);
   procedure SetPlaying(B   : boolean);
   procedure SetLoop   (B   : boolean);
   function  GetDefaultTemp() : TPersent;

   procedure Init;
public
   function  Load(FileName : string) : boolean; overload;
   function  Load(Instance: THandle; const ResName: string; ResType: PChar) : boolean; overload;
   function  Load(Mem : Pointer; MemSize : integer) : boolean; overload;
   procedure UnLoad();

   function  Play() : boolean;
   procedure Pause();
   procedure Stop();
   function  IsRewind() : boolean;

   property Playing : boolean  read GetPlaying write SetPlaying;
   property Loop    : boolean  read FLoop      write SetLoop   ;
   property Paused  : boolean  read GetPaused  write SetPaused ;
   property Volume  : TPersent read GetVolume  write SetVolume ;
   property Temp    : TPersent read GetTemp    write SetTemp   ;
   property DefaultTemp : TPersent read GetDefaultTemp;
end;

var  MikMod : ^TMikMod;

//******************************************************************************
//******************************************************************************
//********   - -->>>  ****************************************

function memcmp(const buf1, buf2: Pointer; len: integer): Integer;
function memset(buf: Pointer; c: Integer; len: integer): Pointer;
function strncmp(const str1, str2: PChar; len: integer): Integer;
function memcpy(dst: Pointer; const src: Pointer; len: integer): Pointer; 
function strcpy(dst: PChar; const src: PChar): PChar;
function strlen(const str1: PChar): integer;
function isalnum(c: Integer): integer;
function isdigit(c: Integer): integer;
function _mm_malloc(size: integer): Pointer;
function _mm_calloc(nb_blocs, size: integer): Pointer;
function  AllocPositions(total: integer): integer;//BOOL;
function  AllocPatterns(): integer;//BOOL;
function  AllocTracks(): integer;//BOOL;
function  AllocInstruments(): integer;//BOOL;
function  AllocSamples(): integer;//BOOL;
function  AllocLinear(): PInteger;
procedure FreeLinear();
function  speed_to_finetune(speed: cardinal; sample: integer): integer;
function  ReadComment(len: WORD): integer;//BOOL;
procedure S3MIT_ProcessCmd(cmd: BYTE; inf: BYTE; flags: cardinal);
procedure S3MIT_CreateOrders(curious: integer);
function  Trim(const S: string): string;
procedure UniEffect(eff: WORD; dat: WORD);
procedure UniReset();
procedure UniWriteByte(data: BYTE);
procedure UniNewline();
function  UniDup(): PBYTE; 
procedure UniInstrument(dat: BYTE);
procedure UniNote(dat: BYTE);
procedure UniPTEffect(eff: BYTE; dat: BYTE);
procedure UniVolEffect(eff: WORD; dat: BYTE);
function InlineIf(cond: Boolean; retvaltrue, retvalfalse: cardinal): cardinal; Overload;
function InlineIf(cond: Boolean; retvaltrue, retvalfalse: integer): integer; Overload;
function InlineIf(cond: Boolean; retvaltrue, retvalfalse: BYTE): BYTE; Overload;
function InlineIf(cond: Boolean; retvaltrue, retvalfalse: WORD): WORD; Overload;
function InlineIf(cond: Boolean; retvaltrue, retvalfalse: smallint): smallint; Overload;
function InlineIf(cond: Boolean; retvaltrue, retvalfalse: int64): int64; Overload;

type
  TInternalStreamObj = object
  private
     FSize : integer;
     Start : integer;
     Current : integer;
     Maximum : integer;
     procedure SetPosition(P : integer);
     function  GetPosition : integer;
  public
    procedure Init(Mem : Pointer; MemSize, Pos : integer);
    function  Read(var Buffer; Count: Longint): Longint;
    property  Position : integer read GetPosition write SetPosition;
    property  Size : integer read FSize;
  end;
  TInternalStream = ^TInternalStreamObj;

  TMLInit = function(): integer;
  TMLTest = function(): integer;
  TMLLoad = function(b: integer): integer;
  TMLCleanup = procedure();
  TMLLoadTitle = function(): PCHAR;
  
  PMLOADER_ = ^MLOADER_;
  MLOADER_ = record
    next: PMLOADER_;
    _type: PCHAR;
    version: PCHAR;
    Init: TMLInit;
    Test: TMLTest;
    Load: TMLLoad;
    Cleanup: TMLCleanup;
    LoadTitle: TMLLoadTitle;
  end;

procedure _mm_registerloader(ldr: PMLOADER_);
function _mm_read_UBYTE(fstrm: TInternalStream{TStream}): byte;//UBYTE;
function _mm_read_I_UWORD(fstrm: TInternalStream{TStream}): WORD;
function _mm_read_M_UWORD(fstrm: TInternalStream{TStream}): WORD;
function _mm_read_I_ULONG(reader: TInternalStream{TStream}): cardinal;
function _mm_read_UBYTES(buf: PBYTE; len: integer; fstrm: TInternalStream{TStream}): integer;//BOOL;
function _mm_read_I_UWORDS(buffer: PWORD; number: integer; fstrm: TInternalStream{TStream}): integer;
function _mm_read_SBYTE(fstrm: TInternalStream{TStream}): shortint;

  // ========== Platform independent-type definitions

type
  SBYTE = shortint;
  UBYTE = byte;
  SWORD = smallint;
  UWORD = word;
  SLONG = integer;
  ULONG = cardinal;
  BOOL = integer;
  SLONGLONG = int64;

  SBYTEARRAY = array[0..$EFFFFFF] of SBYTE;
  PSBYTEARRAY = ^SBYTEARRAY;

  PSBYTE = ^SBYTE;

  UBYTEARRAY = array[0..$EFFFFFF] of UBYTE;
  PUBYTEARRAY = ^UBYTEARRAY;

  PUBYTE = ^UBYTE;
  PPUBYTE = ^PUBYTE;

  SWORDARRAY = array[0..$EFFFFFF] of SWORD;
  PSWORDARRAY = ^SWORDARRAY;

  PSWORD = ^SWORD;

  UWORDARRAY = array[0..$EFFFFFF] of UWORD;
  PUWORDARRAY = ^UWORDARRAY;

  PUWORD = ^UWORD;

  SLONGARRAY = array[0..$EFFFFFF] of SLONG;
  PSLONGARRAY = ^SLONGARRAY;

  PSLONG = ^SLONG;

  ULONGARRAY = array[0..$EFFFFFF] of ULONG;
  PULONGARRAY = ^ULONGARRAY;

  PULONG = ^ULONG;

  FILTER = record
    filter, inf: UBYTE;
  end;

  ENVPT = record
    pos: SWORD;
    val: SWORD;
  end;
  PENVPT = ^ENVPT;

  ENVPTARRAY = array[0..$EFFFFF] of ENVPT;
  PENVPTARRAY = ^ENVPTARRAY;

  PINSTRUMENT = ^INSTRUMENT;
  INSTRUMENT = record
    insname: PCHAR;

    flags: UBYTE;
    samplenumber: array[0..120{INSTNOTES} - 1] of UWORD;
    samplenote: array[0..120{INSTNOTES} - 1] of UBYTE;

    nnatype: UBYTE;
    dca: UBYTE;                         // duplicate check action
    dct: UBYTE;                         // duplicate check type
    globvol: UBYTE;
    volfade: UWORD;
    panning: SWORD;                     //  instrument - based panning var

    pitpansep: UBYTE;                   // pitch pan separation(0 to 255)
    pitpancenter: UBYTE;                // pitch pan center(0 to 119)
    rvolvar: UBYTE;                     // random volume varations(0 - 100 %)
    rpanvar: UBYTE;                     // random panning varations(0 - 100 %)

    // volume envelope
    volflg: UBYTE;                      // bit 0       : on 1: sustain 2: loop
    volpts: UBYTE;
    volsusbeg: UBYTE;
    volsusend: UBYTE;
    volbeg: UBYTE;
    volend: UBYTE;
    volenv: array[0..32{ENVPOINTS} - 1] of ENVPT;
    // panning envelope
    panflg: UBYTE;                      // bit 0: on 1: sustain 2: loop
    panpts: UBYTE;
    pansusbeg: UBYTE;
    pansusend: UBYTE;
    panbeg: UBYTE;
    panend: UBYTE;
    panenv: array[0..32{ENVPOINTS} - 1] of ENVPT;
    //pitch envelope
    pitflg: UBYTE;
    // bit 0: on 1: sustain 2: loop
    pitpts: UBYTE;
    pitsusbeg: UBYTE;
    pitsusend: UBYTE;
    pitbeg: UBYTE;
    pitend: UBYTE;
    pitenv: array[0..32{ENVPOINTS} - 1] of ENVPT;
  end;

  INSTRUMENTARRAY = array[0..$EFFFF] of INSTRUMENT;
  PINSTRUMENTARRAY = ^INSTRUMENTARRAY;

  PSAMPLE = ^SAMPLE;
  SAMPLE = record
    panning: SWORD;                     // panning (0-255 or PAN_SURROUND)
    speed: ULONG;                       // Base playing speed/frequency of note
    volume: UBYTE;                      // volume 0-64
    inflags: UWORD;                     // sample format on disk
    flags: UWORD;                       // sample format in memory
    length: ULONG;                      // length of sample (in samples!)
    loopstart: ULONG;                   // repeat position (relative to start, in samples)
    loopend: ULONG;                     // repeat end
    susbegin: ULONG;                    // sustain loop begin (in samples) \  Not Supported
    susend: ULONG;                      // sustain loop end                /      Yet!

    // Variables used by the module player only! (ignored for sound effects)
    globvol: UBYTE;                     // global volume
    vibflags: UBYTE;                    // autovibrato flag stuffs
    vibtype: UBYTE;                     // Vibratos moved from INSTRUMENT to SAMPLE
    vibsweep: UBYTE;
    vibdepth: UBYTE;
    vibrate: UBYTE;
    samplename: PCHAR;                  // name of the sample

    // Values used internally only
    avibpos: UWORD;                     // autovibrato pos [player use]
    divfactor: UBYTE;                   // for sample scaling, maintains proper period slides
    seekpos: ULONG;                     // seek position in file
    handle: SWORD;                      // sample handle used by individual drivers
  end;

  SAMPLEARRAY = array[0..$EFFFF] of SAMPLE;
  PSAMPLEARRAY = ^SAMPLEARRAY;

  MP_CHANNEL = record
    i: PINSTRUMENT;
    s: PSAMPLE;
    sample: UBYTE;                      //* which sample number */
    note: UBYTE;                        //* the audible note as heard, direct rep of period */
    outvolume: SWORD;                   //* output volume (vol + sampcol + instvol) */
    chanvol: SBYTE;                     //* channel's "global" volume */
    fadevol: UWORD;                     //* fading volume rate */
    panning: SWORD;                     //* panning position */
    kick: UBYTE;                        //* if true = sample has to be restarted */
    period: UWORD;                      //* period to play the sample at */
    nna: UBYTE;                         //* New note action type + master/slave flags */

    volflg: UBYTE;                      //* volume envelope settings */
    panflg: UBYTE;                      //* panning envelope settings */
    pitflg: UBYTE;                      //* pitch envelope settings */

    keyoff: UBYTE;                      //* if true = fade out and stuff */
    handle: SWORD;                      //* which sample-handle */
    notedelay: UBYTE;                   //* (used for note delay) */
    start: SLONG;                       //* The starting byte index in the sample */
  end;

  MP_CHANNELARRAY = array[0..$EFFFF] of MP_CHANNEL;
  PMP_CHANNELARRAY = ^MP_CHANNELARRAY;

  PMP_VOICE = ^MP_VOICE;

  PMP_CONTROL = ^MP_CONTROL;
  MP_CONTROL = record
    main: MP_CHANNEL;

    slave: PMP_VOICE;                   //* Audio Slave of current effects control channel */

    slavechn: UBYTE;                    //* Audio Slave of current effects control channel */
    muted: UBYTE;                       //* if set, channel not played */
    ultoffset: UWORD;                   //* fine sample offset memory */
    anote: UBYTE;                       //* the note that indexes the audible */
    oldnote: UBYTE;
    ownper: SWORD;
    ownvol: SWORD;
    dca: UBYTE;                         //* duplicate check action */
    dct: UBYTE;                         //* duplicate check type */
    row: PUBYTE;                        //* row currently playing on this channel */
    retrig: SBYTE;                      //* retrig value (0 means don't retrig) */
    speed: ULONG;                       //* what finetune to use */
    volume: SWORD;                      //* amiga volume (0 t/m 64) to play the sample at */

    tmpvolume: SWORD;                   //* tmp volume */
    tmpperiod: UWORD;                   //* tmp period */
    wantedperiod: UWORD;                //* period to slide to (with effect 3 or 5) */

    arpmem: UBYTE;                      //* arpeggio command memory */
    pansspd: UBYTE;                     //* panslide speed */
    slidespeed: UWORD;
    portspeed: UWORD;                   //* noteslide speed (toneportamento) */

    s3mtremor: UBYTE;                   //* s3m tremor (effect I) counter */
    s3mtronof: UBYTE;                   //* s3m tremor ontime/offtime */
    s3mvolslide: UBYTE;                 //* last used volslide */
    sliding: SBYTE;
    s3mrtgspeed: UBYTE;                 //* last used retrig speed */
    s3mrtgslide: UBYTE;                 //* last used retrig slide */

    glissando: UBYTE;                   //* glissando (0 means off) */
    wavecontrol: UBYTE;

    vibpos: SBYTE;                      //* current vibrato position */
    vibspd: UBYTE;                      //* "" speed */
    vibdepth: UBYTE;                    //* "" depth */

    trmpos: SBYTE;                      //* current tremolo position */
    trmspd: UBYTE;                      //* "" speed */
    trmdepth: UBYTE;                    //* "" depth */

    fslideupspd: UBYTE;
    fslidednspd: UBYTE;
    fportupspd: UBYTE;                  //* fx E1 (extra fine portamento up) data */
    fportdnspd: UBYTE;                  //* fx E2 (extra fine portamento dn) data */
    ffportupspd: UBYTE;                 //* fx X1 (extra fine portamento up) data */
    ffportdnspd: UBYTE;                 //* fx X2 (extra fine portamento dn) data */

    hioffset: ULONG;                    //* last used high order of sample offset */
    soffset: UWORD;                     //* last used low order of sample-offset (effect 9) */

    sseffect: UBYTE;                    //* last used Sxx effect */
    ssdata: UBYTE;                      //* last used Sxx data info */
    chanvolslide: UBYTE;                //* last used channel volume slide */

    panbwave: UBYTE;                    //* current panbrello waveform */
    panbpos: UBYTE;                     //* current panbrello position */
    panbspd: SBYTE;                     //* "" speed */
    panbdepth: UBYTE;                   //* "" depth */

    newsamp: UWORD;                     //* set to 1 upon a sample / inst change */
    voleffect: UBYTE;                   //* Volume Column Effect Memory as used by IT */
    voldata: UBYTE;                     //* Volume Column Data Memory */

    pat_reppos: SWORD;                  //* patternloop position */
    pat_repcnt: UWORD;                  //* times to loop */
  end;

  MP_CONTROLARRAY = array[0..$EFFFF] of MP_CONTROL;
  PMP_CONTROLARRAY = ^MP_CONTROLARRAY;

  PENVPR = ^ENVPR;
  ENVPR = record
    flg: UBYTE;                         //* envelope flag */
    pts: UBYTE;                         //* number of envelope points */
    susbeg: UBYTE;                      //* envelope sustain index begin */
    susend: UBYTE;                      //* envelope sustain index end */
    beg: UBYTE;                         //* envelope loop begin */
    _end: UBYTE;                        //* envelope loop end */
    p: SWORD;                           //* current envelope counter */
    a: UWORD;                           //* envelope index a */
    b: UWORD;                           //* envelope index b */
    env: PENVPT;                        //* envelope points */
  end;

  ENVPRARRAY = array[0..$EFFFF] of ENVPR;
  PENVPRARRAY = ^ENVPRARRAY;

  MP_VOICE = record
    main: MP_CHANNEL;

    venv: ENVPR;
    penv: ENVPR;
    cenv: ENVPR;

    avibpos: UWORD;                     //* autovibrato pos */
    aswppos: UWORD;                     //* autovibrato sweep pos */

    totalvol: ULONG;                    //* total volume of channel (before global mixings) */

    mflag: BOOL;
    masterchn: SWORD;
    masterperiod: UWORD;

    master: PMP_CONTROL;                //* index of "master" effects channel */
  end;

  MP_VOICEARRAY = array[0..$EFFFF] of MP_VOICE;
  PMP_VOICEARRAY = ^MP_VOICEARRAY;

  PMODULE = ^MODULE;
  PMD = PMODULE;
  MODULE = record
    // general module information */
    songname: PCHAR;                    // name of the song
    modtype: PCHAR;                     // string type of module loaded
    comment: PCHAR;                     // module comments

    flags: UWORD;                       // See module flags above
    numchn: UBYTE;                      // number of module channels
    numvoices: UBYTE;                   // max # voices used for full NNA playback
    numpos: UWORD;                      // number of positions in this song
    numpat: UWORD;                      // number of patterns in this song
    numins: UWORD;                      // number of instruments
    numsmp: UWORD;                      // number of samples

    instruments: PINSTRUMENT;           //* all instruments */
    samples: PSAMPLE;                   //* all samples */

    realchn: UBYTE;                     // real number of channels used
    totalchn: UBYTE;                    // total number of channels used (incl NNAs)

    // playback settings
    reppos: UWORD;                      // restart position
    initspeed: UBYTE;                   // initial song speed
    inittempo: UWORD;                   // initial song tempo
    initvolume: UBYTE;                  // initial global volume (0 - 128)
    panning: array[0..64{UF_MAXCHAN} - 1] of UWORD; // panning positions
    chanvol: array[0..64{UF_MAXCHAN} - 1] of UBYTE; // channel positions

    bpm: UWORD;                         // current beats-per-minute speed
    sngspd: UWORD;                      // current song speed
    volume: SWORD;                      // song volume (0-128) (or user volume)

    extspd: BOOL;                       // extended speed flag (default enabled)
    panflag: BOOL;                      // panning flag (default enabled)
    wrap: BOOL;                         // wrap module ? (default disabled)
    loop: BOOL;                         // allow module to loop ? (default enabled)
    fadeout: BOOL;                      // volume fade out during last pattern

    patpos: UWORD;                      // current row number
    sngpos: SWORD;                      // current song position
    sngtime: ULONG;                     // current song time in 2^-10 seconds

    relspd: SWORD;                      // relative speed factor

    // internal module representation
    numtrk: UWORD;                      // number of tracks
    tracks: PPUBYTE;                    // array of numtrk pointers to tracks
    patterns: PUWORD;                   // array of Patterns
    pattrows: PUWORD;                   // array of number of rows for each pattern
    positions: PUWORD;                  // all positions

    forbid: BOOL;                       // if true, no player update!
    numrow: UWORD;                      // number of rows on current pattern
    vbtick: UWORD;                      // tick counter (counts from 0 to sngspd)
    sngremainder: UWORD;                // used for song time computation

    control: PMP_CONTROL;               // Effects Channel info (size pf->numchn)
    voice: PMP_VOICE;                   // Audio Voice information (size md_numchn)

    globalslide: UBYTE;                 // global volume slide rate
    pat_repcrazy: UBYTE;                // module has just looped to position -1
    patbrk: UWORD;                      // position where to start a new pattern
    patdly: UBYTE;                      // patterndelay counter (command memory)
    patdly2: UBYTE;                     // patterndelay counter (real one)
    posjmp: SWORD;                      // flag to indicate a jump is needed...
    bpmlimit: UWORD;                    // threshold to detect bpm or speed values
  end;

  MODULEARRAY = array[0..$EFFFF] of MODULE;
  PMODULEARRAY = ^MODULEARRAY;


var
  _of               : MODULE;
  modreader         : TInternalStream{TStream};
  poslookup         : PBYTE = nil;     //* lookup table for pattern jumps after blank
  origpositions     : PWORD = nil;
  _mm_errno         : byte;//MikMod_Errors;
  remap             : array[0..64{UF_MAXCHAN} - 1] of SBYTE; //* for removing empty channels */
  filtermacros      : array[0..$10{UF_MAXMACRO} - 1] of UBYTE; //* midi macro settings */
  filtersettings    : array[0..$100{UF_MAXFILTER} - 1] of FILTER; //* computed filter settings */
  filters           : BOOL;             //* resonant filters in use */
  activemacro       : UBYTE;            //* active midi macro number for Sxx,xx<80h */
  poslookupcnt      : UBYTE;
  noteindex         : PInteger = nil;   //* remap value for linear period modules */
  noteindexcount    : integer = 0;
  finetune          : array[0..15] of UWORD = (8363, 8413, 8463, 8529, 8581, 8651, 8723, 8757, 7895, 7941, 7985, 8046, 8107, 8169, 8232, 8280);
implementation


// ========== Library version
const
  LIBMIKMOD_VERSION_MAJOR = 3;
  LIBMIKMOD_VERSION_MINOR = 1;
  LIBMIKMOD_REVISION = 10;

  LIBMIKMOD_VERSION =
    (
    (LIBMIKMOD_VERSION_MAJOR shl 16) or
    (LIBMIKMOD_VERSION_MINOR shl 8) or
    (LIBMIKMOD_REVISION)
    );

  // ========== Error codes

  type
  MikMod_Errors =
    (MMERR_OPENING_FILE = 1,
    MMERR_OUT_OF_MEMORY,
    MMERR_DYNAMIC_LINKING,

    MMERR_SAMPLE_TOO_BIG,
    MMERR_OUT_OF_HANDLES,
    MMERR_UNKNOWN_WAVE_TYPE,

    MMERR_LOADING_PATTERN,{7}
    MMERR_LOADING_TRACK,
    MMERR_LOADING_HEADER,
    MMERR_LOADING_SAMPLEINFO,
    MMERR_NOT_A_MODULE,
    MMERR_NOT_A_STREAM,
    MMERR_MED_SYNTHSAMPLES,
    MMERR_ITPACK_INVALID_DATA,

    MMERR_DETECTING_DEVICE,
    MMERR_INVALID_DEVICE,
    MMERR_INITIALIZING_MIXER,
    MMERR_OPENING_AUDIO,
    MMERR_8BIT_ONLY,
    MMERR_16BIT_ONLY,
    MMERR_STEREO_ONLY,
    MMERR_ULAW,
    MMERR_NON_BLOCK,

    MMERR_AF_AUDIO_PORT,

    MMERR_AIX_CONFIG_INIT,
    MMERR_AIX_CONFIG_CONTROL,
    MMERR_AIX_CONFIG_START,

    MMERR_GUS_SETTINGS,
    MMERR_GUS_RESET,
    MMERR_GUS_TIMER,

    MMERR_HP_SETSAMPLESIZE,
    MMERR_HP_SETSPEED,
    MMERR_HP_CHANNELS,
    MMERR_HP_AUDIO_OUTPUT,
    MMERR_HP_AUDIO_DESC,
    MMERR_HP_BUFFERSIZE,

    MMERR_OSS_SETFRAGMENT,
    MMERR_OSS_SETSAMPLESIZE,
    MMERR_OSS_SETSTEREO,
    MMERR_OSS_SETSPEED,

    MMERR_SGI_SPEED,
    MMERR_SGI_16BIT,
    MMERR_SGI_8BIT,
    MMERR_SGI_STEREO,
    MMERR_SGI_MONO,

    MMERR_SUN_INIT,

    MMERR_OS2_MIXSETUP,
    MMERR_OS2_SEMAPHORE,
    MMERR_OS2_TIMER,
    MMERR_OS2_THREAD,

    MMERR_DS_PRIORITY,
    MMERR_DS_BUFFER,
    MMERR_DS_FORMAT,
    MMERR_DS_NOTIFY,
    MMERR_DS_EVENT,
    MMERR_DS_THREAD,
    MMERR_DS_UPDATE,

    MMERR_WINMM_HANDLE,
    MMERR_WINMM_ALLOCATED,
    MMERR_WINMM_DEVICEID,
    MMERR_WINMM_FORMAT,
    MMERR_WINMM_UNKNOWN,

    MMERR_MAC_SPEED,
    MMERR_MAC_START,

    MMERR_MAX);

const
  SFX_CRITICAL      = 1;

  // Sample format [loading and in-memory] flags:
  SF_16BITS         = $0001;
  SF_STEREO         = $0002;
  SF_SIGNED         = $0004;
  SF_BIG_ENDIAN     = $0008;
  SF_DELTA          = $0010;
  SF_ITPACKED       = $0020;

  SF_FORMATMASK     = $003F;

  // General Playback flags

  SF_LOOP           = $0100;
  SF_BIDI           = $0200;
  SF_REVERSE        = $0400;
  SF_SUSTAIN        = $0800;

  SF_PLAYBACKMASK   = $0C00;

  // Module-only Playback Flags

  SF_OWNPAN         = $1000;
  SF_UST_LOOP       = $2000;

  SF_EXTRAPLAYBACKMASK = $3000;

  // Panning constants
  PAN_LEFT          = 0;
  PAN_HALFLEFT      = 64;
  PAN_CENTER        = 128;
  PAN_HALFRIGHT     = 192;
  PAN_RIGHT         = 255;
  // panning value for Dolby Surround
  PAN_SURROUND      = 512;

  //	========== Internal module representation (UniMod)

  //	Instrument definition - for information only, the only field which may be
  //	of use in user programs is the name field

  // Instrument note count
const
  INSTNOTES         = 120;

  // Envelope point

  // Envelope point count
const
  ENVPOINTS         = 32;

  // Instrument structure


  // Used by NNA only player (audio control.  AUDTMP is used for full effects
  // control). */

  //Module definition

const

  // maximum master channels supported
  UF_MAXCHAN        = 64;

  // Module flags
  UF_XMPERIODS      = $0001;            // XM periods / finetuning
  UF_LINEAR         = $0002;            // LINEAR periods (UF_XMPERIODS must be set)
  UF_INST           = $0004;            // Instruments are used
  UF_NNA            = $0008;            // IT: NNA used, set numvoices rather than numchn
  UF_S3MSLIDES      = $0010;            // uses old S3M volume slides
  UF_BGSLIDES       = $0020;            // continue volume slides in the background
  UF_HIGHBPM        = $0040;            // MED: can use >255 bpm
  UF_NOWRAP         = $0080;            // XM-type (i.e. illogical) pattern break semantics
  UF_ARPMEM         = $0100;            // IT: need arpeggio memory */
  UF_FT2QUIRKS      = $0200;            // emulate some FT2 replay quirks */
  UF_PANNING        = $0400;            // module uses panning effects or have non-tracker default initial panning

  //  	========== Module loaders

const
  MUTE_EXCLUSIVE    = 32000;
  MUTE_INCLUSIVE    = 32001;

  //   	========== Drivers
type

  drvenum1 = (
    MD_MUSIC = 0,
    MD_SNDFX);

  drvenum2 = (
    MD_HARDWARE = 0,
    MD_SOFTWARE);

  // Mixing flags

const
  // These ones take effect only after MikMod_Init or MikMod_Reset
  DMODE_16BITS      = $0001;            // enable 16 bit output
  DMODE_STEREO      = $0002;            // enable stereo output
  DMODE_SOFT_SNDFX  = $0004;            // Process sound effects via software mixer
  DMODE_SOFT_MUSIC  = $0008;            // Process music via software mixer
  DMODE_HQMIXER     = $0010;            // Use high-quality (slower) software mixer
  // These take effect immediately.
  DMODE_SURROUND    = $0100;            // enable surround sound
  DMODE_INTERP      = $0200;            // enable interpolation
  DMODE_REVERSE     = $0400;            // reverse stereo

type
  PSAMPLOAD = ^SAMPLOAD;
  PPSAMPLOAD = ^PSAMPLOAD;
  SAMPLOAD = record
    next: PSAMPLOAD;
    length: ULONG;                      //* length of sample (in samples!) */
    loopstart: ULONG;                   //* repeat position (relative to start, in samples) */
    loopend: ULONG;                     //* repeat end */
    infmt: UWORD;
    outfmt: UWORD;
    scalefactor: integer;
    sample: PSAMPLE;
    reader: TInternalStream;//TStream;
  end;

  SAMPLOADARRAY = array[0..$EFFFF] of SAMPLOAD;
  PSAMPLOADARRAY = ^SAMPLOADARRAY;


  TMDCommandLine = procedure(cmd: PCHAR);
  TMDIsPresent = function(): BOOL;
  TMDSampleLoad = function(sl: PSAMPLOAD; i: integer): SWORD;
  TMDSampleUnload = procedure(sw: SWORD);
  TMDFreeSampleSpace = function(i: integer): ULONG;
  TMDRealSampleLength = function(i: integer; s: PSAMPLE): ULONG;
  TMDInit = function(): BOOL;
  TMDExit = procedure();
  TMDReset = function(): BOOL;
  TMDSetNumVoices = function(): BOOL;
  TMDPlayStart = function(): BOOL;
  TMDPlayStop = procedure();
  TMDUpdate = procedure();
  TMDPause = procedure();
  TMDVoiceSetVolume = procedure(ub: UBYTE; uw: UWORD);
  TMDVoiceGetVolume = function(ub: UBYTE): UWORD;
  TMDVoiceSetFrequency = procedure(ub: UBYTE; ul: ULONG);
  TMDVoiceGetFrequency = function(ub: UBYTE): ULONG;
  TMDVoiceSetPanning = procedure(ub: UBYTE; ul: ULONG);
  TMDVoiceGetPanning = function(ub: UBYTE): ULONG;
  TMDVoicePlay = procedure(ub: UBYTE; sw: SWORD; ul1, ul2, ul3, ul4: ULONG; uw: UWORD);
  TMDVoiceStop = procedure(ub: UBYTE);
  TMDVoiceStopped = function(ub: UBYTE): BOOL;
  TMDVoiceGetPosition = function(ub: UBYTE): SLONG;
  TMDVoiceRealVolume = function(ub: UBYTE): ULONG;

  PMDRIVER = ^MDRIVER;
  MDRIVER = record
    next: PMDRIVER;
    Name: PCHAR;
    Version: PCHAR;

    HardVoiceLimit: UBYTE;              // Limit of hardware mixer voices
    SoftVoiceLimit: UBYTE;              // Limit of software mixer voices

    Alias: PCHAR;

    CommandLine: TMDCommandLine;
    IsPresent: TMDIsPresent;
    SampleLoad: TMDSampleLoad;
    SampleUnload: TMDSampleUnload;
    FreeSampleSpace: TMDFreeSampleSpace;
    RealSampleLength: TMDRealSampleLength;
    Init: TMDInit;
    Exit: TMDExit;
    Reset: TMDReset;
    SetNumVoices: TMDSetNumVoices;
    PlayStart: TMDPlayStart;
    PlayStop: TMDPlayStop;
    Update: TMDUpdate;
    Pause: TMDPause;
    VoiceSetVolume: TMDVoiceSetVolume;
    VoiceGetVolume: TMDVoiceGetVolume;
    VoiceSetFrequency: TMDVoiceSetFrequency;
    VoiceGetFrequency: TMDVoiceGetFrequency;
    VoiceSetPanning: TMDVoiceSetPanning;
    VoiceGetPanning: TMDVoiceGetPanning;
    VoicePlay: TMDVoicePlay;
    VoiceStop: TMDVoiceStop;
    VoiceStopped: TMDVoiceStopped;
    VoiceGetPosition: TMDVoiceGetPosition;
    VoiceRealVolume: TMDVoiceRealVolume;
  end;

  MDRIVERARRAY = array[0..$EFFFF] of MDRIVER;
  PMDRIVERARRAY = ^MDRIVERARRAY;


var
  _mm_critical      : BOOL;

//*========== Samples */

// This is a handle of sorts attached to any sample registered with
//   SL_RegisterSample.  Generally, this only need be used or changed by the
//   loaders and drivers of mikmod. */

//========== Internal module representation (UniMod) interface */

// number of notes in an octave */
const
  OCTAVE            = 12;

  //*========== Module Commands */
type
  uni_fx = (
    // Simple note */
    UNI_NOTE = 1,
    // Instrument change */
    UNI_INSTRUMENT,
    // Protracker effects */
  {3}  UNI_PTEFFECT0,                      // arpeggio */
    UNI_PTEFFECT1,                      // porta up */
    UNI_PTEFFECT2,                      // porta down */
    UNI_PTEFFECT3,                      // porta to note */
    UNI_PTEFFECT4,                      // vibrato */
    UNI_PTEFFECT5,                      // dual effect 3+A */
    UNI_PTEFFECT6,                      // dual effect 4+A */
   {10} UNI_PTEFFECT7,                      // tremolo */
    UNI_PTEFFECT8,                      // pan */
    UNI_PTEFFECT9,                      // sample offset */
    UNI_PTEFFECTA,                      // volume slide */
    UNI_PTEFFECTB,                      // pattern jump */
    UNI_PTEFFECTC,                      // set volume */
    UNI_PTEFFECTD,                      // pattern break */
    UNI_PTEFFECTE,                      // extended effects */
    UNI_PTEFFECTF,                      // set speed */
    // Scream Tracker effects */
    UNI_S3MEFFECTA,                     // set speed */
    UNI_S3MEFFECTD,                     // volume slide */
    UNI_S3MEFFECTE,                     // porta down */
    UNI_S3MEFFECTF,                     // porta up */
    UNI_S3MEFFECTI,                     // tremor */
    UNI_S3MEFFECTQ,                     // retrig */
    UNI_S3MEFFECTR,                     // tremolo */
    UNI_S3MEFFECTT,                     // set tempo */
    UNI_S3MEFFECTU,                     // fine vibrato */
    UNI_KEYOFF,                         // note off */
    // Fast Tracker effects */
    UNI_KEYFADE,                        // note fade */
 {30}   UNI_VOLEFFECTS,                     // volume column effects */
    UNI_XMEFFECT4,                      // vibrato */
    UNI_XMEFFECT6,                      // dual effect 4+A */
    UNI_XMEFFECTA,                      // volume slide */
    UNI_XMEFFECTE1,                     // fine porta up */
    UNI_XMEFFECTE2,                     // fine porta down */
 {36}  UNI_XMEFFECTEA,                     // fine volume slide up */
    UNI_XMEFFECTEB,                     // fine volume slide down */
    UNI_XMEFFECTG,                      // set global volume */
    UNI_XMEFFECTH,                      // global volume slide */
    UNI_XMEFFECTL,                      // set envelope position */
    UNI_XMEFFECTP,                      // pan slide */
    UNI_XMEFFECTX1,                     // extra fine porta up */
  {43}  UNI_XMEFFECTX2,                     // extra fine porta down */
    // Impulse Tracker effects */
    UNI_ITEFFECTG,                      // porta to note */
    UNI_ITEFFECTH,                      // vibrato */
    UNI_ITEFFECTI,                      // tremor (xy not incremented) */
    UNI_ITEFFECTM,                      // set channel volume */
    UNI_ITEFFECTN,                      // slide / fineslide channel volume */
    UNI_ITEFFECTP,                      // slide / fineslide channel panning */
    UNI_ITEFFECTT,                      // slide tempo */
    UNI_ITEFFECTU,                      // fine vibrato */
    UNI_ITEFFECTW,                      // slide / fineslide global volume */
    UNI_ITEFFECTY,                      // panbrello */
    UNI_ITEFFECTZ,                      // resonant filters */
    UNI_ITEFFECTS0,
    // UltraTracker effects */
    UNI_ULTEFFECT9,                     // Sample fine offset */
    // OctaMED effects */
    UNI_MEDSPEED,
    UNI_MEDEFFECTF1,                    // play note twice */
    UNI_MEDEFFECTF2,                    // delay note */
    UNI_MEDEFFECTF3,                    // play note three times */
    // Oktalyzer effects */
    UNI_OKTARP,                         // arpeggio */

    UNI_LAST
    );

  //var
  //  unioperands       : array[0..ORD(UNI_LAST) - 1] of UWORD;

    //* IT / S3M Extended SS effects: */
type

  extsound_fx = (
    SS_GLISSANDO = 1,
    SS_FINETUNE,
    SS_VIBWAVE,
    SS_TREMWAVE,
    SS_PANWAVE,
    SS_FRAMEDELAY,
    SS_S7EFFECTS,
    SS_PANNING,
    SS_SURROUND,
    SS_HIOFFSET,
    SS_PATLOOP,
    SS_NOTECUT,
    SS_NOTEDELAY,
    SS_PATDELAY
    );

  //* IT Volume column effects */
  itcol_fx = (
    VOL_VOLUME = 1,
    VOL_PANNING, //2
    VOL_VOLSLIDE, //3
    VOL_PITCHSLIDEDN, //4
    VOL_PITCHSLIDEUP, // 5
    VOL_PORTAMENTO, //6
    VOL_VIBRATO  //7
    );

  //* IT resonant filter information */

const
  UF_MAXMACRO       = $10;
  UF_MAXFILTER      = $100;

  FILT_CUT          = $80;
  FILT_RESONANT     = $81;

  //*========== Instruments */

  //* Instrument format flags */
const
  IF_OWNPAN         = 1;
  IF_PITCHPAN       = 2;

  //* Envelope flags: */
  EF_ON             = 1;
  EF_SUSTAIN        = 2;
  EF_LOOP           = 4;
  EF_VOLENV         = 8;

  //* New Note Action Flags */
  NNA_CUT           = 0;
  NNA_CONTINUE      = 1;
  NNA_OFF           = 2;
  NNA_FADE          = 3;

  NNA_MASK          = 3;

  DCT_OFF           = 0;
  DCT_NOTE          = 1;
  DCT_SAMPLE        = 2;
  DCT_INST          = 3;

  DCA_CUT           = 0;
  DCA_OFF           = 1;
  DCA_FADE          = 2;

  KEY_KICK          = 0;
  KEY_OFF           = 1;
  KEY_FADE          = 2;
  KEY_KILL          = (KEY_OFF or KEY_FADE);

  KICK_ABSENT       = 0;
  KICK_NOTE         = 1;
  KICK_KEYOFF       = 2;
  KICK_ENV          = 4;

  AV_IT             = 1;                //* IT vs. XM vibrato info */

  //*========== Playing */

  POS_NONE          = (-2);             //* no loop position defined */

  LAST_PATTERN      = word(-1);         //* special ``end of song'' pattern */

  //*========== Loaders */

const
  //* flags for S3MIT_ProcessCmd */
  S3MIT_OLDSTYLE    = 1;                //* behave as old scream tracker */
  S3MIT_IT          = 2;                //* behave as impulse tracker */
  S3MIT_SCREAM      = 4;                //* enforce scream tracker specific limits */
  STM_NTRACKERS     = 3;

type
  TPlayer_Init = function(m: PMODULE): BOOL;
  TPlayer_Exit = procedure(m: PMODULE);
  TPlayer_HandleTick = procedure();

const
  MAXSAMPLEHANDLES  = 384;

type
  PMREADER = ^MREADER;
  PMWRITER = ^MWRITER;

  TMRSeek = function(mr: PMREADER; l: integer; i: integer): BOOL;
  TMRTell = function(mr: PMREADER): integer;
  TMRRead = function(mr: PMREADER; p: Pointer; size: integer): BOOL;
  TMRGet = function(mr: PMREADER): integer;
  TMREOF = function(mr: PMREADER): integer;

  MREADER = record
    Seek: TMRSeek;
    Tell: TMRTell;
    Read: TMRRead;
    Get: TMRGet;
    Eof: TMREOF;
  end;

  TMWSeek = function(mw: PMWRITER; l: integer; i: integer): BOOL;
  TMWTell = function(mw: PMWRITER): integer;
  TMWWrite = function(mw: PMWRITER; p: Pointer; size: integer): BOOL;
  TMWPut = function(mw: PMWRITER; i: integer): integer;

  MWRITER = record
    Seek: TMWSeek;
    Tell: TMWTell;
    Write: TMWWrite;
    Put: TMWPut;
  end;

var
  _mm_mutex_lists   : THandle;
  _mm_mutex_vars    : THandle;


var

  temp_iobase       : integer = 0;
  _mm_iobase        : integer = 0;

var

  STM_Signatures    : array[0..STM_NTRACKERS - 1] of PChar = (
    '!Scream!',
    'BMOD2STM',
    'WUZAMOD!'
    );

  STM_Version       : array[0..STM_NTRACKERS - 1] of PChar = (
    'Screamtracker 2',
    'Converted by MOD2STM (STM format)',
    'Wuzamod (STM format)'
    );

  //*========== Shared loader variables */

  //*========== Linear periods stuff */

const
  BUFPAGE           = 128;

var
  unioperands       : array[0..ORD(UNI_LAST) - 1] of UWORD = (
    0,                                  //* not used */
    1,                                  //* UNI_NOTE */
    1,                                  //* UNI_INSTRUMENT */
    1,                                  //* UNI_PTEFFECT0 */
    1,                                  //* UNI_PTEFFECT1 */
    1,                                  //* UNI_PTEFFECT2 */
    1,                                  //* UNI_PTEFFECT3 */
    1,                                  //* UNI_PTEFFECT4 */
    1,                                  //* UNI_PTEFFECT5 */
    1,                                  //* UNI_PTEFFECT6 */
    1,                                  //* UNI_PTEFFECT7 */
    1,                                  //* UNI_PTEFFECT8 */
    1,                                  //* UNI_PTEFFECT9 */
    1,                                  //* UNI_PTEFFECTA */
    1,                                  //* UNI_PTEFFECTB */
    1,                                  //* UNI_PTEFFECTC */
    1,                                  //* UNI_PTEFFECTD */
    1,                                  //* UNI_PTEFFECTE */
    1,                                  //* UNI_PTEFFECTF */
    1,                                  //* UNI_S3MEFFECTA */
    1,                                  //* UNI_S3MEFFECTD */
    1,                                  //* UNI_S3MEFFECTE */
    1,                                  //* UNI_S3MEFFECTF */
    1,                                  //* UNI_S3MEFFECTI */
    1,                                  //* UNI_S3MEFFECTQ */
    1,                                  //* UNI_S3MEFFECTR */
    1,                                  //* UNI_S3MEFFECTT */
    1,                                  //* UNI_S3MEFFECTU */
    0,                                  //* UNI_KEYOFF */
    1,                                  //* UNI_KEYFADE */
    2,                                  //* UNI_VOLEFFECTS */
    1,                                  //* UNI_XMEFFECT4 */
    1,                                  //* UNI_XMEFFECT6 */
    1,                                  //* UNI_XMEFFECTA */
    1,                                  //* UNI_XMEFFECTE1 */
    1,                                  //* UNI_XMEFFECTE2 */
    1,                                  //* UNI_XMEFFECTEA */
    1,                                  //* UNI_XMEFFECTEB */
    1,                                  //* UNI_XMEFFECTG */
    1,                                  //* UNI_XMEFFECTH */
    1,                                  //* UNI_XMEFFECTL */
    1,                                  //* UNI_XMEFFECTP */
    1,                                  //* UNI_XMEFFECTX1 */
    1,                                  //* UNI_XMEFFECTX2 */
    1,                                  //* UNI_ITEFFECTG */
    1,                                  //* UNI_ITEFFECTH */
    1,                                  //* UNI_ITEFFECTI */
    1,                                  //* UNI_ITEFFECTM */
    1,                                  //* UNI_ITEFFECTN */
    1,                                  //* UNI_ITEFFECTP */
    1,                                  //* UNI_ITEFFECTT */
    1,                                  //* UNI_ITEFFECTU */
    1,                                  //* UNI_ITEFFECTW */
    1,                                  //* UNI_ITEFFECTY */
    2,                                  //* UNI_ITEFFECTZ */
    1,                                  //* UNI_ITEFFECTS0 */
    2,                                  //* UNI_ULTEFFECT9 */
    2,                                  //* UNI_MEDSPEED */
    0,                                  //* UNI_MEDEFFECTF1 */
    0,                                  //* UNI_MEDEFFECTF2 */
    0,                                  //* UNI_MEDEFFECTF3 */
    2                                   //* UNI_OKTARP */
    );


//*========== Writing routines */

var
  rowstart          : PUBYTE;           //* startadress of a row */
  rowend            : PUBYTE;           //* endaddress of a row (exclusive) */
  rowpc             : PUBYTE;           //* current unimod(tm) programcounter */
  lastbyte          : UBYTE;            //* for UniSkipOpcode() */

var
  unibuf            : PUBYTE;           //* pointer to the temporary unitrk buffer */
  unimax            : UWORD;            //* buffer size */

  unipc             : UWORD;            //* buffer cursor */
  unitt             : UWORD;            //* current row index */
  lastp             : UWORD;            //* previous row index */

// from MLoader
var
  firstloader       : PMLOADER_ = nil;

var
  sl_rlength        : integer;
  sl_old            : SWORD;
  sl_buffer         : PSWORD = nil;
  musiclist         : PSAMPLOAD = nil;
  sndfxlist         : PSAMPLOAD = nil;

  //* size of the loader buffer in words */
const
  SLBUFSIZE         = 2048;

type
  //* IT-Compressed status structure */
  ITPACK = record
    bits: UWORD;                        //* current number of bits */
    bufbits: UWORD;                     //* bits in buffer */
    last: SWORD;                        //* last output */
    buf: UBYTE;                         //* bit buffer */
  end;
  PITPACK = ^ITPACK;


var
  firstdriver       : PMDRIVER = nil;
  md_driver         : PMDRIVER = nil;
 // pf                : PMODULE;          //* modfile being played */

  //* Initial global settings */

  md_device         : UWORD = 0;        //* autodetect */
  md_mixfreq        : UWORD = 44100;
  md_mode           : UWORD = DMODE_STEREO or DMODE_16BITS or
    DMODE_SURROUND or DMODE_SOFT_MUSIC or
    DMODE_SOFT_SNDFX;

  md_pansep         : UBYTE = 128;      //* 128 == 100% (full left/right) */
  md_reverb         : UBYTE = 0;        //* no reverb */
  md_volume         : UBYTE = 128;      //* global sound volume (0-128) */
  md_musicvolume    : UBYTE = 128;      //* volume of song */
  md_sndfxvolume    : UBYTE = 128;      //* volume of sound effects */
  md_bpm            : UWORD = 125;      //* tempo */

  //* Do not modify the numchn variables yourself!  use MD_SetVoices() */

  md_numchn         : UBYTE = 0;
  md_sngchn         : UBYTE = 0;
  md_sfxchn         : UBYTE = 0;
  md_hardchn        : UBYTE = 0;
  md_softchn        : UBYTE = 0;

  //void (*md_player)(void) = Player_HandleTick;

  md_player         : TPlayer_HandleTick;

  isplaying         : BOOL = 0;
  initialized       : BOOL = 0;
  sfxinfo           : PUBYTE;
  sfxpool           : integer;

  md_sample         : ^PSAMPLE = nil;

  //* Previous driver in use */
  olddevice         : SWORD = -1;

  // static vars

  firstcall         : integer = 1;

type
  PVINFO = ^VINFO;
  VINFO = record
    kick: UBYTE;                        //* =1 -> sample has to be restarted */
    active: UBYTE;                      //* =1 -> sample is playing */
    flags: UWORD;                       //* 16/8 bits looping/one-shot */
    handle: SWORD;                      //* identifies the sample */
    start: ULONG;                       //* start index */
    size: ULONG;                        //* samplesize */
    reppos: ULONG;                      //* loop start */
    repend: ULONG;                      //* loop end */
    frq: ULONG;                         //* current frequency */
    vol: integer;                       //* current volume */
    pan: integer;                       //* current panning position */

    click: integer;
    rampvol: integer;
    lastvalL: SLONG;
    lastvalR: SLONG;
    lvolsel: integer;
    rvolsel: integer;                   //* Volume factor in range 0-255 */
    oldlvol: integer;
    oldrvol: integer;

    current: SLONGLONG;                 //* current index in the sample */
    increment: SLONGLONG;               //* increment value */
  end;


var
  _drv_win          : MDRIVER;
  vinf              : PVINFO = nil;
  vc_memory         : integer = 0;
  vc_tickbuf        : PSLONG = nil;

var
  //* The currently playing module */
  pf2                : PMODULE = nil;

const
  HIGH_OCTAVE       = 2;                //* number of above-range octaves */
  LOGFAC            = 2 * 16;
  RAND_MAX          = 32767;

var
  oldperiods        : array[0..OCTAVE * 2 - 1] of UWORD = (
    $6B00, $6800, $6500, $6220, $5F50, $5C80,
    $5A00, $5740, $54D0, $5260, $5010, $4DC0,
    $4B90, $4960, $4750, $4540, $4350, $4160,
    $3F90, $3DC0, $3C10, $3A40, $38B0, $3700);

  VibratoTable      : array[0..32 - 1] of UBYTE = (
    0, 24, 49, 74, 97, 120, 141, 161, 180, 197, 212, 224, 235, 244, 250, 253,
    255, 253, 250, 244, 235, 224, 212, 197, 180, 161, 141, 120, 97, 74, 49, 24);

  avibtab           : array[0..128 - 1] of UBYTE = (
    0, 1, 3, 4, 6, 7, 9, 10, 12, 14, 15, 17, 18, 20, 21, 23,
    24, 25, 27, 28, 30, 31, 32, 34, 35, 36, 38, 39, 40, 41, 42, 44,
    45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 54, 55, 56, 57, 57, 58,
    59, 59, 60, 60, 61, 61, 62, 62, 62, 63, 63, 63, 63, 63, 63, 63,
    64, 63, 63, 63, 63, 63, 63, 63, 62, 62, 62, 61, 61, 60, 60, 59,
    59, 58, 57, 57, 56, 55, 54, 54, 53, 52, 51, 50, 49, 48, 47, 46,
    45, 44, 42, 41, 40, 39, 38, 36, 35, 34, 32, 31, 30, 28, 27, 25,
    24, 23, 21, 20, 18, 17, 15, 14, 12, 10, 9, 7, 6, 4, 3, 1);

  //* Triton's linear periods to frequency translation table (for XM modules) */
  lintab            : array[0..768 - 1] of ULONG = (
    535232, 534749, 534266, 533784, 533303, 532822, 532341, 531861,
    531381, 530902, 530423, 529944, 529466, 528988, 528511, 528034,
    527558, 527082, 526607, 526131, 525657, 525183, 524709, 524236,
    523763, 523290, 522818, 522346, 521875, 521404, 520934, 520464,
    519994, 519525, 519057, 518588, 518121, 517653, 517186, 516720,
    516253, 515788, 515322, 514858, 514393, 513929, 513465, 513002,
    512539, 512077, 511615, 511154, 510692, 510232, 509771, 509312,
    508852, 508393, 507934, 507476, 507018, 506561, 506104, 505647,
    505191, 504735, 504280, 503825, 503371, 502917, 502463, 502010,
    501557, 501104, 500652, 500201, 499749, 499298, 498848, 498398,
    497948, 497499, 497050, 496602, 496154, 495706, 495259, 494812,
    494366, 493920, 493474, 493029, 492585, 492140, 491696, 491253,
    490809, 490367, 489924, 489482, 489041, 488600, 488159, 487718,
    487278, 486839, 486400, 485961, 485522, 485084, 484647, 484210,
    483773, 483336, 482900, 482465, 482029, 481595, 481160, 480726,
    480292, 479859, 479426, 478994, 478562, 478130, 477699, 477268,
    476837, 476407, 475977, 475548, 475119, 474690, 474262, 473834,
    473407, 472979, 472553, 472126, 471701, 471275, 470850, 470425,
    470001, 469577, 469153, 468730, 468307, 467884, 467462, 467041,
    466619, 466198, 465778, 465358, 464938, 464518, 464099, 463681,
    463262, 462844, 462427, 462010, 461593, 461177, 460760, 460345,
    459930, 459515, 459100, 458686, 458272, 457859, 457446, 457033,
    456621, 456209, 455797, 455386, 454975, 454565, 454155, 453745,
    453336, 452927, 452518, 452110, 451702, 451294, 450887, 450481,
    450074, 449668, 449262, 448857, 448452, 448048, 447644, 447240,
    446836, 446433, 446030, 445628, 445226, 444824, 444423, 444022,
    443622, 443221, 442821, 442422, 442023, 441624, 441226, 440828,
    440430, 440033, 439636, 439239, 438843, 438447, 438051, 437656,
    437261, 436867, 436473, 436079, 435686, 435293, 434900, 434508,
    434116, 433724, 433333, 432942, 432551, 432161, 431771, 431382,
    430992, 430604, 430215, 429827, 429439, 429052, 428665, 428278,
    427892, 427506, 427120, 426735, 426350, 425965, 425581, 425197,
    424813, 424430, 424047, 423665, 423283, 422901, 422519, 422138,
    421757, 421377, 420997, 420617, 420237, 419858, 419479, 419101,
    418723, 418345, 417968, 417591, 417214, 416838, 416462, 416086,
    415711, 415336, 414961, 414586, 414212, 413839, 413465, 413092,
    412720, 412347, 411975, 411604, 411232, 410862, 410491, 410121,
    409751, 409381, 409012, 408643, 408274, 407906, 407538, 407170,
    406803, 406436, 406069, 405703, 405337, 404971, 404606, 404241,
    403876, 403512, 403148, 402784, 402421, 402058, 401695, 401333,
    400970, 400609, 400247, 399886, 399525, 399165, 398805, 398445,
    398086, 397727, 397368, 397009, 396651, 396293, 395936, 395579,
    395222, 394865, 394509, 394153, 393798, 393442, 393087, 392733,
    392378, 392024, 391671, 391317, 390964, 390612, 390259, 389907,
    389556, 389204, 388853, 388502, 388152, 387802, 387452, 387102,
    386753, 386404, 386056, 385707, 385359, 385012, 384664, 384317,
    383971, 383624, 383278, 382932, 382587, 382242, 381897, 381552,
    381208, 380864, 380521, 380177, 379834, 379492, 379149, 378807,
    378466, 378124, 377783, 377442, 377102, 376762, 376422, 376082,
    375743, 375404, 375065, 374727, 374389, 374051, 373714, 373377,
    373040, 372703, 372367, 372031, 371695, 371360, 371025, 370690,
    370356, 370022, 369688, 369355, 369021, 368688, 368356, 368023,
    367691, 367360, 367028, 366697, 366366, 366036, 365706, 365376,
    365046, 364717, 364388, 364059, 363731, 363403, 363075, 362747,
    362420, 362093, 361766, 361440, 361114, 360788, 360463, 360137,
    359813, 359488, 359164, 358840, 358516, 358193, 357869, 357547,
    357224, 356902, 356580, 356258, 355937, 355616, 355295, 354974,
    354654, 354334, 354014, 353695, 353376, 353057, 352739, 352420,
    352103, 351785, 351468, 351150, 350834, 350517, 350201, 349885,
    349569, 349254, 348939, 348624, 348310, 347995, 347682, 347368,
    347055, 346741, 346429, 346116, 345804, 345492, 345180, 344869,
    344558, 344247, 343936, 343626, 343316, 343006, 342697, 342388,
    342079, 341770, 341462, 341154, 340846, 340539, 340231, 339924,
    339618, 339311, 339005, 338700, 338394, 338089, 337784, 337479,
    337175, 336870, 336566, 336263, 335959, 335656, 335354, 335051,
    334749, 334447, 334145, 333844, 333542, 333242, 332941, 332641,
    332341, 332041, 331741, 331442, 331143, 330844, 330546, 330247,
    329950, 329652, 329355, 329057, 328761, 328464, 328168, 327872,
    327576, 327280, 326985, 326690, 326395, 326101, 325807, 325513,
    325219, 324926, 324633, 324340, 324047, 323755, 323463, 323171,
    322879, 322588, 322297, 322006, 321716, 321426, 321136, 320846,
    320557, 320267, 319978, 319690, 319401, 319113, 318825, 318538,
    318250, 317963, 317676, 317390, 317103, 316817, 316532, 316246,
    315961, 315676, 315391, 315106, 314822, 314538, 314254, 313971,
    313688, 313405, 313122, 312839, 312557, 312275, 311994, 311712,
    311431, 311150, 310869, 310589, 310309, 310029, 309749, 309470,
    309190, 308911, 308633, 308354, 308076, 307798, 307521, 307243,
    306966, 306689, 306412, 306136, 305860, 305584, 305308, 305033,
    304758, 304483, 304208, 303934, 303659, 303385, 303112, 302838,
    302565, 302292, 302019, 301747, 301475, 301203, 300931, 300660,
    300388, 300117, 299847, 299576, 299306, 299036, 298766, 298497,
    298227, 297958, 297689, 297421, 297153, 296884, 296617, 296349,
    296082, 295815, 295548, 295281, 295015, 294749, 294483, 294217,
    293952, 293686, 293421, 293157, 292892, 292628, 292364, 292100,
    291837, 291574, 291311, 291048, 290785, 290523, 290261, 289999,
    289737, 289476, 289215, 288954, 288693, 288433, 288173, 287913,
    287653, 287393, 287134, 286875, 286616, 286358, 286099, 285841,
    285583, 285326, 285068, 284811, 284554, 284298, 284041, 283785,
    283529, 283273, 283017, 282762, 282507, 282252, 281998, 281743,
    281489, 281235, 280981, 280728, 280475, 280222, 279969, 279716,
    279464, 279212, 278960, 278708, 278457, 278206, 277955, 277704,
    277453, 277203, 276953, 276703, 276453, 276204, 275955, 275706,
    275457, 275209, 274960, 274712, 274465, 274217, 273970, 273722,
    273476, 273229, 272982, 272736, 272490, 272244, 271999, 271753,
    271508, 271263, 271018, 270774, 270530, 270286, 270042, 269798,
    269555, 269312, 269069, 268826, 268583, 268341, 268099, 267857);

  logtab            : array[0..104 - 1] of UWORD = (
    LOGFAC * 907, LOGFAC * 900, LOGFAC * 894, LOGFAC * 887,
    LOGFAC * 881, LOGFAC * 875, LOGFAC * 868, LOGFAC * 862,
    LOGFAC * 856, LOGFAC * 850, LOGFAC * 844, LOGFAC * 838,
    LOGFAC * 832, LOGFAC * 826, LOGFAC * 820, LOGFAC * 814,
    LOGFAC * 808, LOGFAC * 802, LOGFAC * 796, LOGFAC * 791,
    LOGFAC * 785, LOGFAC * 779, LOGFAC * 774, LOGFAC * 768,
    LOGFAC * 762, LOGFAC * 757, LOGFAC * 752, LOGFAC * 746,
    LOGFAC * 741, LOGFAC * 736, LOGFAC * 730, LOGFAC * 725,
    LOGFAC * 720, LOGFAC * 715, LOGFAC * 709, LOGFAC * 704,
    LOGFAC * 699, LOGFAC * 694, LOGFAC * 689, LOGFAC * 684,
    LOGFAC * 678, LOGFAC * 675, LOGFAC * 670, LOGFAC * 665,
    LOGFAC * 660, LOGFAC * 655, LOGFAC * 651, LOGFAC * 646,
    LOGFAC * 640, LOGFAC * 636, LOGFAC * 632, LOGFAC * 628,
    LOGFAC * 623, LOGFAC * 619, LOGFAC * 614, LOGFAC * 610,
    LOGFAC * 604, LOGFAC * 601, LOGFAC * 597, LOGFAC * 592,
    LOGFAC * 588, LOGFAC * 584, LOGFAC * 580, LOGFAC * 575,
    LOGFAC * 570, LOGFAC * 567, LOGFAC * 563, LOGFAC * 559,
    LOGFAC * 555, LOGFAC * 551, LOGFAC * 547, LOGFAC * 543,
    LOGFAC * 538, LOGFAC * 535, LOGFAC * 532, LOGFAC * 528,
    LOGFAC * 524, LOGFAC * 520, LOGFAC * 516, LOGFAC * 513,
    LOGFAC * 508, LOGFAC * 505, LOGFAC * 502, LOGFAC * 498,
    LOGFAC * 494, LOGFAC * 491, LOGFAC * 487, LOGFAC * 484,
    LOGFAC * 480, LOGFAC * 477, LOGFAC * 474, LOGFAC * 470,
    LOGFAC * 467, LOGFAC * 463, LOGFAC * 460, LOGFAC * 457,
    LOGFAC * 453, LOGFAC * 450, LOGFAC * 447, LOGFAC * 443,
    LOGFAC * 440, LOGFAC * 437, LOGFAC * 434, LOGFAC * 431);

  PanbrelloTable    : array[0..256 - 1] of SBYTE = (
    0, 2, 3, 5, 6, 8, 9, 11, 12, 14, 16, 17, 19, 20, 22, 23,
    24, 26, 27, 29, 30, 32, 33, 34, 36, 37, 38, 39, 41, 42, 43, 44,
    45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 56, 57, 58, 59,
    59, 60, 60, 61, 61, 62, 62, 62, 63, 63, 63, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 63, 63, 63, 62, 62, 62, 61, 61, 60, 60,
    59, 59, 58, 57, 56, 56, 55, 54, 53, 52, 51, 50, 49, 48, 47, 46,
    45, 44, 43, 42, 41, 39, 38, 37, 36, 34, 33, 32, 30, 29, 27, 26,
    24, 23, 22, 20, 19, 17, 16, 14, 12, 11, 9, 8, 6, 5, 3, 2,
    0, -2, -3, -5, -6, -8, -9, -11, -12, -14, -16, -17, -19, -20, -22, -23,
    -24, -26, -27, -29, -30, -32, -33, -34, -36, -37, -38, -39, -41, -42, -43, -44,
    -45, -46, -47, -48, -49, -50, -51, -52, -53, -54, -55, -56, -56, -57, -58, -59,
    -59, -60, -60, -61, -61, -62, -62, -62, -63, -63, -63, -64, -64, -64, -64, -64,
    -64, -64, -64, -64, -64, -64, -63, -63, -63, -62, -62, -62, -61, -61, -60, -60,
    -59, -59, -58, -57, -56, -56, -55, -54, -53, -52, -51, -50, -49, -48, -47, -46,
    -45, -44, -43, -42, -41, -39, -38, -37, -36, -34, -33, -32, -30, -29, -27, -26,
    -24, -23, -22, -20, -19, -17, -16, -14, -12, -11, -9, -8, -6, -5, -3, -2);


var
raznTemp   : integer = 0;
raznVolume : integer = 0;

//******************************************************************************
//******************************************************************************
//******************************************************************************


function _mm_read_I_SWORD(fstrm: TInternalStream{TStream}): SWORD; forward;
function _mm_read_M_SWORD(fstrm: TInternalStream{TStream}): SWORD; forward;
function _mm_read_M_SWORDS(buffer: PSWORD; number: integer; fstrm: TInternalStream{TStream}): integer; forward;
function _mm_read_I_SWORDS(buffer: PSWORD; number: integer; fstrm: TInternalStream{TStream}): integer; forward;
procedure _mm_iobase_setcur(reader: TInternalStream{TStream}); forward;
procedure _mm_iobase_revert(); forward;
procedure _mm_rewind(reader: TInternalStream{TStream}); forward;

function __mm_read_UBYTE(pfstrm: TInternalStream{TStream}): UBYTE; cdecl;forward;
procedure MUTEX_LOCK(mutex: THandle); forward;
procedure MUTEX_UNLOCK(mutex: THandle); forward;

function calloc(nb_blocs, size: integer): Pointer; forward;
function malloc(size: integer): Pointer; forward;
procedure free(adr: Pointer); forward;
//function min(const a, b: Integer): Integer;
function Min(A, B : integer) : integer; forward;
function rand: Integer;forward;
function  UniInit(): BOOL; forward;
procedure UniCleanup(); forward;

procedure UniSetRow(t: PUBYTE); forward;        // Mglicherweise falsch
function  UniGetByte(): UBYTE;forward;
function  UniGetWord(): UWORD;forward;
procedure UniSkipOpcode();forward;
function  UniFindRow(t: PUBYTE; row: UWORD): PUBYTE; forward;

function  UniExpand(wanted: integer): BOOL; forward;
procedure UniWriteWord(data: UWORD); forward;
function  MyCmp(a, b: PUBYTE; l: UWORD): BOOL; forward;
function ML_LoadSamples(): BOOL; forward;

function  Player_Load(filename: PCHAR; maxchan: integer; curious: BOOL): PMODULE;forward;
function  Player_Load_CustomStream(stream: TInternalStream{TStream}; maxchan: integer; curious: BOOL): PMODULE; forward;
procedure Player_Free(mf: PMODULE); forward;
procedure Player_SetPosition(pos: UWORD); forward;

procedure SL_Sample16to8(s: PSAMPLOAD); forward;
procedure SL_HalveSample(s: PSAMPLOAD; factor: integer); forward;
procedure SL_SampleSigned(s: PSAMPLOAD); forward;
procedure SL_Sample8to16(s: PSAMPLOAD); forward;
function  SL_Load(buffer: Pointer; smp: PSAMPLOAD; length: ULONG): BOOL;forward;
function  SL_Init(s: PSAMPLOAD): BOOL; forward;
procedure SL_Exit(s: PSAMPLOAD);  forward;
procedure MikMod_Exit_internal();  forward;
function  MikMod_EnableOutput_internal(): BOOL;forward;
procedure MikMod_DisableOutput_internal(); forward;
function  MikMod_SetNumVoices_internal(music: integer; sfx: integer): BOOL; forward;
function  MikMod_Active(): BOOL; forward;
function  MikMod_EnableOutput(): BOOL; forward;
procedure MikMod_Update(); forward;
procedure MikMod_Exit(); forward;
function  InitializeMikModEngine : boolean;forward;

procedure MD_SampleUnload(handle: SWORD); forward;
function  MD_SampleSpace(_type: integer): ULONG; forward;
function  MD_SampleLoad(s: PSAMPLOAD; _type: integer): SWORD; forward;
function  MD_SampleLength(_type: integer; s: PSAMPLE): ULONG;forward;

function  Voice_Stopped_internal(voice: SBYTE): BOOL; forward;
procedure Voice_Play_internal(voice: SBYTE; s: PSAMPLE; start: ULONG); forward;
procedure Voice_SetVolume_internal(voice: SBYTE; vol: UWORD); forward;
procedure Voice_SetPanning_internal(voice: SBYTE; pan: ULONG); forward;
procedure Voice_Stop_internal(voice: SBYTE); forward;
procedure Voice_SetFrequency_internal(voice: SBYTE; frq: ULONG); forward;
procedure DoNNAEffects(_mod: PMODULE; a: PMP_CONTROL; dat: UBYTE); forward;
procedure Player_Stop_internal(); forward;
function  getfrequency(flags: UWORD; period: ULONG): ULONG; forward;
function  getlinearperiod(note: UWORD; fine: ULONG): UWORD; forward;

procedure Player_Start(_mod: PMODULE); forward;
procedure Player_Stop(); forward;
function  Player_Active(): BOOL; forward;
function  Player_Init(_mod: PMODULE): BOOL; forward;
procedure Player_HandleTick(); forward;
procedure Player_NextPosition(); forward;
procedure Player_PrevPosition(); forward;
procedure Player_Exit_internal(_mod: PMODULE);forward;
procedure Player_SetVolume(volume: SWORD); forward;
procedure Player_SetTempo(tempo: UWORD); forward;
procedure Player_SetSpeed(speed: UWORD); forward;
function  Player_Paused(): BOOL; forward;
procedure Player_TogglePause(); forward;



function Min(A, B : integer) : integer;
asm
   cmp eax, edx
   jle @ex
   mov eax, edx
   @ex:
end;

function  TInternalStreamObj.GetPosition : integer;
begin
   Result := Current - Start;
end;

procedure TInternalStreamObj.SetPosition(P : integer);
begin
  Current := Start + Min(Maximum-Start, P);
end;

procedure TInternalStreamObj.Init(Mem : Pointer; MemSize, Pos : integer);
begin
  Start := Integer(Mem);
  Maximum := Start + MemSize;
  Current := Start + Min(MemSize, Pos);
  FSize := MemSize;
end;

function  TInternalStreamObj.Read(var Buffer; Count: Longint): Longint;
begin
  Result := Min(Count, Maximum - Current);
  if Result <> 0 then begin
     CopyMemory(@Buffer, pointer(Current), Result);
     Inc(Current, Result);
  end;
end;

//******************************************************************************
//******************************************************************************
//******************************************************************************
var
  dwThreadId        : DWORD   = 0;
  player_hThread    : THANDLE = 0;
  bool_player_exit  : Boolean = true;
  RewindState       : Boolean = false;

//------------------------------------------------------------------------------
procedure UpdateSound();
begin
  while not bool_player_exit do
  begin
    if (Player_Active() <> 0) then MikMod_Update();
    Sleep(4);
  end;
end;
//------------------------------------------------------------------------------
procedure InitPlayThread();
begin
  if not bool_player_exit then exit;
    bool_player_exit := false;
    player_hThread := 0;
    dwThreadId := 0;
    player_hThread := CreateThread(nil, 0, @UpdateSound, nil, 0, dwThreadId);
    SetThreadPriority(player_hThread, THREAD_PRIORITY_TIME_CRITICAL);
end;
//------------------------------------------------------------------------------
procedure TerminatePlayThread();
var
  lpExitCode        : DWORD;
begin
  if     bool_player_exit then exit;
    bool_player_exit := true;
    GetExitCodeThread(player_hThread, lpExitCode);
    TerminateThread(player_hThread, lpExitCode);
end;
//******************************************************************************
//constructor TMikMod.Create;
procedure TMikMod.Init;
begin
  Fmodule   := nil;
  curVolume := 128*3 div 4; // 75%
  curTemp   := 0;
  FLoop     := false;
end;
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
procedure TMikMod.SetVolume(Vol : TPersent);
begin
  if Vol >= 100 then Vol := 100
  else
  if Vol <    0 then Vol := 0;

  curVolume := round(Vol/100*128);
  Player_SetVolume(curVolume);
  if fmodule <> nil then raznVolume := PMD(fmodule).Volume - PMD(fmodule).initVolume;
end;
//------------------------------------------------------------------------------
function  TMikMod.GetVolume : TPersent;
begin
  GetVolume := round(curVolume/128*100);
end;
//------------------------------------------------------------------------------
function  TMikMod.Play() : boolean;
begin
    Result := fmodule <> nil;

    if fmodule <> nil then
    begin
      Player_Start(fmodule);
      Player_SetVolume(CurVolume);
      SetLoop(FLoop);
      InitPlayThread();
    end;
end;
//------------------------------------------------------------------------------
function  TMikMod.Load(Mem : Pointer; MemSize : integer) : boolean;
var
  Stream : TInternalStreamObj;
begin
  UnLoad();
  Stream.Init(Mem, MemSize, 0);
  try
    fmodule := Player_Load_CustomStream(@Stream, 64, 0);
    if fmodule <> nil then CurTemp := PMD(fmodule).bpm else CurTemp := 0;
    Result := fmodule <> nil;
  except
    Result  := false;
    fmodule := nil;
  end;
end;
//------------------------------------------------------------------------------
function  TMikMod.Load(FileName : string) : boolean;
const
    Mb5 = 5*1024*1024;
var
   Mem : pointer;
   hFile, Size, Num : integer;
begin
   Result := false;

 hFile  := -1;
 hFile  := CreateFile(PChar(FileName), GENERIC_READ, 0, nil,
                     OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
 if hFile = INVALID_HANDLE_VALUE then EXIT;

 Size := SetFilePointer(THandle(hFile), 0, nil, 2);
 if Size < 20{?} then
 begin
    CloseHandle(hFile);
    EXIT;
 end;

 if Size > Mb5 then Size := Mb5;
 SetFilePointer(THandle(hFile), 0, nil, 0);
 Mem := nil;

 try
    GetMem(Mem, Size);
    if ReadFile(THandle(hFile), Mem^, Size, DWORD(Num), nil)
       then Result := Load(Mem, Size);
 finally
    CloseHandle(hFile);
    if Mem <> nil then FreeMem(Mem);
 end;

end;
//------------------------------------------------------------------------------
function  TMikMod.Load(Instance: THandle; const ResName: string; ResType: PChar) : boolean;
var
  ResPtr: PByte;
  ResSize: Longint;
  HResInfo: THandle;
  MemHandle: THandle;
begin
  Result := false;
  HResInfo := FindResource(Instance, pchar(ResName), ResType);
  if HResInfo = 0 then Exit;
  ResSize := SizeofResource(HInstance, HResInfo);
  if ResSize < 20 {?} then Exit;
  try
     MemHandle := LoadResource(Instance, HResInfo);
     ResPtr := LockResource(MemHandle);
     Result := Load(ResPtr, ResSize);
  finally
     UnLockResource(MemHandle);
     FreeResource(MemHandle);
  end;
end;
//------------------------------------------------------------------------------
procedure TMikMod.UnLoad();
begin
  if fmodule <> nil then
  begin
    TerminatePlayThread();
    Player_Stop();
    Player_Free(fmodule);
    fmodule := nil;
  end;
end;
//------------------------------------------------------------------------------
procedure TMikMod.Stop();
begin
  if fmodule <> nil then
  begin
    TerminatePlayThread();
    Player_SetPosition(0);
    Player_Stop();
  end;
end;
//------------------------------------------------------------------------------
procedure TMikMod.Pause();
begin
   if (fmodule <> nil) and (Player_Paused = 0) then begin
      Player_TogglePause();
      //Player_Stop();
   end;
end;
//------------------------------------------------------------------------------
const TempLen = 255-32;

function TMikMod.GetTemp   : TPersent;
begin
  GetTemp := round((CurTemp - 32)/TempLen*100)
end;
//------------------------------------------------------------------------------
procedure TMikMod.SetTemp  (Tmp    : TPersent);
begin
  if Tmp >= 100 then Tmp := 100
  else
  if Tmp <    0 then Tmp := 0;

  CurTemp := round(Tmp/100*TempLen)+32;
  Player_SetTempo(CurTemp);
  if fmodule <> nil then raznTemp := PMD(fmodule).bpm - PMD(fmodule).inittempo;
end;
//------------------------------------------------------------------------------
function TMikMod.GetDefaultTemp() : TPersent;
begin
 if (fmodule <> nil) then Result := round((PMD(fmodule).inittempo - 32)/TempLen*100)
 else Result := 0;
end;
//------------------------------------------------------------------------------
function  TMikMod.GetPaused () : boolean;
begin
  GetPaused := (Player_Paused <> 0);
end;
//------------------------------------------------------------------------------
function  TMikMod.GetPlaying() : boolean;
begin
  GetPlaying := (Player_Active() <> 0);
end;
//------------------------------------------------------------------------------
procedure TMikMod.SetPaused(B : boolean);
begin
  if B then Pause else
  begin
     if (Player_Paused <> 0) then Play;
  end;
end;
//------------------------------------------------------------------------------
procedure TMikMod.SetPlaying(B : boolean);
begin
  if B then Play else Pause;
end;
//------------------------------------------------------------------------------
procedure TMikMod.SetLoop   (B   : boolean);
begin
  FLoop := B;
  if fmodule = nil then Exit;
  MUTEX_LOCK(_mm_mutex_vars);
  if B then PMD(fmodule).wrap := 1 else PMD(fmodule).wrap := 0;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;
//------------------------------------------------------------------------------
function  TMikmod.IsRewind() : boolean;
begin
   Result := RewindState;
   RewindState := false;
end;
//------------------------------------------------------------------------------

var
   MikModBuf : TMikMod;
//------------------------------------------------------------------------------
procedure InitMikMod;
begin
    //MikMod := TMikMod.Create;
    //New(MikMod);
    MikMod := @MikModBuf;
    MikMod.Init;
    InitializeMikModEngine;
end;
//------------------------------------------------------------------------------
procedure FinalMikMod;
begin
  //if module <> nil then MikModStop; // TerminateThread
   MikMod.UnLoad();//MikMod.Free;
   //Dispose(MikMod);
   MikMod_Exit();
end;
//------------------------------------------------------------------------------

//FROM MLOADER

{$L sloaderext.obj}

function read_itcompr8(status: PITPACK; reader: TInternalStream{TStream}; sl_buffer: PSWORD;
  count: UWORD; incnt: PUWORD): BOOL; stdcall; external;
function read_itcompr16(status: PITPACK; reader: TInternalStream{TStream};
  sl_buffer: PSWORD; count: UWORD; incnt: PUWORD): BOOL; stdcall; external;


//FROM SLoader

function SL_Init(s: PSAMPLOAD): BOOL;
begin
  if sl_buffer = nil then
  begin
    sl_buffer := _mm_malloc(SLBUFSIZE * sizeof(SWORD));
    if sl_buffer = nil then
    begin
      result := 0;
      exit;
    end;
  end;
  sl_rlength := s^.length;
  if (s^.infmt and SF_16BITS) <> 0 then sl_rlength := sl_rlength shr 1;
  sl_old := 0;
  result := 1;
end;

procedure SL_Exit(s: PSAMPLOAD);
begin
  if sl_rlength > 0 then s^.reader.Position := s^.reader.Position + sl_rlength;  //s^.reader.Seek(sl_rlength, soFromCurrent);
  if sl_buffer <> nil then
  begin
    FreeMem(sl_buffer);
    sl_buffer := nil;
  end;
end;

function SL_LoadInternal(buffer: Pointer; infmt: UWORD; outfmt: UWORD; scalefactor: integer; length: ULONG;
  reader: TInternalStream{TStream}; dither: BOOL; loader: PSAMPLOAD): BOOL;
var
  bptr              : PSBYTE;
  wptr              : PSWORD;
  stodo, t, u       : integer;
  _result, c_block  : integer;
  status            : ITPACK;
  incnt             : UWORD;
  src               : PSBYTE;
  dest              : PSWORD;
  idx               : integer;
  scaleval          : SLONG;
  avgval            : SLONG;
begin
  bptr := buffer;
  wptr := buffer;
  //  _result := 0;
  c_block := 0;                         //* compression bytes until next block */

  while (length <> 0) do
  begin

    stodo := InlineIf((length < SLBUFSIZE), length, SLBUFSIZE);

    if (infmt and SF_ITPACKED) <> 0 then
    begin
      sl_rlength := 0;
      if (c_block = 0) then
      begin
        status.bits := InlineIf(((infmt and SF_16BITS) <> 0), UBYTE(17), UBYTE(9));
        status.bufbits := 0;
        status.last := 0;
        incnt := _mm_read_I_UWORD(reader);
        c_block := InlineIf(((infmt and SF_16BITS) <> 0), $4000, $8000);
        if (infmt and SF_DELTA) <> 0 then sl_old := 0;
      end;
      if (infmt and SF_16BITS) <> 0 then
      begin
        _result := read_itcompr16(@status, addr(reader), sl_buffer, stodo, @incnt);
        if (_result = 0) then
        begin
          result := 1;
          exit;
        end;
      end else
      begin
        _result := read_itcompr8(@status, addr(reader), sl_buffer, stodo, @incnt);
        if (_result = 0) then
        begin
          result := 1;
          exit;
        end;
      end;
      if (_result <> stodo) then
      begin
        _mm_errno := byte(MMERR_ITPACK_INVALID_DATA);
        result := 1;
        exit;
      end;
      c_block := c_block - stodo;
    end
    else
    begin
      if (infmt and SF_16BITS) <> 0 then
      begin
        if (infmt and SF_BIG_ENDIAN) <> 0 then
          _mm_read_M_SWORDS(sl_buffer, stodo, reader)
        else
          _mm_read_I_SWORDS(sl_buffer, stodo, reader);
      end
      else
      begin
        reader.Read(sl_buffer^, sizeof(SBYTE) * stodo);
        src := PSBYTE(sl_buffer);
        dest := sl_buffer;
        inc(src, stodo);
        inc(dest, stodo);
        for t := 0 to stodo - 1 do
        begin
          dec(src);
          dec(dest);
          dest^ := src^ shl 8;
        end;
      end;
      sl_rlength := sl_rlength - stodo;
    end;

    if (infmt and SF_DELTA) <> 0 then
      for t := 0 to stodo - 1 do
      begin
        PSWORDARRAY(sl_buffer)[t] := PSWORDARRAY(sl_buffer)[t] + sl_old;
        sl_old := PSWORDARRAY(sl_buffer)[t];
      end;

    if ((infmt xor outfmt) and SF_SIGNED) <> 0 then
      for t := 0 to stodo - 1 do
        PSWORDARRAY(sl_buffer)[t] := PSWORDARRAY(sl_buffer)[t] xor $8000;

    if scalefactor <> 0 then
    begin
      idx := 0;
      //* Sample Scaling... average values for better results. */
      t := 0;
      while (t < stodo) and (length <> 0) do
      begin
        scaleval := 0;
        u := scalefactor;
        while (u <> 0) and (t < stodo) do
        begin
          scaleval := scaleval + PSWORDARRAY(sl_buffer)[t];
          inc(t);
          dec(u);
        end;
        PSWORDARRAY(sl_buffer)[idx] := scaleval div (scalefactor - u);
        inc(idx);
        dec(length);
      end;
      stodo := idx;
    end
    else length := length - stodo;

    if dither <> 0 then
    begin
      if ((infmt and SF_STEREO) <> 0) and ((outfmt and SF_STEREO) = 0) then
      begin
        //* dither stereo to mono, average together every two samples */
        idx := 0;
        t := 0;
        while (t < stodo) and (length <> 0) do
        begin

          avgval := PSWORDARRAY(sl_buffer)[t];
          inc(t);

          avgval := avgval + PSWORDARRAY(sl_buffer)[t];
          inc(t);

          PSWORDARRAY(sl_buffer)[idx] := avgval shr 1;
          inc(idx);

          length := length - 2;
        end;
        stodo := idx;
      end;
    end;

    if (outfmt and SF_16BITS) <> 0 then
    begin
      for t := 0 to stodo - 1 do
      begin
        wptr^ := PSWORDARRAY(sl_buffer)[t];
        inc(wptr);
      end;
    end else
    begin
      for t := 0 to stodo - 1 do
      begin
        bptr^ := PSWORDARRAY(sl_buffer)[t] shr 8;
        inc(bptr);
      end;
    end;   
  end;

  result := 0;
end;

function SL_Load(buffer: Pointer; smp: PSAMPLOAD; length: ULONG): BOOL;
begin
  result := SL_LoadInternal(buffer, smp^.infmt, smp^.outfmt, smp^.scalefactor,
    length, smp^.reader, 0, smp);
end;

//* Registers a sample for loading when SL_LoadSamples() is called. */

function SL_RegisterSample(s: PSAMPLE; _type: drvenum1; reader: TInternalStream{TStream}): PSAMPLOAD;
var
  news              : PSAMPLOAD;
  cruise            : PSAMPLOAD;
  samplist          : PPSAMPLOAD;
begin

  if (_type = MD_MUSIC) then
  begin
    samplist := @musiclist;
    cruise := musiclist;
  end else
    if (_type = MD_SNDFX) then
    begin
      samplist := @sndfxlist;
      cruise := sndfxlist;
    end else
    begin
      result := nil;
      exit;
    end;

  //* Allocate and add structure to the END of the list */
  news := _mm_malloc(sizeof(SAMPLOAD));
  if (news = nil) then
  begin
    result := nil;
    exit;
  end;

  if (cruise <> nil) then
  begin
    while (cruise^.next <> nil) do cruise := cruise^.next;
    cruise^.next := news;
  end else
    samplist^ := news;

  //  FillChar(news^, sizeof(SAMPLOAD), 0);

  news^.infmt := s^.flags and SF_FORMATMASK;
  news^.outfmt := news^.infmt;
  news^.reader := reader;
  news^.sample := s;
  news^.length := s^.length;
  news^.loopstart := s^.loopstart;
  news^.loopend := s^.loopend;

  result := news;
end;

procedure FreeSampleList(s: PSAMPLOAD);
var
  old               : PSAMPLOAD;
begin
  while (s <> nil) do
  begin
    old := s;
    s := s^.next;
    freeMem(old);
  end;
end;

//* Returns the total amount of memory required by the samplelist queue. */

function SampleTotal(samplist: PSAMPLOAD; _type: drvenum1): ULONG;
var
  total             : integer;
begin
  total := 0;
  while (samplist <> nil) do
  begin
    samplist^.sample^.flags :=
      (samplist^.sample^.flags and (not SF_FORMATMASK)) or samplist^.outfmt;
    total := total + MD_SampleLength(ord(_type), samplist^.sample);
    samplist := samplist^.next;
  end;
  result := total;
end;

function RealSpeed(s: PSAMPLOAD): ULONG;
begin
  result := s^.sample^.speed div InlineIf((s^.scalefactor <> 0), s^.scalefactor, 1);
end;

function DitherSamples(samplist: PSAMPLOAD; _type: drvenum1): BOOL;
var
  c2smp             : PSAMPLOAD;
  maxsize, speed    : ULONG;
  s                 : PSAMPLOAD;
begin
  c2smp := nil;

  if (samplist = nil) then
  begin
    result := 0;
    exit;
  end;
  maxsize := MD_SampleSpace(ord(_type)) * 1024;

  if (maxsize <> 0) then
    while (SampleTotal(samplist, _type) > maxsize) do
    begin
      //* First Pass - check for any 16 bit samples */
      s := samplist;
      while (s <> nil) do
      begin
        if (s^.outfmt and SF_16BITS) <> 0 then
        begin
          SL_Sample16to8(s);
          break;
        end;
        s := s^.next;
      end;

      //* Second pass (if no 16bits found above) is to take the sample with
      //   the highest speed and dither it by half. */

      if (s = nil) then
      begin
        s := samplist;
        speed := 0;
        while (s <> nil) do
        begin
          if ((s^.sample^.length <> 0) and (RealSpeed(s) > speed)) then
          begin
            speed := RealSpeed(s);
            c2smp := s;
          end;
          s := s^.next;
        end;
        if (c2smp <> nil) then
          SL_HalveSample(c2smp, 2);
      end;
    end;

  //* Samples dithered, now load them ! */
  s := samplist;
  while (s <> nil) do
  begin
    //* sample has to be loaded ? -> increase number of samples, allocate
    //   memory and load sample. */
    if (s^.sample^.length <> 0) then
    begin
      if (s^.sample^.seekpos <> 0) then s^.reader.Position := s^.sample^.seekpos;

      //* Call the sample load routine of the driver module. It has to
      //   return a 'handle' (>=0) that identifies the sample. */
      s^.sample^.handle := MD_SampleLoad(s, ord(_type));
      s^.sample^.flags := (s^.sample^.flags and (not SF_FORMATMASK)) or s^.outfmt;
      if (s^.sample^.handle < 0) then
      begin
        FreeSampleList(samplist);
        //if(_mm_errorhandler) _mm_errorhandler();
        result := 1;
        exit;
      end;
    end;
    s := s^.next;
  end;

  FreeSampleList(samplist);
  result := 0;
end;

function SL_LoadSamples(): BOOL;
var
  ok                : BOOL;
begin
  _mm_critical := 0;
  if ((musiclist = nil) and (sndfxlist = nil)) then
  begin
    result := 0;
    exit;
  end;
  ok := DitherSamples(musiclist, MD_MUSIC) or DitherSamples(sndfxlist, MD_SNDFX);
  sndfxlist := nil;
  musiclist := nil;
  result := ok;
end;

procedure SL_Sample16to8(s: PSAMPLOAD);
begin
  s^.outfmt := s^.outfmt and (not SF_16BITS);
  s^.sample^.flags := (s^.sample^.flags and (not SF_FORMATMASK)) or s^.outfmt;
end;

procedure SL_Sample8to16(s: PSAMPLOAD);
begin
  s^.outfmt := s^.outfmt or SF_16BITS;
  s^.sample^.flags := (s^.sample^.flags and (not SF_FORMATMASK)) or s^.outfmt;
end;

procedure SL_SampleSigned(s: PSAMPLOAD);
begin
  s^.outfmt := s^.outfmt or SF_SIGNED;
  s^.sample^.flags := (s^.sample^.flags and (not SF_FORMATMASK)) or s^.outfmt;
end;

procedure SL_SampleUnsigned(s: PSAMPLOAD);
begin
  s^.outfmt := s^.outfmt and (not SF_SIGNED);
  s^.sample^.flags := (s^.sample^.flags and (not SF_FORMATMASK)) or s^.outfmt;
end;

procedure SL_HalveSample(s: PSAMPLOAD; factor: integer);
begin
  s^.scalefactor := InlineIf((factor > 0), factor, 2);
  s^.sample^.divfactor := s^.scalefactor;
  s^.sample^.length := s^.length div s^.scalefactor;
  s^.sample^.loopstart := s^.loopstart div s^.scalefactor;
  s^.sample^.loopend := s^.loopend div s^.scalefactor;
end;

// FROM SLOADER



procedure _mm_registerloader(ldr: PMLOADER_);
var
  cruise            : PMLOADER_;
begin
  cruise := firstloader;
  if (cruise <> nil) then
  begin
    while (cruise^.next <> nil) do cruise := cruise^.next;
    cruise^.next := ldr;
  end else
    firstloader := ldr;
end;

procedure MikMod_RegisterLoader(ldr: PMLOADER_);
begin
  //* if we try to register an invalid loader, or an already registered loader,
  //   ignore this attempt */
  if (ldr = nil) or (ldr^.next <> nil) then exit;
  MUTEX_LOCK(_mm_mutex_lists);
  _mm_registerloader(ldr);
  MUTEX_UNLOCK(_mm_mutex_lists);
end;

function ReadComment(len: UWORD): BOOL; // FEHLERGEFAHR
var
  i                 : integer;
begin
  if (len <> 0) then
  begin
    _of.comment := _mm_malloc(len + 1);
    if (_of.comment = nil) then
    begin
      result := 0;
      exit;
    end;
    modreader.Read(_of.comment^, len);
    //	for(i=0;i<len;i++)
   //			if(of.comment[i]=='\r') of.comment[i]='\n';

    //* translate IT linefeeds */
    FillChar(_of.comment^, len + 1, 0);
    i := 0;
    while i < len do
    begin
      inc(_of.comment, i);
      if _of.comment^ = #10 then _of.comment^ := #13;
      dec(_of.comment, i);
      inc(i);
    end;
    //of.comment[len]=0;	/* just in case */
  end;
  if _of.comment^ = #0 then
  begin
    free(_of.comment);
    _of.comment := nil;
  end;
  result := 1;
end;

function AllocPositions(total: integer): BOOL;
begin
  if (total = 0) then
  begin
    _mm_errno := byte(MMERR_NOT_A_MODULE);
    result := 0;
    exit;
  end;
  _of.positions := _mm_calloc(total, sizeof(UWORD));
  if (_of.positions = nil) then
  begin
    result := 0;
    exit;
  end;
  result := 1;
end;

function AllocPatterns(): BOOL;
var
  s, t, tracks      : integer;
begin
  tracks := 0;
  if (_of.numpat = 0) or (_of.numchn = 0) then
  begin
    _mm_errno := byte(MMERR_NOT_A_MODULE);
    result := 0;
    exit;
  end;
  //* Allocate track sequencing array */
  _of.patterns := _mm_calloc((_of.numpat + 1) * _of.numchn, sizeof(UWORD));
  _of.pattrows := _mm_calloc(_of.numpat + 1, sizeof(UWORD));
  if (_of.patterns = nil) then
  begin
    result := 0;
    exit;
  end;
  if (_of.pattrows = nil) then
  begin
    result := 0;
    exit;
  end;
  for t := 0 to _of.numpat do
  begin
    PUWORDARRAY(_of.pattrows)[t] := 64;

    for s := 0 to _of.numchn - 1 do
    begin
      PUWORDARRAY(_of.patterns)[(t * _of.numchn) + s] := tracks;
      inc(tracks);
    end;
  end;
  result := 1;
end;

function AllocTracks(): BOOL;
begin
  if (_of.numtrk = 0) then
  begin
    _mm_errno := byte(MMERR_NOT_A_MODULE);
    result := 0;
    exit;
  end;
  _of.tracks := _mm_calloc(_of.numtrk, sizeof(PUBYTE));
  if _of.tracks = nil then
  begin
    result := 0;
    exit;
  end;
  result := 1;
end;

function AllocInstruments(): BOOL;
var
  t, n              : integer;
begin
  if (_of.numins = 0) then
  begin
    _mm_errno := byte(MMERR_NOT_A_MODULE);
    result := 0;
    exit;
  end;
  _of.instruments := _mm_calloc(_of.numins, sizeof(INSTRUMENT));
  if (_of.instruments = nil) then
  begin
    result := 0;
    exit;
  end;
  for t := 0 to _of.numins - 1 do
  begin

    for n := 0 to INSTNOTES - 1 do
    begin
      //* Init note / sample lookup table */
      PINSTRUMENTARRAY(_of.instruments)[t].samplenote[n] := n;
      PINSTRUMENTARRAY(_of.instruments)[t].samplenumber[n] := t;
    end;
    PINSTRUMENTARRAY(_of.instruments)[t].globvol := 64;
  end;
  result := 1;
end;

function AllocSamples(): BOOL;
var
  u                 : UWORD;
begin
  if (_of.numsmp = 0) then
  begin
    _mm_errno := byte(MMERR_NOT_A_MODULE);
    result := 0;
    exit;
  end;
  _of.samples := _mm_calloc(_of.numsmp, sizeof(SAMPLE));
  if (_of.samples = nil) then
  begin
    result := 0;
    exit;
  end;
  for u := 0 to _of.numsmp - 1 do
  begin
    PSAMPLEARRAY(_of.samples)[u].panning := 128; //* center */
    PSAMPLEARRAY(_of.samples)[u].handle := -1;
    PSAMPLEARRAY(_of.samples)[u].globvol := 64;
    PSAMPLEARRAY(_of.samples)[u].volume := 64;
  end;
  result := 1;
end;

function ML_LoadSamples(): BOOL;
var
  s                 : PSAMPLE;
  u                 : integer;
begin
  u := _of.numsmp;
  s := _of.samples;
  while u <> 0 do
  begin
    if (s^.length <> 0) then SL_RegisterSample(s, MD_MUSIC, modreader);
    dec(u);
    if u <> 0 then
      inc(s);
  end;
  result := 1;
end;

procedure ML_XFreeSample(s: PSAMPLE);
begin
  if (s^.handle >= 0) then
    MD_SampleUnload(s^.handle);
  if (s^.samplename <> nil) then free(s^.samplename);
end;

procedure ML_XFreeInstrument(i: PINSTRUMENT);
begin
  if (i^.insname <> nil) then free(i^.insname);
end;

procedure ML_FreeEx(mf: PMODULE);
var
  t                 : UWORD;
begin
  if (mf^.songname <> nil) then free(mf^.songname);
  if (mf^.comment <> nil) then free(mf^.comment);
  if (mf^.modtype <> nil) then free(mf^.modtype);
  if (mf^.positions <> nil) then free(mf^.positions);
  if (mf^.patterns <> nil) then free(mf^.patterns);
  if (mf^.pattrows <> nil) then free(mf^.pattrows);
  if (mf^.tracks <> nil) then
  begin
    for t := 0 to mf^.numtrk - 1 do
      if (PPointerArray(mf^.tracks)[t] <> nil) then free(PPointerArray(mf^.tracks)[t]);
    free(mf^.tracks);
  end;

  if (mf^.instruments <> nil) then
  begin
    for t := 0 to mf^.numins - 1 do
    begin
      ML_XFreeInstrument(@PINSTRUMENTARRAY(mf^.instruments)[t]);
    end;
    free(mf^.instruments);
  end;
  if (mf^.samples <> nil) then
  begin
    for t := 0 to mf^.numsmp - 1 do
    begin
      if (PSAMPLEARRAY(mf^.samples)[t].length <> 0) then ML_XFreeSample(@PSAMPLEARRAY(mf^.samples)[t]);
    end;
    free(mf^.samples);
  end;

  FillChar(mf^, sizeof(MODULE), 0);

  if (mf <> @_of) then free(mf);
end;

function ML_AllocUniMod(): PMODULE;
begin
  result := _mm_malloc(sizeof(MODULE));
end;

procedure Player_Free_internal(mf: PMODULE);
begin
  if (mf <> nil) then
  begin
    Player_Exit_internal(mf);
    ML_FreeEx(mf);
  end;
end;

procedure Player_Free(mf: PMODULE);
begin
  MUTEX_LOCK(_mm_mutex_vars);
  Player_Free_internal(mf);
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

//* Loads a module given an reader */

function Player_LoadGeneric_internal(reader: TInternalStream{TStream}; maxchan: integer; curious: BOOL): PMODULE;
var
  t                 : integer;
  l                 : PMLOADER_;
  ok                : BOOL;
  mf                : PMODULE;

begin

  modreader := reader;
  _mm_errno := 0;//MikMod_Errors(0);
  _mm_critical := 0;
  _mm_iobase_setcur(modreader);

  //* Try to find a loader that recognizes the module */

  l := firstloader;

  while l <> nil do
  begin
    _mm_rewind(modreader);
    if l^.Test() <> 0 then break;
    l := l^.next;
  end;

  if (l = nil) then
  begin
    _mm_errno := byte(MMERR_NOT_A_MODULE);
    //if(_mm_errorhandler) _mm_errorhandler();
    _mm_rewind(modreader);
    _mm_iobase_revert();
    result := nil;
    exit;
  end;

  //* init unitrk routines */
  if UniInit() = 0 then
  begin
    //if(_mm_errorhandler) _mm_errorhandler();
    _mm_rewind(modreader);
    _mm_iobase_revert();
    result := nil;
    exit;
  end;

  //* init the module structure with vanilla settings */

  FillChar(_of, sizeof(MODULE), 0);

  _of.bpmlimit := 33;
  _of.initvolume := 128;

  for t := 0 to UF_MAXCHAN - 1 do
    _of.chanvol[t] := 64;

  for t := 0 to UF_MAXCHAN - 1 do
    _of.panning[t] := InlineIf((((t + 1) and 2) <> 0), PAN_RIGHT, PAN_LEFT);

  //* init module loader and load the header / patterns */
  if (not Assigned(l^.Init)) or (l^.Init() <> 0) then
  begin
    _mm_rewind(modreader);
    ok := l^.Load(curious);
    //* propagate inflags=flags for in-module samples */

    for t := 0 to _of.numsmp - 1 do
      if (PSAMPLEARRAY(_of.samples)[t].inflags = 0) then
        PSAMPLEARRAY(_of.samples)[t].inflags := PSAMPLEARRAY(_of.samples)[t].flags;

  end else
    ok := 0;

  //* free loader and unitrk allocations */
  if (Assigned(l^.Cleanup)) then l^.Cleanup();
  UniCleanup();

  if (ok = 0) then
  begin
    ML_FreeEx(@_of);
    //if(_mm_errorhandler) _mm_errorhandler();
    _mm_rewind(modreader);
    _mm_iobase_revert();
    result := nil;
    exit;
  end;

  if (ML_LoadSamples() = 0) then
  begin
    ML_FreeEx(@_of);
    //if(_mm_errorhandler) _mm_errorhandler();
    _mm_rewind(modreader);
    _mm_iobase_revert();
    result := nil;
    exit;
  end;

  mf := ML_AllocUniMod();
  if (mf = nil) then
  begin
    ML_FreeEx(@_of);
    _mm_rewind(modreader);
    _mm_iobase_revert();
    //if(_mm_errorhandler) _mm_errorhandler();
    result := nil;
    exit;
  end;

  //* If the module doesn't have any specific panning, create a
  //   MOD-like panning, with the channels half-separated. */

  if (_of.flags and UF_PANNING) = 0 then
    for t := 0 to _of.numchn - 1 do
      _of.panning[t] := InlineIf((((t + 1) and 2) <> 0), PAN_HALFRIGHT, PAN_HALFLEFT);

  //* Copy the static MODULE contents into the dynamic MODULE struct. */
  memcpy(mf, @_of, sizeof(MODULE));

  if (maxchan > 0) then
  begin
    if ((mf^.flags and UF_NNA) = 0) and (mf^.numchn < maxchan) then
      maxchan := mf^.numchn
    else
      if (mf^.numvoices <> 0) and (mf^.numvoices < maxchan) then
        maxchan := mf^.numvoices;

    if (maxchan < mf^.numchn) then mf^.flags := mf^.flags or UF_NNA;

    if MikMod_SetNumVoices_internal(maxchan, -1) <> 0 then
    begin
      _mm_iobase_revert();
      Player_Free(mf);
      result := nil;
      exit;
    end
  end;
  if SL_LoadSamples() <> 0 then
  begin
    _mm_iobase_revert();
    Player_Free_internal(mf);
    result := nil;
    exit;
  end;
  if Player_Init(mf) <> 0 then
  begin
    _mm_iobase_revert();
    Player_Free_internal(mf);
    mf := nil;
  end;
  _mm_iobase_revert();
  result := mf;

//  defbpm := mf.bpm;
end;

function Player_LoadGeneric(reader: TInternalStream{TStream}; maxchan: integer; curious: BOOL): PMODULE;
begin

  MUTEX_LOCK(_mm_mutex_vars);
  MUTEX_LOCK(_mm_mutex_lists);
  result := Player_LoadGeneric_internal(reader, maxchan, curious);
  MUTEX_UNLOCK(_mm_mutex_lists);
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

function Player_Load(filename: PCHAR; maxchan: integer; curious: BOOL): PMODULE;
begin{var
  reader            : TFileStream;
begin
  reader := TFileStream.Create(filename, $0000);//fmOpenRead);
  result := Player_LoadGeneric(reader, maxchan, curious);
  reader.free; }
end;

function Player_Load_CustomStream(stream: TInternalStream{TStream}; maxchan: integer; curious: BOOL): PMODULE;
begin
  result := nil;
  if stream <> nil then
  begin
    result := Player_LoadGeneric(stream, maxchan, curious);
  end;
end;








// <-- FROM MLOADER




//FROM MUNITRK
//*========== Reading routines */

procedure UniSetRow(t: PUBYTE);
begin
  rowstart := t;
  rowpc := rowstart;
  if t <> nil then
  begin
    rowend := Ptr(LongInt(rowstart) + (rowpc^ and $1F));
    inc(rowpc);
  end
  else rowend := t;
end;

function UniGetByte(): UBYTE;
begin
  if LongInt(rowpc) < LongInt(rowend) then
  begin
    lastbyte := rowpc^;
    inc(rowpc);
  end else lastbyte := 0;
  result := lastbyte;
end;

function UniGetWord(): UWORD;
begin
  result := (UniGetByte() shl 8) or UniGetByte();
end;

procedure UniSkipOpcode();
var
  t                 : UWORD;
begin
  if lastbyte < Ord(UNI_LAST) then
  begin
    t := unioperands[lastbyte];
    while t <> 0 do
    begin
      UniGetByte();
      dec(t);
    end;
  end;
end;

//* Finds the address of row number 'row' in the UniMod(tm) stream 't' returns
//   NULL if the row can't be found. */

function UniFindRow(t: PUBYTE; row: UWORD): PUBYTE;
var
  c, l              : UBYTE;
begin
  if t <> nil then
  begin
    while true do
    begin
      c := t^;                          //* get rep/len byte
      if c = 0 then                     //* zero ? -> end of track..
      begin
        result := nil;
        exit;
      end;
      l := (c shr 5) + 1;               //* extract repeat value
      if l > row then break;            //* reached wanted row? -> return pointer
      dec(row, l);                      //* haven't reached row yet.. update row
      t := ptr(LongInt(t) + c and $1F); //* point t to the next row
    end;
  end;
  result := t;
end;

//* Resets index-pointers to create a new track. */

procedure UniReset();
begin
  unitt := 0;                           //* reset index to rep/len byte */
  unipc := 1;                           //* first opcode will be written to index 1 */
  lastp := 0;                           //* no previous row yet */
  unibuf^ := 0;                         //* clear rep/len byte */  Das 1 Byte im Endeffekt
end;

//* Expands the buffer */

function UniExpand(wanted: integer): BOOL;

var
  newbuf            : PUBYTE;
begin

  if (unipc + wanted) >= unimax then
  begin
    //* Expand the buffer by BUFPAGE bytes */
    newbuf := ReallocMemory(unibuf, (unimax + BUFPAGE) * sizeof(UBYTE));
    //* Check if realloc succeeded */
    if newbuf <> nil then
    begin
      unibuf := newbuf;
      unimax := unimax + BUFPAGE;
      result := 1;
      exit;
    end
    else
    begin
      result := 0;
      exit;
    end;
  end;
  result := 1;
end;

//* Appends one byte of data to the current row of a track. */

procedure UniWriteByte(data: UBYTE);
begin
  if UniExpand(1) <> 0 then
  begin
    //* write byte to current position and update */
    PUBYTEARRAY(unibuf)[unipc] := data;
    inc(unipc);
  end;
end;

procedure UniWriteWord(data: UWORD);
begin
  if UniExpand(2) <> 0 then
  begin
    PUWORDARRAY(unibuf)[unipc] := data shr 8;
    ////
    inc(unipc);
    ////
    PUWORDARRAY(unibuf)[unipc] := data and $FF;
    ////
    inc(unipc);
  end;
end;

function MyCmp(a, b: PUBYTE; l: UWORD): BOOL;
var
  t                 : UWORD;
begin
  if l > 0 then
    for t := 0 to l - 1 do
    begin
      if a^ <> b^ then
      begin
        result := 0;
        exit;
      end;
      inc(a);
      inc(b);
    end;
  result := 1;
end;

//* Closes the current row of a unitrk stream (updates the rep/len byte) and sets
//   pointers to start a new row. */

procedure UniNewline();
var
  n, l, len         : UWORD;
begin

  n := (PUBYTEARRAY(unibuf)[lastp] shr 5) + 1;             //* repeat of previous row */
  l := (PUBYTEARRAY(unibuf)[lastp] and $1F);               //* length of previous row */

  len := unipc - unitt;                 //* length of current row */

  //* Now, check if the previous and the current row are identical.. when they
  //   are, just increase the repeat field of the previous row */

  if (n < 8) and (len = l) and (MyCmp( @PUBYTEARRAY(unibuf)[lastp+1],
  @PUBYTEARRAY(unibuf)[unitt+1], len - 1) <> 0) then
  begin
    PUBYTEARRAY(unibuf)[lastp] := PUBYTEARRAY(unibuf)[lastp] + $20;
    unipc := unitt + 1;
  end else
  begin
    if UniExpand(unitt - unipc) <> 0 then
    begin
      //* current and previous row aren't equal... update the pointers */
      PUBYTEARRAY(unibuf)[unitt] := len;
      lastp := unitt;
      unitt := unipc;
      inc(unipc);
    end;
  end;
end;

//* Terminates the current unitrk stream and returns a pointer to a copy of the
//   stream. */

function UniDup(): PBYTE;
var
  d                 : PBYTE;
begin
  if UniExpand(unitt - unipc) = 0 then
  begin
    result := nil;
    exit;
  end;
  PUBYTEARRAY(unibuf)[unitt] := 0;
  d := _mm_malloc(unipc);
  if d = nil then
  begin
    result := nil;
    exit;
  end;
  memcpy(d, unibuf, unipc);
  result := d;
end;

function UniInit(): BOOL;
begin
  unimax := BUFPAGE;
  unibuf := _mm_malloc(unimax * sizeof(UBYTE));
  if unibuf = nil then result := 0 else result := 1;
end;

procedure UniCleanup();
begin
  if unibuf <> nil then
    FreeMem(unibuf);
  unibuf := nil;
end;



//FROM <<-MUNITRK

function InlineIf(cond: Boolean; retvaltrue, retvalfalse: ULONG): ULONG; Overload;
begin
  if cond then result := retvaltrue else result := retvalfalse;
end;

function InlineIf(cond: Boolean; retvaltrue, retvalfalse: SLONG): SLONG; Overload;
begin
  if cond then result := retvaltrue else result := retvalfalse;
end;

function InlineIf(cond: Boolean; retvaltrue, retvalfalse: UBYTE): UBYTE; Overload;
begin
  if cond then result := retvaltrue else result := retvalfalse;
end;

function InlineIf(cond: Boolean; retvaltrue, retvalfalse: UWORD): UWORD; Overload;
begin
  if cond then result := retvaltrue else result := retvalfalse;
end;

function InlineIf(cond: Boolean; retvaltrue, retvalfalse: SWORD): SWORD; Overload;
begin
  if cond then result := retvaltrue else result := retvalfalse;
end;

function InlineIf(cond: Boolean; retvaltrue, retvalfalse: int64): int64; Overload;
begin
  if cond then result := retvaltrue else result := retvalfalse;
end;

procedure MUTEX_LOCK(mutex: THandle);
begin
  if mutex <> 0 then
    WaitForSingleObject(mutex, INFINITE);
end;

procedure MUTEX_UNLOCK(mutex: THandle);
begin
  if mutex <> 0 then
    ReleaseMutex(mutex);
end;

function _mm_malloc(size: integer): Pointer;
begin
  result := malloc(size);
  FillChar(result^, size, 0);
end;

function _mm_calloc(nb_blocs, size: integer): Pointer;
begin
  result := calloc(nb_blocs, size);
  FillChar(result^, size * nb_blocs, 0);
end;

function _mm_read_UBYTES(buf: PBYTE; len: integer; fstrm: TInternalStream{TStream}): integer;//BOOL;
begin
  result := fstrm.Read(buf^, len);
end;

function _mm_read_UBYTE(fstrm: TInternalStream{TStream}): UBYTE;
begin
  fstrm.read(result, 1);
end;

function __mm_read_UBYTE(pfstrm: TInternalStream{TStream}): UBYTE; cdecl;
begin
  pfstrm^.read(result, 1);
end;

function _mm_read_SBYTE(fstrm: TInternalStream{TStream}): SBYTE;
begin
  fstrm.read(result, 1);
end;

function _mm_read_I_UWORD(fstrm: TInternalStream{TStream}): UWORD;
begin
  result := _mm_read_UBYTE(fstrm);
  result := result or _mm_read_UBYTE(fstrm) shl 8;
end;

function _mm_read_M_UWORD(fstrm: TInternalStream{TStream}): UWORD;
begin
  result := _mm_read_UBYTE(fstrm) shl 8;
  result := result or _mm_read_UBYTE(fstrm);
end;

function _mm_read_I_SWORD(fstrm: TInternalStream{TStream}): SWORD;
begin
  result := _mm_read_I_UWORD(fstrm);
end;

function _mm_read_M_SWORD(fstrm: TInternalStream{TStream}): SWORD;
begin
  result := _mm_read_M_UWORD(fstrm);
end;

function _mm_read_M_SWORDS(buffer: PSWORD; number: integer; fstrm: TInternalStream{TStream}): integer;
var
  i                 : integer;
begin
  for i := 1 to number do
  begin
    buffer^ := _mm_read_M_SWORD(fstrm);
    inc(buffer);
  end;
  result := 1;
end;

function _mm_read_I_SWORDS(buffer: PSWORD; number: integer; fstrm: TInternalStream{TStream}): integer;
var
  i                 : integer;
begin
  for i := 1 to number do
  begin
    buffer^ := _mm_read_I_SWORD(fstrm);
    inc(buffer);
  end;
  result := 1;
end;

function _mm_read_I_UWORDS(buffer: PWORD; number: integer; fstrm: TInternalStream{TStream}): integer;
var
  i                 : integer;
begin
  for i := 1 to number do
  begin
    buffer^ := _mm_read_I_UWORD(fstrm);
    inc(buffer);
  end;
  result := 1;
end;

function _mm_read_I_ULONG(reader: TInternalStream{TStream}): ULONG;
begin
  result := _mm_read_I_UWORD(reader);
  result := result or (_mm_read_I_UWORD(reader)) shl 16;
end;

//* Sets the current file-position as the new _mm_iobase */

procedure _mm_iobase_setcur(reader: TInternalStream{TStream});
begin
  temp_iobase := _mm_iobase;            //* store old value in case of revert */
  _mm_iobase := reader.Position;
end;

//* Reverts to the last known _mm_iobase value. */

procedure _mm_iobase_revert();
begin
  _mm_iobase := temp_iobase;
end;

procedure _mm_rewind(reader: TInternalStream{TStream});
begin
  reader.Position := 0;
end;

function calloc(nb_blocs, size: integer): Pointer;
begin
  Result := malloc(nb_blocs * size);
end;

function malloc(size: integer): Pointer;
begin
  GetMem(Result, size);
end;

procedure free(adr: Pointer);
begin
  FreeMem(adr);
end;


function rand: Integer;
const
  RAND_MAX          = $7FFF;
begin
  Result := Random(RAND_MAX);
end;

function isalnum(c: Integer): integer;
begin
  if Chr(c) in ['a'..'z', 'A'..'Z', '0'..'9'] then
    Result := 1
  else
    Result := 0;
end;

function isdigit(c: Integer): integer;
begin
  if Chr(c) in ['0'..'9'] then
    Result := 1
  else
    Result := 0;
end;

{function min(const a, b: Integer): Integer;
begin
  if a <= b then
    Result := a
  else
    Result := b;
end; }

function memcpy(dst: Pointer; const src: Pointer; len: integer): Pointer;
begin
  Move(src^, dst^, len);
  Result := dst;
end;

function strcpy(dst: PChar; const src: PChar): PChar;
begin
  Result := memcpy(dst, src, strlen(src) + 1);
end;

function memcmp(const buf1, buf2: Pointer; len: integer): Integer;
var
  i                 : Integer;
begin
  Result := 0;
  i := 0;
  while (i < len) and (Result = 0) do
  begin
    if PChar(buf1)[i] < PChar(buf2)[i] then
      Result := -1
    else if PChar(buf1)[i] > PChar(buf2)[i] then
      Result := 1;
    Inc(i);
  end;
end;

function strncmp(const str1, str2: PChar; len: integer): Integer;
var
  l1, l2            : Integer;
begin
  l1 := min(strlen(str1), len);
  l2 := min(strlen(str2), len);
  Result := memcmp(str1, str2, min(l1, l2));
  if Result = 0 then
    if l1 < l2 then
      Result := -1
    else if l2 > l1 then
      Result := 1;
end;

function memset(buf: Pointer; c: Integer; len: integer): Pointer;
begin
  FillChar(buf^, len, c);
  Result := buf;
end;

function strlen(const str1: PChar): integer;
begin
  Result := 0;
  while str1[Result] <> #0 do
    Inc(Result);
end;

function Trim(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  if I > L then Result := '' else
  begin
    while S[L] <= ' ' do Dec(L);
    Result := Copy(S, I, L - I + 1);
  end;
end;

function AllocLinear(): PInteger;
begin
  if (_of.numsmp > noteindexcount) then
  begin
    noteindexcount := _of.numsmp;
    noteindex := ReallocMemory(noteindex, noteindexcount * sizeof(Integer));
  end;
  result := noteindex;
end;

procedure FreeLinear();
begin
  if (noteindex <> nil) then
  begin
    free(noteindex);
    noteindex := nil;
  end;
  noteindexcount := 0;
end;

function speed_to_finetune(speed: ULONG; sample: integer): integer;
var
  ctmp, tmp, note, finetune: integer;
begin
  ctmp := 0;
  note := 1;
  finetune := 0;
  speed := speed shr 1;
  tmp := getfrequency(_of.flags, getlinearperiod(note shl 1, 0));
  while tmp < speed do
  begin
    ctmp := tmp;
    inc(note);
    tmp := getfrequency(_of.flags, getlinearperiod(note shl 1, 0));
  end;
  if (tmp <> speed) then
  begin
    if ((tmp - speed) < (speed - ctmp)) then
      while (tmp > speed) do
      begin
        tmp := getfrequency(_of.flags, getlinearperiod(note shl 1, finetune));
        dec(finetune);
      end
    else
    begin
      dec(note);
      while (ctmp < speed) do
      begin
        ctmp := getfrequency(_of.flags, getlinearperiod(note shl 1, finetune));
        inc(finetune);
      end;
    end;
  end;
  PintegerArray(noteindex)[sample] := note - 4 * OCTAVE;
  result := finetune;
end;

//*========== Order stuff */

//* handles S3M and IT orders */

procedure S3MIT_CreateOrders(curious: BOOL);
var
  t                 : integer;
  order             : integer;
begin
  _of.numpos := 0;
  FillChar(_of.positions^, poslookupcnt * sizeof(UWORD), 0);
  FillChar(poslookup^, 256, -1);
  for t := 0 to poslookupcnt - 1 do
  begin
    order := PUWORDARRAY(origpositions)[t];
    if (order = 255) then order := LAST_PATTERN;
    PUWORDARRAY(_of.positions)[_of.numpos] := order;
    PUBYTEARRAY(poslookup)[t] := _of.numpos;           //* bug fix for freaky S3Ms / ITs */
    if (PUWORDARRAY(origpositions)[t] < 254) then inc(_of.numpos)
    else
      //* end of song special order */
      if (order = LAST_PATTERN) and (curious = 0) then
      begin
        break;
      end
      else dec(curious);                // FEHLERGEFAHR
  end;
end;

//*========== Unitrk stuff */

//* Generic effect writing routine */

procedure UniEffect(eff: UWORD; dat: UWORD);
begin
  if (eff = 0) or (eff >= ord(UNI_LAST)) then exit;

  UniWriteByte(eff);
  if (unioperands[eff] = 2) then
    UniWriteWord(dat)
  else
    UniWriteByte(dat);
end;

//*  Appends UNI_PTEFFECTX opcode to the unitrk stream. */

procedure UniPTEffect(eff: UBYTE; dat: UBYTE);
begin
  if (eff <> 0) or (dat <> 0) or ((_of.flags and UF_ARPMEM) <> 0) then UniEffect(ord(UNI_PTEFFECT0) + eff, dat);
end;

//* Appends UNI_VOLEFFECT + effect/dat to unistream. */

procedure UniVolEffect(eff: UWORD; dat: UBYTE);
begin
  if ((eff <> 0) or (dat <> 0)) then    //* don't write empty effect */
  begin
    UniWriteByte(ord(UNI_VOLEFFECTS));
    UniWriteByte(eff);
    UniWriteByte(dat);
  end;
end;

procedure UniInstrument(dat: UBYTE);
begin
  UniEffect(ord(UNI_INSTRUMENT), dat);
end;

procedure UniNote(dat: UBYTE);
begin
  UniEffect(ord(UNI_NOTE), dat);
end;

//*========== Effect stuff */

//* handles S3M and IT effects */

procedure S3MIT_ProcessCmd(cmd: UBYTE; inf: UBYTE; flags: cardinal);
var
  {hi,} lo            : UBYTE;
begin
  lo := inf and $F;
//  hi := inf shr 4;
  //* process S3M / IT specific command structure */
  if (cmd <> 255) then
  begin
    case (cmd) of
      1:                                //* Axx set speed to xx */
        UniEffect(ord(UNI_S3MEFFECTA), inf);
      2:                                //* Bxx position jump */
        if (inf < poslookupcnt) then
        begin
          //* switch to curious mode if necessary, for example
          //   sympex.it, deep joy.it */
          if (SBYTE(PUBYTEARRAY(poslookup)[inf]) < 0) and (PUWORDARRAY(origpositions)[inf] <> 255) then
            S3MIT_CreateOrders(1);
          if not (SBYTE(PUBYTEARRAY(poslookup)[inf]) < 0) then
            UniPTEffect($B, PUBYTEARRAY(poslookup)[inf]);
        end;
      3:                                //* Cxx patternbreak to row xx */
        if ((flags and S3MIT_OLDSTYLE) <> 0) and ((flags and S3MIT_IT) = 0) then
          UniPTEffect($D, (inf shr 4) * 10 + (inf and $F))
        else
          UniPTEffect($D, inf);
      4:                                //* Dxy volumeslide */
        UniEffect(ord(UNI_S3MEFFECTD), inf);
      5:                                //* Exy toneslide down */
        UniEffect(ord(UNI_S3MEFFECTE), inf);
      6:                                //* Fxy toneslide up */
        UniEffect(ord(UNI_S3MEFFECTF), inf);
      7:                                //* Gxx Tone portamento, speed xx */
        if (flags and S3MIT_OLDSTYLE) <> 0 then
          UniPTEffect($3, inf)
        else
          UniEffect(ord(UNI_ITEFFECTG), inf);
      8:                                //* Hxy vibrato */
        if (flags and S3MIT_OLDSTYLE) <> 0 then
          UniPTEffect($4, inf)
        else
          UniEffect(ord(UNI_ITEFFECTH), inf);
      9:                                //* Ixy tremor, ontime x, offtime y */
        if (flags and S3MIT_OLDSTYLE) <> 0 then
          UniEffect(ord(UNI_S3MEFFECTI), inf)
        else
          UniEffect(ord(UNI_ITEFFECTI), inf);
      $A:                               //* Jxy arpeggio */
        UniPTEffect($0, inf);
      $B:                               //* Kxy Dual command H00 & Dxy */
        begin
          if (flags and S3MIT_OLDSTYLE) <> 0 then
            UniPTEffect($4, 0)
          else
            UniEffect(ord(UNI_ITEFFECTH), 0);
          UniEffect(ord(UNI_S3MEFFECTD), inf);
        end;
      $C:                               //* Lxy Dual command G00 & Dxy */
        begin
          if (flags and S3MIT_OLDSTYLE) <> 0 then
            UniPTEffect($3, 0)
          else
            UniEffect(ord(UNI_ITEFFECTG), 0);
          UniEffect(ord(UNI_S3MEFFECTD), inf);
        end;
      $D:                               //* Mxx Set Channel Volume */
        UniEffect(ord(UNI_ITEFFECTM), inf);
      $E:                               //* Nxy Slide Channel Volume */
        UniEffect(ord(UNI_ITEFFECTN), inf);
      $F:                               //* Oxx set sampleoffset xx00h */
        UniPTEffect($9, inf);
      $10:                              //* Pxy Slide Panning Commands */
        UniEffect(ord(UNI_ITEFFECTP), inf);
      $11:                              //* Qxy Retrig (+volumeslide) */
        begin
          UniWriteByte(ord(UNI_S3MEFFECTQ));
          if (inf <> 0) and (lo = 0) and ((flags and S3MIT_OLDSTYLE) = 0) then
            UniWriteByte(1)
          else
            UniWriteByte(inf);
        end;
      $12:                              //* Rxy tremolo speed x, depth y */
        UniEffect(ord(UNI_S3MEFFECTR), inf);
      $13:                              //* Sxx special commands */
        if (inf >= $F0) then
        begin
          //* change resonant filter settings if necessary */
          if (filters <> 0) and ((inf and $F) <> activemacro) then
          begin
            activemacro := inf and $F;
            inf := 0;
            while inf < $80 do
            begin
              filtersettings[inf].filter := filtermacros[activemacro];
              inc(inf);
            end;
          end;
        end else
        begin
          //* Scream Tracker does not have samples larger than
          //   64 Kb, thus doesn't need the SAx effect */
          if ((flags and S3MIT_SCREAM) <> 0) and ((inf and $F0) = $A0) then
          else UniEffect(ord(UNI_ITEFFECTS0), inf);
        end;
      $14:                              //* Txx tempo */
        if (inf >= $20) then
          UniEffect(ord(UNI_S3MEFFECTT), inf)
        else
        begin
          if ((flags and S3MIT_OLDSTYLE) = 0) then
            //* IT Tempo slide */
            UniEffect(ord(UNI_ITEFFECTT), inf);
        end;
      $15:                              //* Uxy Fine Vibrato speed x, depth y */
        if (flags and S3MIT_OLDSTYLE) <> 0 then
          UniEffect(ord(UNI_S3MEFFECTU), inf)
        else
          UniEffect(ord(UNI_ITEFFECTU), inf);
      $16:                              //* Vxx Set Global Volume */
        UniEffect(ord(UNI_XMEFFECTG), inf);
      $17:                              //* Wxy Global Volume Slide */
        UniEffect(ord(UNI_ITEFFECTW), inf);
      $18:                              //* Xxx amiga command 8xx */
        if (flags and S3MIT_OLDSTYLE) <> 0 then
        begin
          if (inf > 128) then
            UniEffect(ord(UNI_ITEFFECTS0), $91) //* surround */
          else
            if inf = 128 then
              UniPTEffect($8, 255) else UniPTEffect($8, (inf shl 1));

        end else
          UniPTEffect($8, inf);
      $19:                              //* Yxy Panbrello  speed x, depth y */
        UniEffect(ord(UNI_ITEFFECTY), inf);
      $1A:                              //* Zxx midi/resonant filters */
        if (filtersettings[inf].filter) <> 0 then
        begin
          UniWriteByte(ord(UNI_ITEFFECTZ));
          UniWriteByte(filtersettings[inf].filter);
          UniWriteByte(filtersettings[inf].inf);
        end;
    end;
  end;
end;

// FROM DRV_WIN ///////////////////////////////////////////////////////////////
const

  NUMBUFFERS        = 6;                // number of buffers
  BUFFERSIZE        = 120;              // buffer size in milliseconds

var
  _hwaveout         : HWAVEOUT;
  drv_win_header    : array[0..NUMBUFFERS - 1] of WAVEHDR;
  drv_win_buffer    : array[0..NUMBUFFERS - 1] of Pointer; // pointers to buffers
  drv_win_buffersout: WORD;             // number of buffers playing/about to be played
  drv_win_nextbuffer: WORD;             // next buffer to be mixed */
  _buffersize       : ULONG;

type
  NATIVE = SLONG;

const

  MAXVOL_FACTOR     = (1 shl 9);
  REVERBERATION     = 11000;

  SAMPLING_SHIFT    = 2;
  SAMPLING_FACTOR   = (1 shl SAMPLING_SHIFT);

  FRACBITS          = 28;
  FRACMASK          = ((1 shl FRACBITS) - 1);

  TICKLSIZE         = 8192;
  TICKWSIZE         = (TICKLSIZE * 2);
  TICKBSIZE         = (TICKWSIZE * 2);

  CLICK_SHIFT_BASE  = 6;
  CLICK_SHIFT       = (CLICK_SHIFT_BASE + SAMPLING_SHIFT);
  CLICK_BUFFER      = (1 shl CLICK_SHIFT);

type
  VINFOARRAY = array[0..$EFFFF] of VINFO;
  PVINFOARRAY = ^VINFOARRAY;

  TMix32to16 = procedure(dste: PSWORD; srce: PSLONG; count: NATIVE); stdcall;
  TMix32to8 = procedure(dste: PSBYTE; srce: PSLONG; count: NATIVE); stdcall;
  TMixReverb = procedure(srce: PSLONG; count: NATIVE);

var

  Mix32to16         : TMix32to16;
  Mix32to8          : TMix32to8;
  MixReverb         : TMixReverb;

  Samples           : ^PSWORD;
  vnf               : PVINFO;

  tickleft          : integer;
  samplesthatfit    : integer;
  vc_softchn        : integer;

  idxsize           : SLONGLONG = 0;
  idxlpos           : SLONGLONG = 0;
  idxlend           : SLONGLONG = 0;

  vc_mode           : UWORD;

  //* Reverb control variables */

  RVc1, RVc2, RVc3, RVc4, RVc5, RVc6, RVc7, RVc8: integer;
  RVRindex          : ULONG;

  //* For Mono or Left Channel */

  RVbufL1           : PSLONG = nil;
  RVbufL2           : PSLONG = nil;
  RVbufL3           : PSLONG = nil;
  RVbufL4           : PSLONG = nil;
  RVbufL5           : PSLONG = nil;
  RVbufL6           : PSLONG = nil;
  RVbufL7           : PSLONG = nil;
  RVbufL8           : PSLONG = nil;

  //* for Stereo only(Right Channel) */
  RVbufR1           : PSLONG = nil;
  RVbufR2           : PSLONG = nil;
  RVbufR3           : PSLONG = nil;
  RVbufR4           : PSLONG = nil;
  RVbufR5           : PSLONG = nil;
  RVbufR6           : PSLONG = nil;
  RVbufR7           : PSLONG = nil;
  RVbufR8           : PSLONG = nil;


  {$L virtch2ext.obj}

function Mix32MonoNormal(srce: PSWORD; dest: PSLONG; index: SLONG; increment: SLONG; todo: SLONG; vnf: PVINFO): SLONG; stdcall; external;
function Mix32StereoNormal(srce: PSWORD; dest: PSLONG; index: SLONG; increment: SLONG; todo: ULONG; vnf: PVINFO): SLONG; stdcall; external;
function Mix32StereoSurround(srce: PSWORD; dest: PSLONG; index: SLONG; increment: SLONG; todo: ULONG; vnf: PVINFO): SLONG; stdcall; external;
function MixMonoNormal(srce: PSWORD; dest: PSLONG; index: SLONGLONG; increment: SLONGLONG; todo: SLONG; vnf: PVINFO): SLONGLONG; stdcall; external;
function MixStereoNormal(srce: PSWORD; dest: PSLONG; index: SLONGLONG; increment: SLONGLONG; todo: ULONG; vnf: PVINFO): SLONGLONG; stdcall; external;
function MixStereoSurround(srce: PSWORD; dest: PSLONG; index: SLONGLONG; increment: SLONGLONG; todo: ULONG; vnf: PVINFO): SLONGLONG; stdcall; external;

procedure Mix32To16_Normal(dste: PSWORD; srce: PSLONG; count: NATIVE); stdcall; external;
procedure Mix32To16_Stereo(dste: PSWORD; srce: PSLONG; count: NATIVE); stdcall; external;
procedure Mix32To8_Normal(dste: PSBYTE; srce: PSLONG; count: NATIVE); stdcall; external;
procedure Mix32To8_Stereo(dste: PSBYTE; srce: PSLONG; count: NATIVE); stdcall; external;

procedure __llmul;
asm
        push  edx
        push  eax

  // Param2 : [ESP+16]:[ESP+12]  (hi:lo)
  // Param1 : [ESP+4]:[ESP]      (hi:lo)

        mov   eax, [esp+16]
        mul   dword ptr [esp]
        mov   ecx, eax

        mov   eax, [esp+4]
        mul   dword ptr [esp+12]
        add   ecx, eax

        mov   eax, [esp]
        mul   dword ptr [esp+12]
        add   edx, ecx

        pop   ecx
        pop   ecx

        ret     8
end;

//* Reverb macros */

function samples2bytes(samples: ULONG): ULONG;
begin
  if (vc_mode and DMODE_16BITS) <> 0 then samples := samples shl 1;
  if (vc_mode and DMODE_STEREO) <> 0 then samples := samples shl 1;
  result := samples;
end;

function bytes2samples(bytes: ULONG): ULONG;
begin
  if (vc_mode and DMODE_16BITS) <> 0 then bytes := bytes shr 1;
  if (vc_mode and DMODE_STEREO) <> 0 then bytes := bytes shr 1;
  result := bytes;
end;

procedure COMPUTE_LOC(var loc: cardinal; RVc: integer);
begin
  loc := RVRindex mod RVc;
end;

procedure COMPUTE_ECHO(loc: cardinal; RVbuf: PSLONG; speedup: NATIVE; ReverbPct: integer);
begin
  inc(RVbuf, loc);
  RVbuf^ := speedup + ((ReverbPct * RVbuf^) shr 7);
  //dec(RVbuf, loc);
end;

function hlpfunc_MixReverb_Normal(RVbuf: PSLONG; loc: cardinal): SLONG;
begin
  inc(RVbuf, loc);
  result := RVbuf^;
  //dec(RVbuf, loc);
end;

procedure MixReverb_Normal(srce: PSLONG; count: NATIVE);
var
  speedup           : NATIVE;
  ReverbPct         : integer;
  loc1, loc2, loc3, loc4, loc5, loc6, loc7, loc8: cardinal;
begin

  ReverbPct := 58 + (md_reverb * 4);

  COMPUTE_LOC(loc1, RVc1);
  COMPUTE_LOC(loc2, RVc2);
  COMPUTE_LOC(loc3, RVc3);
  COMPUTE_LOC(loc4, RVc4);
  COMPUTE_LOC(loc5, RVc5);
  COMPUTE_LOC(loc6, RVc6);
  COMPUTE_LOC(loc7, RVc7);
  COMPUTE_LOC(loc8, RVc8);

  while (count <> 0) do
  begin
    //* Compute the left channel echo buffers */
    speedup := srce^ shr 3;

    COMPUTE_ECHO(loc1, RVbufL1, speedup, ReverbPct);
    COMPUTE_ECHO(loc2, RVbufL2, speedup, ReverbPct);
    COMPUTE_ECHO(loc3, RVbufL3, speedup, ReverbPct);
    COMPUTE_ECHO(loc4, RVbufL4, speedup, ReverbPct);
    COMPUTE_ECHO(loc5, RVbufL5, speedup, ReverbPct);
    COMPUTE_ECHO(loc6, RVbufL6, speedup, ReverbPct);
    COMPUTE_ECHO(loc7, RVbufL7, speedup, ReverbPct);
    COMPUTE_ECHO(loc8, RVbufL8, speedup, ReverbPct);

    //* Prepare to compute actual finalized data */
    inc(RVRindex);
    COMPUTE_LOC(loc1, RVc1);
    COMPUTE_LOC(loc2, RVc2);
    COMPUTE_LOC(loc3, RVc3);
    COMPUTE_LOC(loc4, RVc4);
    COMPUTE_LOC(loc5, RVc5);
    COMPUTE_LOC(loc6, RVc6);
    COMPUTE_LOC(loc7, RVc7);
    COMPUTE_LOC(loc8, RVc8);

    //* left channel */

    srce^ := srce^ + hlpfunc_MixReverb_Normal(RVbufL1, loc1) -
      hlpfunc_MixReverb_Normal(RVbufL2, loc2) +
      hlpfunc_MixReverb_Normal(RVbufL3, loc3) -
      hlpfunc_MixReverb_Normal(RVbufL4, loc4) +
      hlpfunc_MixReverb_Normal(RVbufL5, loc5) -
      hlpfunc_MixReverb_Normal(RVbufL6, loc6) +
      hlpfunc_MixReverb_Normal(RVbufL7, loc7) -
      hlpfunc_MixReverb_Normal(RVbufL8, loc8);

    inc(srce);

    dec(count);
  end;
end;

procedure MixReverb_Stereo(srce: PSLONG; count: NATIVE);
var
  speedup           : NATIVE;
  ReverbPct         : integer;
  loc1, loc2, loc3, loc4, loc5, loc6, loc7, loc8: cardinal;
begin
  ReverbPct := 58 + (md_reverb * 4);

  COMPUTE_LOC(loc1, RVc1);
  COMPUTE_LOC(loc2, RVc2);
  COMPUTE_LOC(loc3, RVc3);
  COMPUTE_LOC(loc4, RVc4);
  COMPUTE_LOC(loc5, RVc5);
  COMPUTE_LOC(loc6, RVc6);
  COMPUTE_LOC(loc7, RVc7);
  COMPUTE_LOC(loc8, RVc8);

  while (count <> 0) do
  begin
    //* Compute the left channel echo buffers */
    speedup := srce^ shr 3;

    COMPUTE_ECHO(loc1, RVbufL1, speedup, ReverbPct);
    COMPUTE_ECHO(loc2, RVbufL2, speedup, ReverbPct);
    COMPUTE_ECHO(loc3, RVbufL3, speedup, ReverbPct);
    COMPUTE_ECHO(loc4, RVbufL4, speedup, ReverbPct);
    COMPUTE_ECHO(loc5, RVbufL5, speedup, ReverbPct);
    COMPUTE_ECHO(loc6, RVbufL6, speedup, ReverbPct);
    COMPUTE_ECHO(loc7, RVbufL7, speedup, ReverbPct);
    COMPUTE_ECHO(loc8, RVbufL8, speedup, ReverbPct);

    //* Compute the right channel echo buffers */
    inc(srce);
    speedup := srce^ shr 3;
    dec(srce);

    COMPUTE_ECHO(loc1, RVbufR1, speedup, ReverbPct);
    COMPUTE_ECHO(loc2, RVbufR2, speedup, ReverbPct);
    COMPUTE_ECHO(loc3, RVbufR3, speedup, ReverbPct);
    COMPUTE_ECHO(loc4, RVbufR4, speedup, ReverbPct);
    COMPUTE_ECHO(loc5, RVbufR5, speedup, ReverbPct);
    COMPUTE_ECHO(loc6, RVbufR6, speedup, ReverbPct);
    COMPUTE_ECHO(loc7, RVbufR7, speedup, ReverbPct);
    COMPUTE_ECHO(loc8, RVbufR8, speedup, ReverbPct);
    //* Prepare to compute actual finalized data */
    inc(RVRindex);
    COMPUTE_LOC(loc1, RVc1);
    COMPUTE_LOC(loc2, RVc2);
    COMPUTE_LOC(loc3, RVc3);
    COMPUTE_LOC(loc4, RVc4);
    COMPUTE_LOC(loc5, RVc5);
    COMPUTE_LOC(loc6, RVc6);
    COMPUTE_LOC(loc7, RVc7);
    COMPUTE_LOC(loc8, RVc8);
    //* left channel */
    srce^ := srce^ + hlpfunc_MixReverb_Normal(RVbufL1, loc1) -
      hlpfunc_MixReverb_Normal(RVbufL2, loc2) +
      hlpfunc_MixReverb_Normal(RVbufL3, loc3) -
      hlpfunc_MixReverb_Normal(RVbufL4, loc4) +
      hlpfunc_MixReverb_Normal(RVbufL5, loc5) -
      hlpfunc_MixReverb_Normal(RVbufL6, loc6) +
      hlpfunc_MixReverb_Normal(RVbufL7, loc7) -
      hlpfunc_MixReverb_Normal(RVbufL8, loc8);
    inc(srce);
    //* right channel */
    srce^ := srce^ +
      hlpfunc_MixReverb_Normal(RVbufR1, loc1) -
      hlpfunc_MixReverb_Normal(RVbufR2, loc2) +
      hlpfunc_MixReverb_Normal(RVbufR3, loc3) -
      hlpfunc_MixReverb_Normal(RVbufR4, loc4) +
      hlpfunc_MixReverb_Normal(RVbufR5, loc5) -
      hlpfunc_MixReverb_Normal(RVbufR6, loc6) +
      hlpfunc_MixReverb_Normal(RVbufR7, loc7) -
      hlpfunc_MixReverb_Normal(RVbufR8, loc8);
    inc(srce);
    dec(count);
  end;
end;

//* Mixing macros */

procedure AddChannel(ptr: PSLONG; todo: NATIVE);
var
  _end, done, endpos: SLONGLONG;
  s                 : PSWORD;
begin
  s := PPointerArray(Samples)[vnf^.handle];
  if (s = nil) then
  begin
    vnf^.current := 0;
    vnf^.active := 0;
    vnf^.lastvalL := 0;
    vnf^.lastvalR := 0;
    exit;
  end;
  //* update the 'current' index so the sample loops, or stops playing if it
  //   reached the end of the sample */
  while (todo > 0) do
  begin
    if (vnf^.flags and SF_REVERSE) <> 0 then
    begin
      //* The sample is playing in reverse */
      if ((vnf^.flags and SF_LOOP) <> 0) and (vnf^.current < idxlpos) then
      begin
        //* the sample is looping and has reached the loopstart index */
        if (vnf^.flags and SF_BIDI) <> 0 then
        begin
          //* sample is doing bidirectional loops, so 'bounce' the
          //   current index against the idxlpos */
          vnf^.current := idxlpos + (idxlpos - vnf^.current);
          vnf^.flags := vnf^.flags and (not SF_REVERSE);
          vnf^.increment := -vnf^.increment;
        end else
          //* normal backwards looping, so set the current position to
          //   loopend index */
          vnf^.current := idxlend - (idxlpos - vnf^.current);
      end
      else
      begin
        //* the sample is not looping, so check if it reached index 0 */
        if (vnf^.current < 0) then
        begin
          //* playing index reached 0, so stop playing this sample */
          vnf^.current := 0;
          vnf^.active := 0;
          break;
        end;
      end;
    end else
    begin
      //* The sample is playing forward */
      if ((vnf^.flags and SF_LOOP) <> 0) and
        (vnf^.current >= idxlend) then
      begin
        //* the sample is looping, check the loopend index */
        if (vnf^.flags and SF_BIDI) <> 0 then
        begin
          //* sample is doing bidirectional loops, so 'bounce' the
           //  current index against the idxlend */
          vnf^.flags := vnf^.flags or SF_REVERSE;
          vnf^.increment := -vnf^.increment;
          vnf^.current := idxlend - (vnf^.current - idxlend);
        end else
          //* normal backwards looping, so set the current position
          //   to loopend index */
          vnf^.current := idxlpos + (vnf^.current - idxlend);
      end else
      begin
        // sample is not looping, so check if it reached the last
        //   position */
        if (vnf^.current >= idxsize) then
        begin
          //* yes, so stop playing this sample */
          vnf^.current := 0;
          vnf^.active := 0;
          break;
        end;
      end;
    end;

    { if vnf^.flags and SF_REVERSE <> 0 then
     begin
       if vnf^.flags and SF_LOOP <> 0 then _end := idxlpos else _end := 0;
     end else if vnf^.flags and SF_LOOP <> 0 then _end := idxlend else _end := idxsize;}

    _end := InLineIf((vnf^.flags and SF_REVERSE <> 0), InlineIf((vnf^.flags and SF_LOOP <> 0), idxlpos, 0),
      InlineIf((vnf^.flags and SF_LOOP <> 0), idxlend, idxsize));

    //* if the sample is not blocked... */
    if (_end = vnf^.current) or (vnf^.increment = 0) then
      done := 0
    else
    begin
      done := MIN((_end - vnf^.current) div vnf^.increment + 1, todo);
      if (done < 0) then done := 0;
    end;
    if (done = 0) then
    begin
      vnf^.active := 0;
      break;
    end;
    endpos := vnf^.current + done * vnf^.increment;
    if (vnf^.vol <> 0) or (vnf^.rampvol <> 0) then
    begin
      //* use the 32 bit mixers as often as we can (they're much faster) */
      if (vnf^.current < $7FFFFFFF) and (endpos < $7FFFFFFF) then
      begin
        if (vc_mode and DMODE_STEREO) <> 0 then
        begin
          if (vnf^.pan = PAN_SURROUND) and ((vc_mode and DMODE_SURROUND) <> 0) then
            vnf^.current := Mix32StereoSurround
              (s, ptr, vnf^.current, vnf^.increment, done, vnf)
          else
            vnf^.current := Mix32StereoNormal
              (s, ptr, vnf^.current, vnf^.increment, done, vnf);
        end else
          vnf^.current := Mix32MonoNormal
            (s, ptr, vnf^.current, vnf^.increment, done, vnf);
      end else
      begin
        if (vc_mode and DMODE_STEREO) <> 0 then
        begin
          if (vnf^.pan = PAN_SURROUND) and ((vc_mode and DMODE_SURROUND) <> 0) then
            vnf^.current := MixStereoSurround(s, ptr, vnf^.current, vnf^.increment, done, vnf)
          else
            vnf^.current := MixStereoNormal(s, ptr, vnf^.current, vnf^.increment, done, vnf);
        end else
          vnf^.current := MixMonoNormal(s, ptr, vnf^.current, vnf^.increment, done, vnf);
      end;
    end else
    begin
      vnf^.lastvalL := 0;
      vnf^.lastvalR := 0;
      //* update sample position */
      vnf^.current := endpos;
    end;
    todo := todo - done;
    if vc_mode and DMODE_STEREO <> 0 then inc(ptr, (done shl 1)) else inc(ptr, done);
  end;
end;

procedure VC2_WriteSamples(buf: PSBYTE; todo: ULONG);
var
  left, portion     : integer;
  buffer            : PSBYTE;
  t, pan, vol       : integer;
begin
  //portion := 0;
  todo := todo * SAMPLING_FACTOR;
  while (todo <> 0) do
  begin
    if (tickleft = 0) then
    begin
      if (vc_mode and DMODE_SOFT_MUSIC) <> 0 then Player_HandleTick();
      tickleft := (md_mixfreq * 125 * SAMPLING_FACTOR) div (md_bpm * 50);
      tickleft := tickleft and (not (SAMPLING_FACTOR - 1));
    end;
    left := MIN(tickleft, todo);
    buffer := buf;
    tickleft := tickleft - left;
    todo := todo - left;
    inc(buf, samples2bytes(left) div SAMPLING_FACTOR);
    while (left) <> 0 do
    begin
      portion := MIN(left, samplesthatfit);
      FillChar(vc_tickbuf^, portion shl Byte(InlineIf(((vc_mode and DMODE_STEREO) <> 0), UBYTE(3), UBYTE(2))), UBYTE(0));
      for t := 0 to vc_softchn - 1 do
      begin
        vnf := @PVINFOARRAY(vinf)[t];
        if (vnf^.kick) <> 0 then
        begin
          vnf^.current := (Int64(vnf^.start)) shl FRACBITS;
          vnf^.kick := 0;
          vnf^.active := 1;
          vnf^.click := CLICK_BUFFER;
          vnf^.rampvol := 0;
        end;

        if (vnf^.frq = 0) then vnf^.active := 0;

        if (vnf^.active) <> 0 then
        begin
          vnf^.increment := (Int64(vnf^.frq) shl (FRACBITS - SAMPLING_SHIFT)) div md_mixfreq;
          if (vnf^.flags and SF_REVERSE) <> 0 then vnf^.increment := -vnf^.increment;
          vol := vnf^.vol;
          pan := vnf^.pan;
          vnf^.oldlvol := vnf^.lvolsel;
          vnf^.oldrvol := vnf^.rvolsel;
          if (vc_mode and DMODE_STEREO) <> 0 then
          begin
            if (pan <> PAN_SURROUND) then
            begin
              vnf^.lvolsel := (vol * (PAN_RIGHT - pan)) shr 8;
              vnf^.rvolsel := (vol * pan) shr 8;
            end else
            begin
              vnf^.lvolsel := (vol * 256) div 480;
              vnf^.rvolsel := (vol * 256) div 480;
            end;
          end else
            vnf^.lvolsel := vol;

          if vnf^.size <> 0 then idxsize := (int64(vnf^.size) shl FRACBITS) - 1 else idxsize := 0;
          if vnf^.repend <> 0 then idxlend := (int64(vnf^.repend) shl FRACBITS) - 1 else idxlend := 0;
          idxlpos := int64(vnf^.reppos) shl FRACBITS;
          AddChannel(vc_tickbuf, portion);
        end;
      end;

      if (md_reverb <> 0) then
      begin
        if (md_reverb > 15) then md_reverb := 15;
        MixReverb(vc_tickbuf, portion);
      end;

      if (vc_mode and DMODE_16BITS) <> 0 then
        Mix32to16(PSWORD(buffer), vc_tickbuf, portion)
      else
        Mix32to8(PSBYTE(buffer), vc_tickbuf, portion);

      inc(buffer, samples2bytes(portion) div SAMPLING_FACTOR);
      left := left - portion;
    end;
  end;
end;

function VC2_Init(): BOOL;
begin

  //VC_SetupPointers();

  //if (!(md_mode&DMODE_HQMIXER))
  //	return VC1_Init();

  Samples := _mm_calloc(MAXSAMPLEHANDLES, sizeof(PSWORD));

  if (Samples = nil) then
  begin
    _mm_errno := byte(MMERR_INITIALIZING_MIXER);
    result := 1;
    exit;
  end;

  if (vc_tickbuf = nil) then
  begin

    vc_tickbuf := _mm_malloc((TICKLSIZE + 32) * sizeof(SLONG));
    if (vc_tickbuf = nil) then
    begin
      _mm_errno := byte(MMERR_INITIALIZING_MIXER);
      result := 1;
      exit;
    end;
  end;

  if (md_mode and DMODE_STEREO) <> 0 then
  begin
    Mix32to16 := Mix32To16_Stereo;
    Mix32to8 := Mix32To8_Stereo;
    MixReverb := MixReverb_Stereo;
  end else
  begin
    Mix32to16 := Mix32To16_Normal;
    Mix32to8 := Mix32To8_Normal;
    MixReverb := MixReverb_Normal;
  end;
  md_mode := md_mode or DMODE_INTERP;
  vc_mode := md_mode;
  result := 0;
end;

function VC2_PlayStart(): BOOL;
begin
  md_mode := md_mode or DMODE_INTERP;

  samplesthatfit := TICKLSIZE;
  if (vc_mode and DMODE_STEREO) <> 0 then samplesthatfit := samplesthatfit shr 1;
  tickleft := 0;

  RVc1 := (5000 * md_mixfreq) div (REVERBERATION * 10);
  RVc2 := (5078 * md_mixfreq) div (REVERBERATION * 10);
  RVc3 := (5313 * md_mixfreq) div (REVERBERATION * 10);
  RVc4 := (5703 * md_mixfreq) div (REVERBERATION * 10);
  RVc5 := (6250 * md_mixfreq) div (REVERBERATION * 10);
  RVc6 := (6953 * md_mixfreq) div (REVERBERATION * 10);
  RVc7 := (7813 * md_mixfreq) div (REVERBERATION * 10);
  RVc8 := (8828 * md_mixfreq) div (REVERBERATION * 10);

  RVbufL1 := _mm_calloc((RVc1 + 1), sizeof(SLONG));
  if RVbufL1 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufL2 := _mm_calloc((RVc2 + 1), sizeof(SLONG));
  if RVbufL2 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufL3 := _mm_calloc((RVc3 + 1), sizeof(SLONG));
  if RVbufL3 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufL4 := _mm_calloc((RVc4 + 1), sizeof(SLONG));
  if RVbufL4 = nil then
  begin
    result := 1;
    exit;
  end;

{  RVbufL5 := _mm_calloc((RVc5 + 1), sizeof(SLONG));
  if RVbufL5 = nil then
  begin
    result := 1;
    exit;
  end;    }

  RVbufL5 := _mm_calloc((RVc5 + 1), sizeof(SLONG));
  if RVbufL5 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufL6 := _mm_calloc((RVc6 + 1), sizeof(SLONG));
  if RVbufL6 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufL7 := _mm_calloc((RVc7 + 1), sizeof(SLONG));
  if RVbufL7 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufL8 := _mm_calloc((RVc8 + 1), sizeof(SLONG));
  if RVbufL8 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufR1 := _mm_calloc((RVc1 + 1), sizeof(SLONG));
  if RVbufR1 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufR2 := _mm_calloc((RVc2 + 1), sizeof(SLONG));
  if RVbufR2 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufR3 := _mm_calloc((RVc3 + 1), sizeof(SLONG));
  if RVbufR3 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufR4 := _mm_calloc((RVc4 + 1), sizeof(SLONG));
  if RVbufR4 = nil then
  begin
    result := 1;
    exit;
  end;

{  RVbufR5 := _mm_calloc((RVc5 + 1), sizeof(SLONG));
  if RVbufR5 = nil then
  begin
    result := 1;
    exit;
  end;    }

  RVbufR5 := _mm_calloc((RVc5 + 1), sizeof(SLONG));
  if RVbufR5 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufR6 := _mm_calloc((RVc6 + 1), sizeof(SLONG));
  if RVbufR6 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufR7 := _mm_calloc((RVc7 + 1), sizeof(SLONG));
  if RVbufR7 = nil then
  begin
    result := 1;
    exit;
  end;

  RVbufR8 := _mm_calloc((RVc8 + 1), sizeof(SLONG));
  if RVbufR8 = nil then
  begin
    result := 1;
    exit;
  end;

  RVRindex := 0;
  result := 0;
end;

procedure VC2_PlayStop();
begin
  if (RVbufL1 <> nil) then free(RVbufL1);
  if (RVbufL2 <> nil) then free(RVbufL2);
  if (RVbufL3 <> nil) then free(RVbufL3);
  if (RVbufL4 <> nil) then free(RVbufL4);
  if (RVbufL5 <> nil) then free(RVbufL5);
  if (RVbufL6 <> nil) then free(RVbufL6);
  if (RVbufL7 <> nil) then free(RVbufL7);
  if (RVbufL8 <> nil) then free(RVbufL8);
  if (RVbufR1 <> nil) then free(RVbufR1);
  if (RVbufR2 <> nil) then free(RVbufR2);
  if (RVbufR3 <> nil) then free(RVbufR3);
  if (RVbufR4 <> nil) then free(RVbufR4);
  if (RVbufR5 <> nil) then free(RVbufR5);
  if (RVbufR6 <> nil) then free(RVbufR6);
  if (RVbufR7 <> nil) then free(RVbufR7);
  if (RVbufR8 <> nil) then free(RVbufR8);

  RVbufL1 := nil;
  RVbufL2 := nil;
  RVbufL3 := nil;
  RVbufL4 := nil;
  RVbufL5 := nil;
  RVbufL6 := nil;
  RVbufL7 := nil;
  RVbufL8 := nil;
  RVbufR1 := nil;
  RVbufR2 := nil;
  RVbufR3 := nil;
  RVbufR4 := nil;
  RVbufR5 := nil;
  RVbufR6 := nil;
  RVbufR7 := nil;
  RVbufR8 := nil;
end;

function VC2_SetNumVoices(): BOOL;
var
  t                 : integer;
begin
  md_mode := md_mode or DMODE_INTERP;
  vc_softchn := md_softchn;
  if (vc_softchn = 0) then
  begin
    result := 0;
    exit;
  end;
  if (vinf <> nil) then free(vinf);
  vinf := _mm_calloc(sizeof(VINFO), vc_softchn);
  if vinf = nil then
  begin
    result := 1;
    exit;
  end;
  for t := 0 to vc_softchn - 1 do
  begin
    PVINFOARRAY(vinf)[t].frq := 10000;
    if t and 1 <> 0 then
      PVINFOARRAY(vinf)[t].pan := PAN_LEFT else PVINFOARRAY(vinf)[t].pan := PAN_RIGHT;
  end;
  result := 0;
end;

//* Fill the buffer with 'todo' bytes of silence (it depends on the mixing mode
//   how the buffer is filled) */

function VC2_SilenceBytes(buf: PSBYTE; todo: ULONG): ULONG;
begin
  todo := samples2bytes(bytes2samples(todo));
  //* clear the buffer to zero (16 bits signed) or 0x80 (8 bits unsigned) */
  if (vc_mode and DMODE_16BITS) <> 0 then
    FillChar(buf^, todo, 0)
  else
    FillChar(buf^, todo, $80);
  result := todo;
end;

//* Writes 'todo' mixed SBYTES (!!) to 'buf'. It returns the number of SBYTES
//   actually written to 'buf' (which is rounded to number of samples that fit
//   into 'todo' bytes). */

function VC2_WriteBytes(buf: PSBYTE; todo: ULONG): ULONG;
begin
  if (vc_softchn = 0) then
  begin
    result := VC2_SilenceBytes(buf, todo);
    exit;
  end;
  todo := bytes2samples(todo);
  VC2_WriteSamples(buf, todo);
  result := samples2bytes(todo);
end;

procedure VC2_Exit();
begin
  if (vc_tickbuf <> nil) then free(vc_tickbuf);
  if (vinf <> nil) then free(vinf);
  if (Samples <> nil) then free(Samples);
  vc_tickbuf := nil;
  vinf := nil;
  Samples := nil;
end;

function VC2_VoiceGetVolume(voice: UBYTE): UWORD;
begin
  result := PVINFOARRAY(vinf)[voice].vol;
end;

function VC2_VoiceGetPanning(voice: UBYTE): ULONG;
begin
  result := PVINFOARRAY(vinf)[voice].pan;
end;

procedure VC2_VoiceSetFrequency(voice: UBYTE; frq: ULONG);
begin
  PVINFOARRAY(vinf)[voice].frq := frq;
end;

function VC2_VoiceGetFrequency(voice: UBYTE): ULONG;
begin
  result := PVINFOARRAY(vinf)[voice].frq;
end;

procedure VC2_VoicePlay(voice: UBYTE; handle: SWORD; start: ULONG; size: ULONG; reppos: ULONG; repend: ULONG; flags: UWORD);
begin
  PVINFOARRAY(vinf)[voice].flags := flags;
  PVINFOARRAY(vinf)[voice].handle := handle;
  PVINFOARRAY(vinf)[voice].start := start;
  PVINFOARRAY(vinf)[voice].size := size;
  PVINFOARRAY(vinf)[voice].reppos := reppos;
  PVINFOARRAY(vinf)[voice].repend := repend;
  PVINFOARRAY(vinf)[voice].kick := 1;
end;

procedure VC2_VoiceStop(voice: UBYTE);
begin
  PVINFOARRAY(vinf)[voice].active := 0;
end;

function VC2_VoiceStopped(voice: UBYTE): BOOL;
begin
  result := PVINFOARRAY(vinf)[voice].active;
end;

function VC2_VoiceGetPosition(voice: UBYTE): SLONG;
begin
  result := PVINFOARRAY(vinf)[voice].current shr FRACBITS;
end;

procedure VC2_VoiceSetVolume(voice: UBYTE; vol: UWORD);
begin
  //* protect against clicks if volume variation is too high */
  if (abs(PVINFOARRAY(vinf)[voice].vol - vol) > 32) then
    PVINFOARRAY(vinf)[voice].rampvol := CLICK_BUFFER;
  PVINFOARRAY(vinf)[voice].vol := vol;
end;

procedure VC2_VoiceSetPanning(voice: UBYTE; pan: ULONG);
begin
  //* protect against clicks if panning variation is too high */
  if (abs(PVINFOARRAY(vinf)[voice].pan - pan) > 48) then
    PVINFOARRAY(vinf)[voice].rampvol := CLICK_BUFFER;
  PVINFOARRAY(vinf)[voice].pan := pan;
end;

//*========== External mixer interface */

procedure VC2_SampleUnload(handle: SWORD);
begin
  if (handle < MAXSAMPLEHANDLES) then
  begin
    if (PPointerArray(Samples)[handle] <> nil) then
      free(PPointerArray(Samples)[handle]);
    PPointerArray(Samples)[handle] := nil;
  end;
end;

function VC2_SampleLoad(sload: PSAMPLOAD; _type: integer): SWORD;
var
  s                 : PSAMPLE;
  handle            : integer;
  t, length, loopstart, loopend: ULONG;
begin
  s := sload^.sample;
  if (_type = ord(MD_HARDWARE)) then
  begin
    result := -1;
    exit;
  end;
  //* Find empty slot to put sample address in */
  for handle := 0 to MAXSAMPLEHANDLES - 1 do
    if PPointerArray(Samples)[handle] = nil then break;

  if (handle = MAXSAMPLEHANDLES) then
  begin
    _mm_errno := byte(MMERR_OUT_OF_HANDLES);
    result := -1;
    exit;
  end;

  //* Reality check for loop settings */
  if (s^.loopend > s^.length) then
    s^.loopend := s^.length;
  if (s^.loopstart >= s^.loopend) then
    s^.flags := s^.flags and (not SF_LOOP);
  length := s^.length;
  loopstart := s^.loopstart;
  loopend := s^.loopend;
  SL_SampleSigned(sload);
  SL_Sample8to16(sload);

  PPointerArray(Samples)[handle] := _mm_malloc((length + 20) shl 1 + 50000);
  if (PPointerArray(Samples)[handle] = nil) then
  begin
    _mm_errno := byte(MMERR_SAMPLE_TOO_BIG);
    result := -1;
    exit;
  end;
  //* read sample into buffer */
  if SL_Load(PPointerArray(Samples)[handle], sload, length) <> 0 then
  begin
    result := -1;
    exit;
  end;
  //* Unclick sample */
  if (s^.flags and SF_LOOP) <> 0 then
  begin
    if (s^.flags and SF_BIDI) <> 0 then
      for t := 0 to 15 do
        PSWORDARRAY(PPointerArray(Samples)[handle])[loopend + t] :=
          PSWORDARRAY(PPointerArray(Samples)[handle])[(loopend - t) - 1]
    else
      for t := 0 to 15 do
        PSWORDARRAY(PPointerArray(Samples)[handle])[loopend + t] :=
          PSWORDARRAY(PPointerArray(Samples)[handle])[t + loopstart];
  end else
    for t := 0 to 15 do PSWORDARRAY(PPointerArray(Samples)[handle])[t + length] := 0;

  result := handle;
end;

function VC2_SampleSpace(_type: integer): ULONG;
begin
  result := vc_memory;
end;

function VC2_SampleLength(_type: integer; s: PSAMPLE): ULONG;
begin
  if (s = nil) then
  begin
    result := 0;
    exit;
  end;
  result := s^.length * InlineIf((s^.flags and SF_16BITS <> 0), UBYTE(2), UBYTE(1)) + 16;
end;

function VC2_VoiceRealVolume(voice: UBYTE): ULONG;
var
  i, s, size        : ULONG;
  k, j              : integer;
  smp               : PSWORD;
  t                 : SLONG;
begin
  t := PVINFOARRAY(vinf)[voice].current shr FRACBITS;
  if (PVINFOARRAY(vinf)[voice].active = 0) then
  begin
    result := 0;
    exit;
  end;
  s := PVINFOARRAY(vinf)[voice].handle;
  size := PVINFOARRAY(vinf)[voice].size;
  i := 64;
  t := t - 64;
  k := 0;
  j := 0;
  if (i > size) then i := size;
  if (t < 0) then t := 0;
  if (t + i > size) then t := size - i;
  i := i and (not 1);
  //* make sure it's EVEN. */
  smp := @PSWORDARRAY(PPointerArray(Samples)[s])[t];
  while i <> 0 do
  begin
    if (k < smp^) then k := smp^;
    if (j > smp^) then j := smp^;
    dec(i);
    inc(smp);
  end;
  result := abs(k - j);
end;


// FROM VIRTCH2

// converts Windows error to libmikmod error */

function WIN_GetError(mmr: MMRESULT): MikMod_Errors;
begin
  result := MMERR_WINMM_UNKNOWN;
  case mmr of
    MMSYSERR_INVALHANDLE: result := MMERR_WINMM_HANDLE;
    MMSYSERR_NODRIVER: result := MMERR_OPENING_AUDIO;
    MMSYSERR_NOMEM: result := MMERR_OUT_OF_MEMORY;
    MMSYSERR_ALLOCATED: result := MMERR_WINMM_ALLOCATED;
    MMSYSERR_BADDEVICEID: result := MMERR_WINMM_DEVICEID;
    WAVERR_BADFORMAT: result := MMERR_WINMM_FORMAT;
  end;
end;

function WIN_IsThere(): BOOL;
begin
  result := waveOutGetNumDevs();
end;

procedure WIN_CallBack(hwo: HWAVEOUT; uMsg: UINT; dwInstance: DWORD; dwParam1: DWORD; dwParam2: DWORD); stdcall;
begin
  if uMsg = WOM_DONE then dec(drv_win_buffersout);
end;

function WIN_Init(): BOOL;
var
  wfe               : TWAVEFORMATEX;
  samplesize        : WORD;
  mmr               : MMRESULT;
  n                 : integer;
begin
//  FillChar(wfe,sizeof(wfe),0);
  samplesize := 1;
  if (md_mode and DMODE_STEREO) <> 0 then samplesize := samplesize shl 1;
  if (md_mode and DMODE_16BITS) <> 0 then samplesize := samplesize shl 1;
  wfe.wFormatTag := WAVE_FORMAT_PCM;
  if (md_mode and DMODE_STEREO) <> 0 then wfe.nChannels := 2
  else wfe.nChannels := 1;
  wfe.nSamplesPerSec := md_mixfreq;
  wfe.nAvgBytesPerSec := md_mixfreq * samplesize;
  wfe.nBlockAlign := samplesize;
  if (md_mode and DMODE_16BITS) <> 0 then wfe.wBitsPerSample := 16
  else wfe.wBitsPerSample := 8;
  wfe.cbSize := sizeof(wfe);
  mmr := waveOutOpen(@_hwaveout, WAVE_MAPPER, @wfe, Cardinal(@WIN_CallBack), 0, CALLBACK_FUNCTION);
  if (mmr <> MMSYSERR_NOERROR) then
  begin
    _mm_errno := byte(WIN_GetError(mmr));
    result := 0;
    exit;
  end;
  _buffersize := md_mixfreq * samplesize * BUFFERSIZE div 1000;
//  n := 0;
  for n := 0 to NUMBUFFERS-1 do
  begin
    drv_win_buffer[n] := _mm_malloc(_buffersize);
    drv_win_header[n].lpData := drv_win_buffer[n]; ////  WORKING ?!?!?
    drv_win_header[n].dwBufferLength := _buffersize;
    mmr := waveOutPrepareHeader(_hwaveout, @drv_win_header[n], sizeof(WAVEHDR));
    if (drv_win_buffer[n] = nil) or (mmr <> MMSYSERR_NOERROR) then
    begin
      if (drv_win_buffer[n] = nil) then
        _mm_errno := byte(MMERR_OUT_OF_MEMORY)
      else
        _mm_errno := byte(WIN_GetError(mmr));
      result := 0;
      exit;
    end;
  end;
  md_mode := md_mode or DMODE_SOFT_MUSIC or DMODE_SOFT_SNDFX;
  drv_win_buffersout := drv_win_nextbuffer;
  drv_win_nextbuffer := 0;
  result := VC2_Init();
end;

procedure WIN_Exit();
var
  n                 : integer;
begin
  VC2_Exit();
  if @_hwaveout <> nil then
  begin
//    n := 0;
    for n:= 0 to NUMBUFFERS-1 do
    begin
      if (drv_win_header[n].dwFlags and WHDR_PREPARED) <> 0 then
        waveOutUnprepareHeader(_hwaveout, @drv_win_header[n], sizeof(WAVEHDR));
      FreeMem(drv_win_buffer[n]);       // _mm_freemem
    end;
    while waveOutClose(_hwaveout) = WAVERR_STILLPLAYING do Sleep(10);
    _hwaveout := 0;
  end;
end;

procedure WIN_Update();

var
  done              : ULONG;
begin
  while drv_win_buffersout < NUMBUFFERS do
  begin
    done := VC2_WriteBytes(drv_win_buffer[drv_win_nextbuffer], _buffersize);
    if (done = 0) then break;
    drv_win_header[drv_win_nextbuffer].dwBufferLength := done;
    waveOutWrite(_hwaveout, @drv_win_header[drv_win_nextbuffer], sizeof(WAVEHDR));
    inc(drv_win_nextbuffer);
    if drv_win_nextbuffer >= NUMBUFFERS then drv_win_nextbuffer := drv_win_nextbuffer mod NUMBUFFERS;
    inc(drv_win_buffersout);
  end;
end;

procedure WIN_PlayStop();
begin
  if (@_hwaveout <> nil) then waveOutReset(_hwaveout);
  VC2_PlayStop();
end;

// <-- FROM DRV_WIN ///////////////////////////////////////////////////////////


//* Limits the number of hardware voices to the specified amount.
//   This function should only be used by the low-level drivers. */

procedure LimitHardVoices(limit: integer);
var
  t                 : integer;
begin
  t := 0;

  if (((md_mode and DMODE_SOFT_SNDFX) = 0) and (md_sfxchn > limit)) then md_sfxchn := limit;
  if (((md_mode and DMODE_SOFT_MUSIC) = 0) and (md_sngchn > limit)) then md_sngchn := limit;

  if ((md_mode and DMODE_SOFT_SNDFX) = 0) then
    md_hardchn := md_sfxchn
  else
    md_hardchn := 0;

  if ((md_mode and DMODE_SOFT_MUSIC) = 0) then md_hardchn := md_hardchn + md_sngchn;

  while (md_hardchn > limit) do
  begin
    inc(t);
    if (t and 1) <> 0 then
    begin
      if (((md_mode and DMODE_SOFT_SNDFX) = 0) and (md_sfxchn > 4)) then dec(md_sfxchn);
    end else
    begin
      if (((md_mode and DMODE_SOFT_MUSIC) = 0) and (md_sngchn > 8)) then dec(md_sngchn);
    end;

    if ((md_mode and DMODE_SOFT_SNDFX) = 0) then
      md_hardchn := md_sfxchn
    else
      md_hardchn := 0;

    if ((md_mode and DMODE_SOFT_MUSIC) = 0) then
      md_hardchn := md_hardchn + md_sngchn;
  end;
  md_numchn := md_hardchn + md_softchn;
end;

//* Limits the number of hardware voices to the specified amount.
//   This function should only be used by the low-level drivers. */

procedure LimitSoftVoices(limit: integer);
var
  t                 : integer;
begin
  t := 0;

  if ((md_mode and DMODE_SOFT_SNDFX) <> 0) and (md_sfxchn > limit) then md_sfxchn := limit;
  if ((md_mode and DMODE_SOFT_MUSIC) <> 0) and (md_sngchn > limit) then md_sngchn := limit;

  if (md_mode and DMODE_SOFT_SNDFX) <> 0 then
    md_softchn := md_sfxchn
  else
    md_softchn := 0;

  if (md_mode and DMODE_SOFT_MUSIC) <> 0 then md_softchn := md_softchn + md_sngchn;

  while (md_softchn > limit) do
  begin
    inc(t);
    if (t and 1) <> 0 then
    begin
      if ((md_mode and DMODE_SOFT_SNDFX) <> 0) and (md_sfxchn > 4) then dec(md_sfxchn);
    end else
    begin
      if ((md_mode and DMODE_SOFT_MUSIC) <> 0) and (md_sngchn > 8) then dec(md_sngchn);
    end;

    if ((md_mode and DMODE_SOFT_SNDFX) = 0) then
      md_softchn := md_sfxchn
    else
      md_softchn := 0;

    if ((md_mode and DMODE_SOFT_MUSIC) = 0) then
      md_softchn := md_softchn + md_sngchn;
  end;
  md_numchn := md_hardchn + md_softchn;
end;

//* Note: 'type' indicates whether the returned value should be for music or for
//   sound effects. */

function MD_SampleSpace(_type: integer): ULONG;
begin
  if (_type = ord(MD_MUSIC)) then
    _type := InlineIf((md_mode and DMODE_SOFT_MUSIC <> 0), Integer(MD_SOFTWARE), Integer(MD_HARDWARE))
  else if (_type = ord(MD_SNDFX)) then
    _type := InlineIf((md_mode and DMODE_SOFT_SNDFX <> 0), Integer(MD_SOFTWARE), Integer(MD_HARDWARE));
  result := md_driver^.FreeSampleSpace(_type);
end;

function MD_SampleLength(_type: integer; s: PSAMPLE): ULONG;
begin
  if (_type = ord(MD_MUSIC)) then
    if md_mode and DMODE_SOFT_MUSIC <> 0 then _type := ord(MD_SOFTWARE) else _type := ord(MD_HARDWARE)
  else if (_type = ord(MD_SNDFX)) then
    if md_mode and DMODE_SOFT_SNDFX <> 0 then _type := ord(MD_SOFTWARE) else _type := ord(MD_HARDWARE);
  result := md_driver^.RealSampleLength(_type, s);
end;


procedure _mm_registerdriver(drv: PMDRIVER);
var
  cruise            : PMDRIVER;
begin
  cruise := firstdriver;
  //* don't register a MISSING() driver */
  if ((drv^.Name <> nil) and (drv^.Version <> nil)) then
  begin
    if (cruise <> nil) then
    begin
      while (cruise^.next <> nil) do cruise := cruise^.next;
      cruise^.next := drv;
    end else
      firstdriver := drv;
  end;
end;

function MD_SampleLoad(s: PSAMPLOAD; _type: integer): SWORD;
begin
  if (_type = ord(MD_MUSIC)) then
    if md_mode and DMODE_SOFT_MUSIC <> 0 then _type := ord(MD_SOFTWARE) else _type := ord(MD_HARDWARE)
  else if (_type = ord(MD_SNDFX)) then
    if md_mode and DMODE_SOFT_SNDFX <> 0 then _type := ord(MD_SOFTWARE) else _type := ord(MD_HARDWARE);
  SL_Init(s);
  result := md_driver^.SampleLoad(s, _type);
  SL_Exit(s);
end;

procedure MD_SampleUnload(handle: SWORD);
begin
  md_driver^.SampleUnload(handle);
end;

procedure MikMod_Update();
begin
  MUTEX_LOCK(_mm_mutex_vars);
  if (isplaying <> 0) then
  begin
    if ((pf2 = nil) or (pf2^.forbid = 0)) then  {!!!}
      md_driver^.Update()
    else
    begin
      if Assigned(md_driver^.Pause) then
        md_driver^.Pause();
    end;
  end;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Voice_SetVolume_internal(voice: SBYTE; vol: UWORD);
var
  tmp               : ULONG;
begin
  if ((voice < 0) or (voice >= md_numchn)) then exit;
  // * range checks * /
  if (md_musicvolume > 128) then md_musicvolume := 128;
  if (md_sndfxvolume > 128) then md_sndfxvolume := 128;
  if (md_volume > 128) then md_volume := 128;
  if (voice < md_sngchn) then
    tmp := vol * md_volume * md_musicvolume
  else tmp := vol * md_volume * md_sndfxvolume;
  md_driver^.VoiceSetVolume(voice, tmp div 16384);
end;

procedure Voice_SetFrequency_internal(voice: SBYTE; frq: ULONG);
begin
  if ((voice < 0) or (voice >= md_numchn)) then exit;
  if ((PPointerArray(md_sample)[voice] <> nil) and (PSAMPLE(PPointerArray(md_sample)[voice]).divfactor <> 0)) then
    frq := frq div PSAMPLE(PPointerArray(md_sample)[voice]).divfactor;
  md_driver^.VoiceSetFrequency(voice, frq);
end;

procedure Voice_SetPanning_internal(voice: SBYTE; pan: ULONG);
begin
  if ((voice < 0) or (voice >= md_numchn)) then exit;
  if (pan <> PAN_SURROUND) then
  begin
    if (md_pansep > 128) then md_pansep := 128;
    if (md_mode and DMODE_REVERSE) <> 0 then pan := 255 - pan;
    pan := (((SWORD(pan) - 128) * md_pansep) div 128) + 128;
  end;
  md_driver^.VoiceSetPanning(voice, pan);
end;

procedure Voice_Play_internal(voice: SBYTE; s: PSAMPLE; start: ULONG);
var
  repend            : ULONG;
begin
  if ((voice < 0) or (voice >= md_numchn)) then exit;
  PPointerArray(md_sample)[voice] := s;
  repend := s^.loopend;
  if (s^.flags and SF_LOOP) <> 0 then
    // * repend can't be bigger than size */
    if (repend > s^.length) then repend := s^.length;
  md_driver^.VoicePlay(voice, s^.handle, start, s^.length, s^.loopstart, repend, s^.flags);
end;

procedure Voice_Stop_internal(voice: SBYTE);
begin
  if ((voice < 0) or (voice >= md_numchn)) then exit;
  if (voice >= md_sngchn) then
  begin
    //* It is a sound effects channel, so flag the voice as non-critical! */
    PUBYTEARRAY(sfxinfo)[voice - md_sngchn] := 0;
  end;
  md_driver^.VoiceStop(voice);
end;

function Voice_Stopped_internal(voice: SBYTE): BOOL;
begin
  if ((voice < 0) or (voice >= md_numchn)) then
  begin
    result := 0;
    exit;
  end;
  result := md_driver^.VoiceStopped(voice);
end;

procedure MikMod_Exit_internal();
var
  drv1, drv2        : PMDRIVER;
  ldr1, ldr2        : PMLOADER_;
begin
  MikMod_DisableOutput_internal();
  md_driver^.Exit();
  md_sngchn := 0;
  md_sfxchn := 0;
  md_numchn := 0;

  drv1 := firstdriver;

  while drv1 <> nil do
  begin
    drv2 := drv1^.next;
    drv1^.next := nil;
    drv1 := drv2;
  end;

  md_driver := nil;
  firstdriver := nil;

  ldr1 := firstloader;

  while ldr1 <> nil do
  begin
    ldr2 := ldr1.next;
    ldr1^.next := nil;
    ldr1 := ldr2;
  end;

  firstloader := nil;

  if (sfxinfo <> nil) then free(sfxinfo);
  if (md_sample <> nil) then free(md_sample);
  md_sample := nil;
  sfxinfo := nil;

  initialized := 0;

  {drv_win.}vc_tickbuf:=nil;
  {drv_win.}vc_memory:=0;
  {drv_win.}vinf:=nil;
end;

procedure MikMod_Exit();
begin
  MUTEX_LOCK(_mm_mutex_vars);
  MUTEX_LOCK(_mm_mutex_lists);
  MikMod_Exit_internal();
  MUTEX_UNLOCK(_mm_mutex_lists);
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

//* If either parameter is -1, the current set value will be retained. */

function MikMod_SetNumVoices_internal(music: integer; sfx: integer): BOOL;
var
  resume            : BOOl;
  t, oldchn         : integer;

begin
  resume := 0;
  oldchn := 0;

  if ((music = 0) and (sfx = 0)) then
  begin
    result := 1;
    exit;
  end;

  _mm_critical := 1;

  if (isplaying <> 0) then
  begin
    MikMod_DisableOutput_internal();
    oldchn := md_numchn;
    resume := 1;
  end;

  if (sfxinfo <> nil) then free(sfxinfo);
  if (md_sample <> nil) then free(md_sample);
  md_sample := nil;
  sfxinfo := nil;

  if (music <> -1) then md_sngchn := music;
  if (sfx <> -1) then md_sfxchn := sfx;
  md_numchn := md_sngchn + md_sfxchn;

  LimitHardVoices(md_driver^.HardVoiceLimit);
  LimitSoftVoices(md_driver^.SoftVoiceLimit);

  if md_driver^.SetNumVoices() <> 0 then
  begin
    MikMod_Exit_internal();
    //if(_mm_errno)
    //	if(_mm_errorhandler!=NULL) _mm_errorhandler();
    md_numchn := 0;
    md_softchn := 0;
    md_hardchn := 0;
    md_sfxchn := 0;
    md_sngchn := 0;
    result := 1;
    exit;
  end;

  if (md_sngchn + md_sfxchn <> 0) then
    md_sample := _mm_calloc(md_sngchn + md_sfxchn, sizeof(PSAMPLE));
  if (md_sfxchn <> 0) then
    sfxinfo := _mm_calloc(md_sfxchn, sizeof(UBYTE));

  //* make sure the player doesn't start with garbage */
  for t := oldchn to md_numchn - 1 do Voice_Stop_internal(t);

  sfxpool := 0;
  if resume <> 0 then MikMod_EnableOutput_internal();
  _mm_critical := 0;

  result := 0;
end;

function MikMod_EnableOutput_internal(): BOOL;
begin
  _mm_critical := 1;
  if isplaying = 0 then
  begin
    if md_driver^.PlayStart() <> 0 then
    begin
      result := 1;
      exit;
    end;
    isplaying := 1;
  end;
  _mm_critical := 0;
  result := 0;
end;

function MikMod_EnableOutput(): BOOL;
begin
  MUTEX_LOCK(_mm_mutex_vars);
  result := MikMod_EnableOutput_internal();
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure MikMod_DisableOutput_internal();
begin
  if (isplaying <> 0) and (md_driver <> nil) then
  begin
    isplaying := 0;
    md_driver^.PlayStop();
  end;
end;

function MikMod_Active_internal(): BOOL;
begin
  result := isplaying;
end;

function MikMod_Active(): BOOL;
begin
  MUTEX_LOCK(_mm_mutex_vars);
  result := MikMod_Active_internal();
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

function  InitializeMikModEngine : boolean;
begin
//    MikMod_RegisterAllDrivers();
  _mm_registerdriver(@_drv_win);

//    MikMod_RegisterAllLoaders();
  {_mm_registerloader(@_load_mod);
  _mm_registerloader(@_load_s3m);
  _mm_registerloader(@_load_xm);
  _mm_registerloader(@_load_it); }

  //  MikMod_Init();
  _mm_critical := 1;

  md_driver := firstdriver;
  olddevice := md_device;
  if md_driver^.Init() <> 0 then
  begin
    MikMod_Exit_internal();
    result := true;
    exit;
  end;
  initialized := 1;
  _mm_critical := 0;

  //  MikMod_InitThreads();
  result := false;
  if (firstcall <> 0) then
  begin
    firstcall := 0;
    _mm_mutex_lists := CreateMutex(nil, FALSE, 'libmikmod(lists)');
    _mm_mutex_vars  := CreateMutex(nil, FALSE, 'libmikmod(vars)');
    if (_mm_mutex_lists = 0) or (_mm_mutex_vars = 0) then
      result := false
    else
      result := true;
  end;
end;

function getrandom(ceil: integer): integer;
begin
  result := (rand() * ceil) div (RAND_MAX + 1);
end;

//*	New Note Action Scoring System :
//	--------------------------------
//	1)	total-volume (fadevol, chanvol, volume) is the main scorer.
//	2)	a looping sample is a bonus x2
//	3)	a foreground channel is a bonus x4
//	4)	an active envelope with keyoff is a handicap -x2
//*/

function MP_FindEmptyChannel(_mod: PMODULE): integer;
var
  a                 : PMP_VOICE;
  t, k, tvol, pp    : ULONG;
begin
  for t := 0 to md_sngchn - 1 do
    if (((PMP_VOICEARRAY(_mod^.voice)[t].main.kick = KICK_ABSENT) or
      (PMP_VOICEARRAY(_mod^.voice)[t].main.kick = KICK_ENV)) and
      (Voice_Stopped_internal(t) <> 0)) then
    begin
      result := t;
      exit;
    end;

  tvol := $FFFFFF;
  t := 0;
  a := _mod^.voice;
  for k := 0 to md_sngchn - 1 do
  begin
    //* allow us to take over a nonexisting sample */
    if (a^.main.s = nil) then
    begin
      result := k;
      exit;
    end;
    if ((a^.main.kick = KICK_ABSENT) or (a^.main.kick = KICK_ENV)) then
    begin
      pp := a^.totalvol shl InlineIf((a^.main.s^.flags and SF_LOOP <> 0), UBYTE(1), UBYTE(0));
      if ((a^.master <> nil) and (a = a^.master^.slave)) then
        pp := pp shl 2;
      if (pp < tvol) then
      begin
        tvol := pp;
        t := k;
      end;
    end;
    inc(a);
  end;
  if (tvol > 8000 * 7) then
  begin
    result := -1;
    exit;
  end;
  result := t;
end;

function Interpolate(p: SWORD; p1: SWORD; p2: SWORD; v1: SWORD; v2: SWORD): SWORD;
begin
  if ((p1 = p2) or (p = p1)) then
  begin
    result := v1;
    exit;
  end;
  result := v1 + (((p - p1) * (v2 - v1)) div (p2 - p1));
end;

function getlinearperiod(note: UWORD; fine: ULONG): UWORD;
begin
  result := ((20 + 2 * HIGH_OCTAVE) * OCTAVE + 2 - note) * 32 - (fine shr 1);
end;

function getlogperiod(note: UWORD; fine: ULONG): UWORD;
var
  n, o              : UWORD;
  p1, p2            : UWORD;
  i                 : ULONG;
begin
  n := note mod (2 * OCTAVE);
  o := note div (2 * OCTAVE);
  i := (n shl 2) + (fine shr 4);        //* n*8 + fine/16 */
  p1 := logtab[i];
  p2 := logtab[i + 1];
  result := Interpolate(fine shr 4, 0, 15, p1, p2) shr o;
end;

function getoldperiod(note: UWORD; speed: ULONG): UWORD;
var
  n, o              : UWORD;
begin
  //* This happens sometimes on badly converted AMF, and old MOD */
  if (speed = 0) then
  begin
    result := 4242;                     //* <- prevent divide overflow.. (42 hehe) */
    exit;
  end;
  n := note mod (2 * OCTAVE);
  o := note div (2 * OCTAVE);
  result := ((8363 * oldperiods[n]) shr o) div speed;
end;

function GetPeriod(flags: UWORD; note: UWORD; speed: ULONG): UWORD;
begin
  if (flags and UF_XMPERIODS) <> 0 then
  begin
    if (flags and UF_LINEAR) <> 0 then
    begin
      result := getlinearperiod(note, speed);
      exit;
    end
    else
    begin
      result := getlogperiod(note, speed);
      exit;
    end;
  end
  else
    result := getoldperiod(note, speed);
end;

function InterpolateEnv(p: SWORD; a: PENVPT; b: PENVPT): SWORD;
begin
  result := Interpolate(p, a^.pos, b^.pos, a^.val, b^.val);
end;

function DoPan(envpan: SWORD; pan: SWORD): SWORD;
var
  newpan            : integer;
begin
  newpan := pan + (((envpan - PAN_CENTER) * (128 - abs(pan - PAN_CENTER))) div 128);
  if newpan < PAN_LEFT then result := PAN_LEFT
  else if newpan > PAN_RIGHT then result := PAN_RIGHT else result := newpan;
end;

function StartEnvelope(t: PENVPR; flg: UBYTE; pts: UBYTE; susbeg: UBYTE; susend: UBYTE; beg: UBYTE; _end: UBYTE; p: PENVPT; keyoff: UBYTE): SWORD;
begin
  t^.flg := flg;
  t^.pts := pts;
  t^.susbeg := susbeg;
  t^.susend := susend;
  t^.beg := beg;
  t^._end := _end;
  t^.env := p;
  t^.p := 0;
  t^.a := 0;
  if ((t^.flg and EF_SUSTAIN) <> 0) and ((keyoff and KEY_OFF) = 0) then
    t^.b := 0 else t^.b := 1;

  //* Imago Orpheus sometimes stores an extra initial point in the envelope */
  if ((t^.pts >= 2) and (PENVPTARRAY(t^.env)[0].pos = PENVPTARRAY(t^.env)[1].pos)) then
  begin
    inc(t^.a);
    inc(t^.b);
  end;
  //* Fit in the envelope, still */
  if (t^.a >= t^.pts) then
    t^.a := t^.pts - 1;
  if (t^.b >= t^.pts) then
    t^.b := t^.pts - 1;

  result := PENVPTARRAY(t^.env)[t^.a].val;

end;

(* This procedure processes all envelope types, include volume, pitch, and
   panning.  Envelopes are defined by a set of points, each with a magnitude
   [relating either to volume, panning position, or pitch modifier] and a tick
   position.

   Envelopes work in the following manner:

   (a) Each tick the envelope is moved a point further in its progression. For
       an accurate progression, magnitudes between two envelope points are
       interpolated.

   (b) When progression reaches a defined point on the envelope, values are
       shifted to interpolate between this point and the next, and checks for
       loops or envelope end are done.

   Misc:
     Sustain loops are loops that are only active as long as the keyoff flag is
     clear.  When a volume envelope terminates, so does the current fadeout.
*)

function ProcessEnvelope(aout: PMP_VOICE; t: PENVPR; v: SWORD): SWORD;

var

  a, b              : UBYTE;            // actual points in the envelope */
  p                 : UWORD;            // the 'tick counter' - real point being played */

begin
  if (t^.flg and EF_ON <> 0) then
  begin

    a := t^.a;
    b := t^.b;
    p := t^.p;

    //
    // * Sustain loop on one point (XM type).
    // * Not processed if KEYOFF.
    // * Don't move and don't interpolate when the point is reached
    // */
    if ((t^.flg and EF_SUSTAIN <> 0) and (t^.susbeg = t^.susend) and
      ((aout^.main.keyoff and KEY_OFF = 0) and (p = PENVPTARRAY(t^.env)[t^.susbeg].pos))) then
    begin
      v := PENVPTARRAY(t^.env)[t^.susbeg].val;
    end else
    begin
      //
      // * All following situations will require interpolation between
      // * two envelope points.
      // */

      //
      // * Sustain loop between two points (IT type).
      // * Not processed if KEYOFF.
      // */
      // if we were on a loop point, loop now */
      if ((t^.flg and EF_SUSTAIN <> 0) and (aout^.main.keyoff and KEY_OFF = 0) and
        (a >= t^.susend)) then
      begin
        a := t^.susbeg;
        b := InlineIf((t^.susbeg = t^.susend), UBYTE(a), UBYTE(a + 1));
        p := PENVPTARRAY(t^.env)[a].pos;
        v := PENVPTARRAY(t^.env)[a].val;
      end else
        //
        // * Regular loop.
        // * Be sure to correctly handle single point loops.
        // */
        if ((t^.flg and EF_LOOP <> 0) and (a >= t^._end)) then
        begin
          a := t^.beg;
          b := InlineIf((t^.beg = t^._end), UBYTE(a), UBYTE(a + 1));
          p := PENVPTARRAY(t^.env)[a].pos;
          v := PENVPTARRAY(t^.env)[a].val;
        end else
          //
          // * Non looping situations.
          // */
          if (a <> b) then
            v := InterpolateEnv(p, @PENVPTARRAY(t^.env)[a], @PENVPTARRAY(t^.env)[b])
          else
            v := PENVPTARRAY(t^.env)[a].val;

      //
      // * Start to fade if the volume envelope is finished.
      // */
      if (p >= PENVPTARRAY(t^.env)[t^.pts - 1].pos) then
      begin
        if (t^.flg and EF_VOLENV <> 0) then
        begin
          aout^.main.keyoff := aout^.main.keyoff or KEY_FADE;
          if (v = 0) then
            aout^.main.fadevol := 0;
        end;
      end else
      begin
        inc(p);
        // did pointer reach point b? */
        if (p >= PENVPTARRAY(t^.env)[b].pos) then
        begin
          a := b;                       // shift points a and b */
          inc(b);
        end;
      end;
      t^.a := a;
      t^.b := b;
      t^.p := p;
    end;
  end;
  result := v;
end;

/// XM linear period to frequency conversion */

function getfrequency(flags: UWORD; period: ULONG): ULONG;
var
  shift             : SLONG;
begin
  if (flags and UF_LINEAR) <> 0 then
  begin
    shift := (period div 768) - HIGH_OCTAVE;
    if (shift >= 0) then
      result := lintab[period mod 768] shr shift
    else
      result := lintab[period mod 768] shl (-shift);
  end else
    result := (8363 * 1712) div InlineIf((period <> 0), period, 1);
end;

///========== Protracker effects */

procedure DoArpeggio(tick: UWORD; flags: UWORD; a: PMP_CONTROL; style: UBYTE);
var
  note              : UBYTE;
begin
  note := a^.main.note;
  if (a^.arpmem <> 0) then
  begin
    case (style) of
      0:                                /// mod style: N, N+x, N+y */
        begin
          case (tick mod 3) of
            /// case 0: unchanged */
            1: note := note + (a^.arpmem shr 4);
            2: note := note + (a^.arpmem and $F);
          end;
        end;
      3:                                /// okt arpeggio 3: N-x, N, N+y */
        begin
          case (tick mod 3) of
            0: note := note - (a^.arpmem shr 4);
            /// case 1: unchanged */
            2: note := note + (a^.arpmem and $F);
          end;
        end;
      4:                                /// okt arpeggio 4: N, N+y, N, N-x */
        begin
          case (tick mod 4) of
            /// case 0, case 2: unchanged */
            1: note := note + (a^.arpmem and $F);
            3: note := note - (a^.arpmem shr 4);
          end;
        end;
      5:                                /// okt arpeggio 5: N-x, N+y, N, and nothing at tick 0 */
        begin
          if (tick <> 0) then
            case (tick mod 3) of
              /// case 0: unchanged */
              1: note := note - (a^.arpmem shr 4);
              2: note := note + (a^.arpmem and $F);
            end;
        end;
    end;
    a^.main.period := GetPeriod(flags, note shl 1, a^.speed);
    a^.ownper := 1;
  end;
end;

function DoPTEffect0(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat = 0) and ((flags and UF_ARPMEM) <> 0) then
      dat := a^.arpmem else a^.arpmem := dat;
  end;
  if (a^.main.period <> 0) then
    DoArpeggio(tick, flags, a, 0);
  result := 0;
end;

function DoPTEffect1(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) and (dat <> 0) then
    a^.slidespeed := dat shl 2;
  if (a^.main.period <> 0) then
    if (tick <> 0) then
      a^.tmpperiod := a^.tmpperiod - a^.slidespeed;
  result := 0;
end;

function DoPTEffect2(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) and (dat <> 0) then
    a^.slidespeed := dat shl 2;
  if (a^.main.period <> 0) then
    if (tick <> 0) then
      a^.tmpperiod := a^.tmpperiod + a^.slidespeed;
  result := 0;
end;

procedure DoToneSlide(tick: UWORD; a: PMP_CONTROL);
var
  dist              : integer;
begin
  if (a^.main.fadevol = 0) then
    if a^.main.kick = KICK_NOTE then a^.main.kick := KICK_NOTE else a^.main.kick := KICK_KEYOFF
  else
    if a^.main.kick = KICK_NOTE then a^.main.kick := KICK_ENV else a^.main.kick := KICK_ABSENT;
  if (tick <> 0) then
  begin
    /// We have to slide a^.main.period towards a^.wantedperiod, so compute
    //   the difference between those two values */
    dist := a^.main.period - a^.wantedperiod;

    //// if they are equal or if portamentospeed is too big ...*/
    if (dist = 0) or (a^.portspeed > abs(dist)) then
    begin
      /// ...make tmpperiod equal tperiod */
      a^.tmpperiod := a^.wantedperiod;
      a^.main.period := a^.wantedperiod;
    end
    else
      if (dist > 0) then
      begin
        a^.tmpperiod := a^.tmpperiod - a^.portspeed;
        a^.main.period := a^.main.period - a^.portspeed; /// dist>0, slide up */
      end
      else
      begin
        a^.tmpperiod := a^.tmpperiod + a^.portspeed;
        a^.main.period := a^.main.period + a^.portspeed; /// dist<0, slide down */
      end;
  end
  else
    a^.tmpperiod := a^.main.period;
  a^.ownper := 1;
end;

function DoPTEffect3(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) and (dat <> 0) then a^.portspeed := dat shl 2;
  if (a^.main.period <> 0) then
    DoToneSlide(tick, a);
  result := 0;
end;

procedure DoVibrato(tick: UWORD; a: PMP_CONTROL);
var
  q                 : UBYTE;
  temp              : UWORD;
begin
  temp := 0;                            /// silence warning */
  if (tick = 0) then exit;
  q := (a^.vibpos shr 2) and $1F;
  case (a^.wavecontrol and 3) of
    0:                                  /// sine */
      temp := VibratoTable[q];
    1:                                  /// ramp down */
      begin
        q := q shl 3;
        if (a^.vibpos < 0) then q := 255 - q;
        temp := q;
      end;
    2:                                  /// square wave */
      temp := 255;
    3:                                  /// random wave */
      temp := getrandom(256);
  end;
  temp := temp * a^.vibdepth;
  temp := temp shr 7;
  temp := temp shl 2;
  if (a^.vibpos >= 0) then
    a^.main.period := a^.tmpperiod + temp
  else
    a^.main.period := a^.tmpperiod - temp;
  a^.ownper := 1;
  if (tick <> 0) then
    a^.vibpos := a^.vibpos + a^.vibspd;
end;

function DoPTEffect4(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat and $0F) <> 0 then a^.vibdepth := dat and $F;
    if (dat and $F0) <> 0 then a^.vibspd := (dat and $F0) shr 2;
  end;
  if (a^.main.period <> 0) then
    DoVibrato(tick, a);
  result := 0;
end;

procedure DoVolSlide(a: PMP_CONTROL; dat: UBYTE);
begin
  if (dat and $F) <> 0 then
  begin
    a^.tmpvolume := a^.tmpvolume - (dat and $0F);
    if (a^.tmpvolume < 0) then
      a^.tmpvolume := 0;
  end else
  begin
    a^.tmpvolume := a^.tmpvolume + (dat shr 4);
    if (a^.tmpvolume > 64) then
      a^.tmpvolume := 64;
  end;
end;

function DoPTEffect5(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (a^.main.period <> 0) then
    DoToneSlide(tick, a);
  if (tick <> 0) then
    DoVolSlide(a, dat);
  result := 0;
end;

/// DoPTEffect6 after DoPTEffectA */

function DoPTEffect7(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
  q                 : UBYTE;
  temp              : UWORD;            /// silence warning */
begin
  temp := 0;                            /// silence warning */
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat and $0F) <> 0 then a^.trmdepth := dat and $F;
    if (dat and $F0) <> 0 then a^.trmspd := (dat and $F0) shr 2;
  end;
  if (a^.main.period <> 0) then
  begin
    q := (a^.trmpos shr 2) and $1F;
    case ((a^.wavecontrol shr 4) and 3) of
      0:                                /// sine */
        temp := VibratoTable[q];
      1:                                /// ramp down */
        begin
          q := q shl 3;
          if (a^.trmpos < 0) then q := 255 - q;
          temp := q;
        end;
      2:                                /// square wave */
        temp := 255;
      3:                                /// random wave */
        temp := getrandom(256);
    end;
    temp := temp * a^.trmdepth;
    temp := temp shr 6;
    if (a^.trmpos >= 0) then
    begin
      a^.volume := a^.tmpvolume + temp;
      if (a^.volume > 64) then a^.volume := 64;
    end else
    begin
      a^.volume := a^.tmpvolume - temp;
      if (a^.volume < 0) then a^.volume := 0;
    end;
    a^.ownvol := 1;
    if (tick <> 0) then
      a^.trmpos := a^.trmpos + a^.trmspd;
  end;
  result := 0;
end;

function DoPTEffect8(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if _mod^.panflag <> 0 then
  begin
    a^.main.panning := dat;
    _mod^.panning[channel] := dat;
  end;
  result := 0;
end;

function DoPTEffect9(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat <> 0) then a^.soffset := dat shl 8;
    a^.main.start := a^.hioffset or a^.soffset;
    if (a^.main.s <> nil) and (a^.main.start > a^.main.s^.length) then
      if a^.main.s^.flags and (SF_LOOP or SF_BIDI) <> 0 then
        a^.main.start := a^.main.s^.loopstart else a^.main.start := a^.main.s^.length;
  end;
  result := 0;
end;

function DoPTEffectA(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick <> 0) then
    DoVolSlide(a, dat);
  result := 0;
end;

function DoPTEffect6(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  if (a^.main.period <> 0) then
    DoVibrato(tick, a);
  DoPTEffectA(tick, flags, a, _mod, channel);
  result := 0;
end;

function DoPTEffectB(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick <> 0) and (_mod^.patdly2 <> 0) then
  begin
    result := 0;
    exit;
  end;
  /// Vincent Voois uses a nasty trick in "Universal Bolero" */
  if (dat = _mod^.sngpos) and (_mod^.patbrk = _mod^.patpos) then
  begin
    result := 0;
    exit;
  end;
  if (_mod^.loop = 0) and (_mod^.patbrk = 0)
    and ((dat < _mod^.sngpos)
    or ((_mod^.sngpos = (_mod^.numpos - 1))
    and (_mod^.patbrk = 0))
    or ((dat = _mod^.sngpos) and ((flags and UF_NOWRAP) <> 0))) then
  begin
    /// if we don't loop, better not to skip the end of the
    //   pattern, after all... so:
    //mod^.patbrk=0; */
    _mod^.posjmp := 3;
  end else
  begin
    /// if we were fading, adjust... */
    if (_mod^.sngpos = (_mod^.numpos - 1)) then
//      if _mod^.initvolume > 128 then
  //      _mod^.volume := 128 else _mod^.volume := _mod^.initvolume;
        _mod^.volume := _mod^.initvolume + RaznVolume;
    _mod^.sngpos := dat;
    _mod^.posjmp := 2;
    _mod^.patpos := 0;
  end;
  result := 0;
end;

function DoPTEffectC(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick <> 0) then
  begin
    result := 0;
    exit;
  end;
  if (dat = UBYTE(-1)) then
  begin
    a^.anote := 0;
    dat := 0;
  end                                   /// note cut */
  else if (dat > 64) then dat := 64;
  a^.tmpvolume := dat;
  result := 0;
end;

function DoPTEffectD(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;

begin
  dat := UniGetByte();
  if ((tick <> 0) or (_mod^.patdly2 <> 0)) then
  begin
    result := 0;
    exit;
  end;

  if ((PUWORDARRAY(_mod^.positions)[_mod^.sngpos] <> LAST_PATTERN) and
    (dat > PUWORDARRAY(_mod^.pattrows)[PUWORDARRAY(_mod^.positions)[_mod^.sngpos]])) then
    dat := PUWORDARRAY(_mod^.pattrows)[PUWORDARRAY(_mod^.positions)[_mod^.sngpos]];

  _mod^.patbrk := dat;
  if (_mod^.posjmp = 0) then
  begin
    (* don't ask me to explain this code - it makes
       backwards.s3m and children.xm (heretic's version) play
       correctly, among others. Take that for granted, or write
       the page of comments yourself... you might need some
       aspirin - Miod *)

    if (_mod^.sngpos = _mod^.numpos - 1) and (dat <> 0) and ((_mod^.loop <> 0) or
      ((PUWORDARRAY(_mod^.positions)[_mod^.sngpos] = (_mod^.numpat - 1))
      and (flags and UF_NOWRAP = 0))) then
    begin
      _mod^.sngpos := 0;
      _mod^.posjmp := 2;
    end else
      _mod^.posjmp := 3;
  end;
  result := 0;
end;

procedure DoEEffects(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE;
  channel: SWORD; dat: UBYTE);
var
  nib               : UBYTE;
begin
  nib := dat and $F;
  case (dat shr 4) of
    $0: ;                               /// hardware filter toggle, not supported */
    $1:                                 /// fineslide up */
      if (a^.main.period <> 0) then
        if (tick = 0) then
          a^.tmpperiod := a^.tmpperiod - (nib shl 2);
    $2:                                 /// fineslide dn */
      if (a^.main.period <> 0) then
        if (tick = 0) then
          a^.tmpperiod := a^.tmpperiod + (nib shl 2);
    $3:                                 /// glissando ctrl */
      a^.glissando := nib;
    $4:                                 /// set vibrato waveform */
      begin
        a^.wavecontrol := a^.wavecontrol and $F0;
        a^.wavecontrol := a^.wavecontrol or nib;
      end;
    $5:                                 /// set finetune */
      if (a^.main.period <> 0) then
      begin
        if (flags and UF_XMPERIODS <> 0) then
          a^.speed := nib + 128
        else
          a^.speed := finetune[nib];
        a^.tmpperiod := GetPeriod(flags, a^.main.note shl 1, a^.speed);
      end;
    $6:                                 /// set patternloop */
      if (tick = 0) then
        if (nib <> 0) then              /// set reppos or repcnt ? */
        begin
          /// set repcnt, so check if repcnt already is set, which means we
          //   are already looping */
          if (a^.pat_repcnt <> 0) then
            dec(a^.pat_repcnt)          /// already looping, decrease counter */
          else
          begin
            (*#if 0
                // this would make walker.xm, shipped with Xsoundtracker,
                   play correctly, but it's better to remain compatible
                   with FT2 */
                if ((!(flags&UF_NOWRAP))||(a^.pat_reppos!=POS_NONE))
            #endif*)
            a^.pat_repcnt := nib;       /// not yet looping, so set repcnt */
          end;
          if (a^.pat_repcnt <> 0) then  /// jump to reppos if repcnt>0 */
          begin
            if (a^.pat_reppos = POS_NONE) then
              a^.pat_reppos := _mod^.patpos - 1;
            if (a^.pat_reppos = -1) then
            begin
              _mod^.pat_repcrazy := 1;
              _mod^.patpos := 0;
            end else
              _mod^.patpos := a^.pat_reppos;
          end else a^.pat_reppos := POS_NONE;
        end else
          a^.pat_reppos := _mod^.patpos - 1; /// set reppos - can be (-1) */
    $7:                                 /// set tremolo waveform */
      begin
        a^.wavecontrol := a^.wavecontrol and $0F;
        a^.wavecontrol := a^.wavecontrol or nib shl 4;
      end;
    $8:                                 /// set panning */
      if (_mod^.panflag <> 0) then
      begin
        if (nib <= 8) then nib := nib shl 4
        else nib := nib * 17;

        a^.main.panning := nib;
        _mod^.panning[channel] := nib;
      end;
    $9:                                 /// retrig note */
      /// do not retrigger on tick 0, until we are emulating FT2 and effect
      //   data is zero */
      if (tick = 0) and not (((flags and UF_FT2QUIRKS) <> 0) and (nib = 0)) then
      else
        /// only retrigger if data nibble > 0, or if tick 0 (FT2 compat) */
        if (nib <> 0) and (tick = 0) then
        begin
          if (a^.retrig = 0) then
          begin
            /// when retrig counter reaches 0, reset counter and restart
            //   the sample */
            if (a^.main.period <> 0) then a^.main.kick := KICK_NOTE;
            a^.retrig := nib;
          end;
          dec(a^.retrig);               /// countdown */
        end;
    $A:                                 /// fine volume slide up */
      if (tick = 0) then
      begin
        a^.tmpvolume := a^.tmpvolume + nib;
        if (a^.tmpvolume > 64) then a^.tmpvolume := 64;
      end;
    $B:                                 /// fine volume slide dn  */
      if (tick = 0) then
      begin
        a^.tmpvolume := a^.tmpvolume - nib;
        if (a^.tmpvolume < 0) then a^.tmpvolume := 0;
      end;
    $C:                                 /// cut note */
      /// When tick reaches the cut-note value, turn the volume to
      //   zero (just like on the amiga) */
      if (tick >= nib) then
        a^.tmpvolume := 0;              /// just turn the volume down */
    $D:                                 /// note delay */
      /// delay the start of the sample until tick==nib */
      if (tick = 0) then
        a^.main.notedelay := nib
      else if (a^.main.notedelay <> 0) then
        dec(a^.main.notedelay);
    $E:                                 /// pattern delay */
      if (tick = 0) then
        if (_mod^.patdly2 = 0) then
          _mod^.patdly := nib + 1;      /// only once, when tick=0 */
    $F: ;                               /// invert loop, not supported  */
  end;
end;

function DoPTEffectE(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  DoEEffects(tick, flags, a, _mod, channel, UniGetByte());
  result := 0;
end;

function DoPTEffectF(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick <> 0) or (_mod^.patdly2 <> 0) then
  begin
    result := 0;
    exit;
  end;
  if (_mod^.extspd <> 0) and (dat >= _mod^.bpmlimit) then
  begin
    _mod^.bpm := dat;
    //IsTemp(dat, '1');
  end
  else
    if (dat <> 0) then
    begin
      if (dat >= _mod^.bpmlimit) then
        _mod^.sngspd := _mod^.bpmlimit - 1 else _mod^.sngspd := dat;
      _mod^.vbtick := 0;
    end;
  result := 0;
end;

///========== Scream Tracker effects */

function DoS3MEffectA(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  speed             : UBYTE;
begin
  speed := UniGetByte();
  if (tick <> 0) or (_mod^.patdly2 <> 0) then
  begin
    result := 0;
    exit;
  end;
  if (speed > 128) then
    speed := speed - 128;
  if (speed <> 0) then
  begin
    _mod^.sngspd := speed;
    _mod^.vbtick := 0;
  end;
  result := 0;
end;

procedure DoS3MVolSlide(tick: UWORD; flags: UWORD; a: PMP_CONTROL; inf: UBYTE);
var
  lo, hi            : UBYTE;
begin
  if (inf <> 0) then a^.s3mvolslide := inf
  else inf := a^.s3mvolslide;
  lo := inf and $F;
  hi := inf shr 4;
  if (lo = 0) then
  begin
    if (tick <> 0) or ((flags and UF_S3MSLIDES) <> 0) then a^.tmpvolume := a^.tmpvolume + hi;
  end else
    if (hi = 0) then
    begin
      if (tick <> 0) or ((flags and UF_S3MSLIDES) <> 0) then a^.tmpvolume := a^.tmpvolume - lo;
    end else
      if (lo = $F) then
      begin
        if (tick = 0) then
          if hi <> 0 then a^.tmpvolume := a^.tmpvolume + hi else a^.tmpvolume := a^.tmpvolume + $F;
      end else
        if (hi = $F) then
        begin
          if (tick = 0) then
            if lo <> 0 then a^.tmpvolume := a^.tmpvolume - lo else a^.tmpvolume := a^.tmpvolume - $F;
        end else
          exit;
  if (a^.tmpvolume < 0) then
    a^.tmpvolume := 0
  else if (a^.tmpvolume > 64) then
    a^.tmpvolume := 64;
end;

function DoS3MEffectD(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  DoS3MVolSlide(tick, flags, a, UniGetByte());
  result := 1;
end;

procedure DoS3MSlideDn(tick: UWORD; a: PMP_CONTROL; inf: UBYTE);
var
  hi, lo            : UBYTE;
begin
  if (inf <> 0) then
    a^.slidespeed := inf
  else
    inf := a^.slidespeed;
  hi := inf shr 4;
  lo := inf and $F;
  if (hi = $F) then
  begin
    if (tick = 0) then a^.tmpperiod := a^.tmpperiod + lo shl 2;
  end else
    if (hi = $E) then
    begin
      if (tick = 0) then a^.tmpperiod := a^.tmpperiod + lo;
    end else
    begin
      if (tick <> 0) then a^.tmpperiod := a^.tmpperiod + inf shl 2;
    end;
end;

function DoS3MEffectE(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (a^.main.period <> 0) then
    DoS3MSlideDn(tick, a, dat);
  result := 0;
end;

procedure DoS3MSlideUp(tick: UWORD; a: PMP_CONTROL; inf: UBYTE);
var
  hi, lo            : UBYTE;
begin
  if (inf <> 0) then a^.slidespeed := inf
  else inf := a^.slidespeed;
  hi := inf shr 4;
  lo := inf and $F;
  if (hi = $F) then
  begin
    if (tick = 0) then a^.tmpperiod := a^.tmpperiod - lo shl 2;
  end else
    if (hi = $E) then
    begin
      if (tick = 0) then a^.tmpperiod := a^.tmpperiod - lo;
    end else
    begin
      if (tick <> 0) then a^.tmpperiod := a^.tmpperiod - inf shl 2;
    end;
end;

function DoS3MEffectF(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (a^.main.period <> 0) then
    DoS3MSlideUp(tick, a, dat);
  result := 0;
end;

function DoS3MEffectI(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf, _on, off     : UBYTE;
begin
  inf := UniGetByte();
  if (inf <> 0) then
    a^.s3mtronof := inf
  else
  begin
    inf := a^.s3mtronof;
    if (inf = 0) then
    begin
      result := 0;
      exit;
    end;
  end;
  if (tick = 0) then
  begin
    result := 0;
    exit;
  end;
  _on := (inf shr 4) + 1;
  off := (inf and $F) + 1;
  a^.s3mtremor := a^.s3mtremor mod (_on + off);
  if a^.s3mtremor < _on then
    a^.volume := a^.tmpvolume else a^.volume := 0;
  a^.ownvol := 1;
  inc(a^.s3mtremor);
  result := 0;
end;

function DoS3MEffectQ(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf               : UBYTE;
begin
  inf := UniGetByte();
  if (a^.main.period <> 0) then
  begin
    if (inf <> 0) then
    begin
      a^.s3mrtgslide := inf shr 4;
      a^.s3mrtgspeed := inf and $F;
    end;
    /// only retrigger if low nibble > 0 */
    if (a^.s3mrtgspeed > 0) then
    begin
      if (a^.retrig = 0) then
      begin
        /// when retrig counter reaches 0, reset counter and restart the
        //   sample */
        if (a^.main.kick <> KICK_NOTE) then a^.main.kick := KICK_KEYOFF;
        a^.retrig := a^.s3mrtgspeed;
        if (tick <> 0) or ((flags and UF_S3MSLIDES) <> 0) then
        begin
          case (a^.s3mrtgslide) of
            1: ;
            2: ;
            3: ;
            4: ;
            5: a^.tmpvolume := a^.tmpvolume - (1 shl (a^.s3mrtgslide - 1));
            6: a^.tmpvolume := (2 * a^.tmpvolume) div 3;
            7: a^.tmpvolume := a^.tmpvolume shr 1;
            9: ;
            $A: ;
            $B: ;
            $C: ;
            $D: a^.tmpvolume := a^.tmpvolume + (1 shl (a^.s3mrtgslide - 9));
            $E: a^.tmpvolume := (3 * a^.tmpvolume) shr 1;
            $F: a^.tmpvolume := a^.tmpvolume shl 1;
          end;
          if (a^.tmpvolume < 0) then
            a^.tmpvolume := 0
          else if (a^.tmpvolume > 64) then
            a^.tmpvolume := 64;
        end;
      end;
      dec(a^.retrig);                   /// countdown  */
    end;
  end;
  result := 0;
end;

function DoS3MEffectR(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat, q            : UBYTE;
  temp              : UWORD;
begin
  temp := 0;                            /// silence warning */
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat and $0F) <> 0 then a^.trmdepth := dat and $F;
    if (dat and $F0) <> 0 then a^.trmspd := (dat and $F0) shr 2;
  end;
  q := (a^.trmpos shr 2) and $1F;
  case ((a^.wavecontrol shr 4) and 3) of
    0:                                  /// sine */
      temp := VibratoTable[q];
    1:                                  /// ramp down */
      begin
        q := q shl 3;
        if (a^.trmpos < 0) then q := 255 - q;
        temp := q;
      end;
    2:                                  /// square wave */
      temp := 255;
    3:                                  /// random */
      temp := getrandom(256);
  end;
  temp := temp * a^.trmdepth;
  temp := temp shr 7;
  if (a^.trmpos >= 0) then
  begin
    a^.volume := a^.tmpvolume + temp;
    if (a^.volume > 64) then a^.volume := 64;
  end else
  begin
    a^.volume := a^.tmpvolume - temp;
    if (a^.volume < 0) then a^.volume := 0;
  end;
  a^.ownvol := 1;
  if (tick <> 0) then
    a^.trmpos := a^.trmpos + a^.trmspd;
  result := 0;
end;

function DoS3MEffectT(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  tempo             : integer;
begin
  tempo := UniGetByte() + raznTemp;
  if (tick <> 0) or (_mod^.patdly2 <> 0) then
  begin
    result := 0;
    exit;
  end;

     if tempo < 32  then tempo := 32;
     if tempo > 255 then tempo := 255;
    _mod^.bpm := tempo;

  result := 0;
end;

function DoS3MEffectU(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat, q            : UBYTE;
  temp              : UWORD;
begin
  temp := 0;                            /// silence warning */
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat and $0F) <> 0 then a^.vibdepth := dat and $F;
    if (dat and $F0) <> 0 then a^.vibspd := (dat and $F0) shr 2;
  end else
    if (a^.main.period <> 0) then
    begin
      q := (a^.vibpos shr 2) and $1F;
      case (a^.wavecontrol and 3) of
        0:                              /// sine */
          temp := VibratoTable[q];
        1:                              /// ramp down */
          begin
            q := q shl 3;
            if (a^.vibpos < 0) then q := 255 - q;
            temp := q;
          end;
        2:                              /// square wave */
          temp := 255;
        3:                              /// random */
          temp := getrandom(256);
      end;
      temp := temp * a^.vibdepth;
      temp := temp shr 8;
      if (a^.vibpos >= 0) then
        a^.main.period := a^.tmpperiod + temp
      else
        a^.main.period := a^.tmpperiod - temp;
      a^.ownper := 1;
      a^.vibpos := a^.vibpos + a^.vibspd;
    end;
  result := 0;
end;

///========== Envelope helpers */

function DoKeyOff(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  a^.main.keyoff := a^.main.keyoff or KEY_OFF;
  if ((a^.main.volflg and EF_ON) = 0) or ((a^.main.volflg and EF_LOOP) <> 0) then
    a^.main.keyoff := KEY_KILL;
  result := 0;
end;

function DoKeyFade(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick >= dat) or (tick = _mod^.sngspd - 1) then
  begin
    a^.main.keyoff := KEY_KILL;
    if (a^.main.volflg and EF_ON) = 0 then
      a^.main.fadevol := 0;
  end;
  result := 0;
end;

///========== Fast Tracker effects */

/// DoXMEffect6 after DoXMEffectA */

function DoXMEffectA(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf, lo, hi       : UBYTE;
begin
  inf := UniGetByte();
  if (inf <> 0) then
    a^.s3mvolslide := inf
  else
    inf := a^.s3mvolslide;
  if (tick <> 0) then
  begin
    lo := inf and $F;
    hi := inf shr 4;
    if (hi = 0) then
    begin
      a^.tmpvolume := a^.tmpvolume - lo;
      if (a^.tmpvolume < 0) then a^.tmpvolume := 0;
    end else
    begin
      a^.tmpvolume := a^.tmpvolume + hi;
      if (a^.tmpvolume > 64) then a^.tmpvolume := 64;
    end;
  end;
  result := 0;
end;

function DoXMEffect6(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  if (a^.main.period <> 0) then
    DoVibrato(tick, a);

  result := DoXMEffectA(tick, flags, a, _mod, channel);
end;

function DoXMEffectE1(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat <> 0) then a^.fportupspd := dat;
    if (a^.main.period <> 0) then
      a^.tmpperiod := a^.tmpperiod - (a^.fportupspd shl 2);
  end;
  result := 0;
end;

function DoXMEffectE2(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat <> 0) then a^.fportdnspd := dat;
    if (a^.main.period <> 0) then
      a^.tmpperiod := a^.tmpperiod + (a^.fportdnspd shl 2);
  end;
  result := 0;
end;

function DoXMEffectEA(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) then
    if (dat <> 0) then a^.fslideupspd := dat;
  a^.tmpvolume := a^.tmpvolume + a^.fslideupspd;
  if (a^.tmpvolume > 64) then a^.tmpvolume := 64;
  result := 0;
end;

function DoXMEffectEB(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (tick = 0) then
    if (dat <> 0) then a^.fslidednspd := dat;
  a^.tmpvolume := a^.tmpvolume - a^.fslidednspd;
  if (a^.tmpvolume < 0) then a^.tmpvolume := 0;
  result := 0;
end;

function DoXMEffectG(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  _mod^.volume := RaznVolume + UniGetByte() shl 1;
  if (_mod^.volume < 0  ) then _mod^.volume := 0
  else
  if (_mod^.volume > 128) then _mod^.volume := 128;
  result := 0;
end;

function DoXMEffectH(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf               : UBYTE;
begin
  inf := UniGetByte();
  if (tick <> 0) then
  begin
    if (inf <> 0) then _mod^.globalslide := inf
    else inf := _mod^.globalslide;
    if (inf and $F0) <> 0 then inf := inf and $F0;
    _mod^.volume := _mod^.volume + ((inf shr 4) - (inf and $F)) * 2;
    if (_mod^.volume < 0) then
      _mod^.volume := 0
    else if (_mod^.volume > 128) then
      _mod^.volume := 128;
  end;
  result := 0;
end;

function DoXMEffectL(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
  points            : UWORD;
  i                 : PINSTRUMENT;
  aout              : PMP_VOICE;
begin
  dat := UniGetByte();
  if (tick = 0) and (a^.main.i <> nil) then
  begin
    i := a^.main.i;
    aout := a^.slave;
    if (aout <> nil) then
    begin
      if (aout^.venv.env <> nil) then
      begin
        points := i^.volenv[i^.volpts - 1].pos;
        aout^.venv.p := PENVPTARRAY(aout^.venv.env)[Integer(InLineIf((dat > points), points, dat))].pos;
      end;

      if (aout^.penv.env <> nil) then
      begin
        points := i^.panenv[i^.panpts - 1].pos;
        aout^.penv.p := PENVPTARRAY(aout^.penv.env)[Integer(InLineIf((dat > points), points, dat))].pos;
      end;

    end;
  end;
  result := 0;
end;

function DoXMEffectP(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf, lo, hi       : UBYTE;
  pan               : SWORD;
begin
  inf := UniGetByte();
  if _mod^.panflag = 0 then
  begin
    result := 0;
    exit;
  end;
  if (inf <> 0) then
    a^.pansspd := inf
  else
    inf := a^.pansspd;
  if (tick <> 0) then
  begin
    lo := inf and $F;
    hi := inf shr 4;
    /// slide right has absolute priority */
    if (hi <> 0) then
      lo := 0;
    if a^.main.panning = PAN_SURROUND then
      pan := (PAN_CENTER) + hi - lo else pan := (a^.main.panning) + hi - lo;
    if pan < PAN_LEFT then
      a^.main.panning := PAN_LEFT
    else if pan > PAN_RIGHT then a^.main.panning := PAN_RIGHT else a^.main.panning := pan;
  end;
  result := 0;
end;

function DoXMEffectX1(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (dat <> 0) then
    a^.ffportupspd := dat
  else
    dat := a^.ffportupspd;
  if (a^.main.period <> 0) then
    if (tick = 0) then
    begin
      a^.main.period := a^.main.period - dat;
      a^.tmpperiod := a^.tmpperiod - dat;
      a^.ownper := 1;
    end;
  result := 0;
end;

function DoXMEffectX2(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat               : UBYTE;
begin
  dat := UniGetByte();
  if (dat <> 0) then
    a^.ffportdnspd := dat
  else
    dat := a^.ffportdnspd;
  if (a^.main.period <> 0) then
    if (tick = 0) then
    begin
      a^.main.period := a^.main.period + dat;
      a^.tmpperiod := a^.tmpperiod + dat;
      a^.ownper := 1;
    end;
  result := 0;
end;

///========== Impulse Tracker effects */

procedure DoITToneSlide(tick: UWORD; a: PMP_CONTROL; dat: UBYTE);
var
  dist              : integer;
begin
  if (dat <> 0) then
    a^.portspeed := dat;
  /// if we don't come from another note, ignore the slide and play the note
  //   as is */
  if (a^.oldnote = 0) or (a^.main.period = 0) then
    exit;
  if (tick = 0) and (a^.newsamp <> 0) then
  begin
    a^.main.kick := KICK_NOTE;
    a^.main.start := -1;
  end else
    if a^.main.kick = KICK_NOTE then
      a^.main.kick := KICK_ENV else a^.main.kick := KICK_ABSENT;
  if (tick <> 0) then
  begin
    /// We have to slide a^.main.period towards a^.wantedperiod, compute the
    //	   difference between those two values */
    dist := a^.main.period - a^.wantedperiod;
    /// if they are equal or if portamentospeed is too big... */
    if (dist = 0) or ((a^.portspeed shl 2) > abs(dist)) then
    begin
      /// ... make tmpperiod equal tperiod */
      a^.tmpperiod := a^.wantedperiod;
      a^.main.period := a^.wantedperiod;
    end
    else
      if (dist > 0) then
      begin
        a^.tmpperiod := a^.tmpperiod - a^.portspeed shl 2;
        a^.main.period := a^.main.period - a^.portspeed shl 2; /// dist>0 slide up */
      end else
      begin
        a^.tmpperiod := a^.tmpperiod + a^.portspeed shl 2;
        a^.main.period := a^.main.period + a^.portspeed shl 2; /// dist<0 slide down */
      end;
  end
  else
    a^.tmpperiod := a^.main.period;
  a^.ownper := 1;
end;

function DoITEffectG(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  DoITToneSlide(tick, a, UniGetByte());
  result := 0;
end;

procedure DoITVibrato(tick: UWORD; a: PMP_CONTROL; dat: UBYTE);
var
  q                 : UBYTE;
  temp              : UWORD;
begin
  temp := 0;
  if (tick = 0) then
  begin
    if (dat and $0F) <> 0 then a^.vibdepth := dat and $F;
    if (dat and $F0) <> 0 then a^.vibspd := (dat and $F0) shr 2;
  end;
  if (a^.main.period = 0) then
    exit;
  q := (a^.vibpos shr 2) and $1F;
  case (a^.wavecontrol and 3) of
    0:                                  /// sine */
      temp := VibratoTable[q];
    1:                                  /// square wave */
      temp := 255;
    2:                                  /// ramp down */
      begin
        q := q shl 3;
        if (a^.vibpos < 0) then q := 255 - q;
        temp := q;
      end;
    3:                                  /// random */
      temp := getrandom(256);
  end;
  temp := temp * a^.vibdepth;
  temp := temp shr 8;
  temp := temp shl 2;
  if (a^.vibpos >= 0) then
    a^.main.period := a^.tmpperiod + temp
  else
    a^.main.period := a^.tmpperiod - temp;
  a^.ownper := 1;
  a^.vibpos := a^.vibpos + a^.vibspd;
end;

function DoITEffectH(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  DoITVibrato(tick, a, UniGetByte());
  result := 0;
end;

function DoITEffectI(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf, _on, off     : UBYTE;
begin
  inf := UniGetByte();
  if (inf <> 0) then
    a^.s3mtronof := inf
  else
  begin
    inf := a^.s3mtronof;
    if (inf = 0) then
    begin
      result := 0;
      exit
    end;
  end;
  _on := (inf shr 4);
  off := (inf and $F);
  a^.s3mtremor := a^.s3mtremor mod (_on + off);
  if a^.s3mtremor < _on then
    a^.volume := a^.tmpvolume else a^.volume := 0;
  a^.ownvol := 1;
  inc(a^.s3mtremor);
  result := 0;
end;

function DoITEffectM(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  a^.main.chanvol := UniGetByte();
  if (a^.main.chanvol > 64) then
    a^.main.chanvol := 64
  else if (a^.main.chanvol < 0) then
    a^.main.chanvol := 0;
  result := 0;
end;

function DoITEffectN(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf, lo, hi       : UBYTE;
begin
  inf := UniGetByte();
  if (inf <> 0) then
    a^.chanvolslide := inf
  else
    inf := a^.chanvolslide;
  lo := inf and $F;
  hi := inf shr 4;
  if (hi = 0) then
    a^.main.chanvol := a^.main.chanvol - lo
  else
    if (lo = 0) then
    begin
      a^.main.chanvol := a^.main.chanvol + hi;
    end else
      if (hi = $F) then
      begin
        if (tick = 0) then a^.main.chanvol := a^.main.chanvol - lo;
      end else
        if (lo = $F) then
        begin
          if (tick = 0) then a^.main.chanvol := a^.main.chanvol + hi;
        end;
  if (a^.main.chanvol < 0) then
    a^.main.chanvol := 0
  else if (a^.main.chanvol > 64) then
    a^.main.chanvol := 64;
  result := 0;
end;

function DoITEffectP(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf, lo, hi       : UBYTE;
  pan               : SWORD;
begin
  inf := UniGetByte();
  if (inf <> 0) then
    a^.pansspd := inf
  else
    inf := a^.pansspd;
  if _mod^.panflag = 0 then
  begin
    result := 0;
    exit;
  end;
  lo := inf and $F;
  hi := inf shr 4;
  if a^.main.panning = PAN_SURROUND then
    pan := PAN_CENTER else pan := a^.main.panning;
  if (hi = 0) then
    pan := pan + lo shl 2
  else if (lo = 0) then
  begin
    pan := pan - hi shl 2;
  end else
    if (hi = $F) then
    begin
      if (tick = 0) then pan := pan + lo shl 2;
    end else
      if (lo = $F) then
        if (tick = 0) then pan := pan - hi shl 2;
  if pan < PAN_LEFT then
    a^.main.panning := PAN_LEFT else if pan > PAN_RIGHT then a^.main.panning := PAN_RIGHT else a^.main.panning := pan;
  result := 0;
end;

function DoITEffectT(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  tempo             : UBYTE;
  temp              : SWORD;
begin
  tempo := UniGetByte();
  if (_mod^.patdly2 <> 0) then
  begin
    result := 0;
    exit;
  end;
  temp := _mod^.bpm;
  if (tempo and $10) <> 0 then
    temp := temp + (tempo and $0F)
  else
    temp := temp - tempo;
  if temp > 255 then
    _mod^.bpm := 255 else if temp < 1 then _mod^.bpm := 1 else _mod^.bpm := temp;

 // IsTemp(temp, '3');  
  result := 0;
end;

function DoITEffectU(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat, q            : UBYTE;
  temp              : UWORD;
begin
  temp := 0;                            /// silence warning */
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat and $0F) <> 0 then a^.vibdepth := dat and $F;
    if (dat and $F0) <> 0 then a^.vibspd := (dat and $F0) shr 2;
  end;
  if (a^.main.period <> 0) then
  begin
    q := (a^.vibpos shr 2) and $1F;
    case (a^.wavecontrol and 3) of
      0:                                /// sine */
        temp := VibratoTable[q];
      1:                                /// square wave */
        temp := 255;
      2:                                /// ramp down */
        begin
          q := q shl 3;
          if (a^.vibpos < 0) then q := 255 - q;
          temp := q;
        end;
      3:                                /// random */
        temp := getrandom(256);
    end;
    temp := temp * a^.vibdepth;
    temp := temp shr 8;
    if (a^.vibpos >= 0) then
      a^.main.period := a^.tmpperiod + temp
    else
      a^.main.period := a^.tmpperiod - temp;
    a^.ownper := 1;
    a^.vibpos := a^.vibpos + a^.vibspd;
  end;

  result := 0;
end;

function DoITEffectW(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  inf, lo, hi       : UBYTE;

begin

  inf := UniGetByte();

  if (inf <> 0) then
    _mod^.globalslide := inf
  else
    inf := _mod^.globalslide;

  lo := inf and $F;
  hi := inf shr 4;

  if (lo = 0) then
  begin
    if (tick <> 0) then _mod^.volume := _mod^.volume + hi;
  end else
    if (hi = 0) then
    begin
      if (tick <> 0) then _mod^.volume := _mod^.volume - lo;
    end else
      if (lo = $F) then
      begin
        if (tick = 0) then _mod^.volume := _mod^.volume + hi;
      end else
        if (hi = $F) then
        begin
          if (tick = 0) then _mod^.volume := _mod^.volume - lo;
        end;

  if (_mod^.volume < 0) then
    _mod^.volume := 0
  else if (_mod^.volume > 128) then
    _mod^.volume := 128;
  result := 0;
end;

function DoITEffectY(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat, q            : UBYTE;
  temp              : SLONG;
begin
  temp := 0;                            /// silence warning */
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat and $0F) <> 0 then a^.panbdepth := (dat and $F);
    if (dat and $F0) <> 0 then a^.panbspd := (dat and $F0) shr 4;
  end;
  if _mod^.panflag <> 0 then
  begin
    q := a^.panbpos;
    case (a^.panbwave) of
      0:                                /// sine */
        temp := PanbrelloTable[q];
      1:                                /// square wave */
        if q < $80 then temp := 64 else temp := 0;
      2:                                /// ramp down */
        begin
          q := q shl 3;
          temp := q;
        end;
      3:                                /// random */
        temp := getrandom(256);
    end;
    temp := temp * a^.panbdepth;
    temp := (temp div 8) + _mod^.panning[channel];
    if (temp < PAN_LEFT) then
      a^.main.panning := PAN_LEFT else if temp > PAN_RIGHT then
      a^.main.panning := PAN_RIGHT else a^.main.panning := temp;
    a^.panbpos := a^.panbpos + a^.panbspd;
  end;
  result := 0;
end;

/// Impulse/Scream Tracker Sxx effects.
//   All Sxx effects share the same memory space. */

function DoITEffectS0(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat, inf, c       : UBYTE;
begin
  dat := UniGetByte();
  inf := dat and $F;
  c := dat shr 4;
  if (dat = 0) then
  begin
    c := a^.sseffect;
    inf := a^.ssdata;
  end else
  begin
    a^.sseffect := c;
    a^.ssdata := inf;
  end;
  case extsound_fx(c) of
    SS_GLISSANDO:                       /// S1x set glissando voice */
      DoEEffects(tick, flags, a, _mod, channel, $30 or inf);
    SS_FINETUNE:                        /// S2x set finetune */
      DoEEffects(tick, flags, a, _mod, channel, $50 or inf);
    SS_VIBWAVE:                         /// S3x set vibrato waveform */
      DoEEffects(tick, flags, a, _mod, channel, $40 or inf);
    SS_TREMWAVE:                        /// S4x set tremolo waveform */
      DoEEffects(tick, flags, a, _mod, channel, $70 or inf);
    SS_PANWAVE:                         /// S5x panbrello */
      a^.panbwave := inf;
    SS_FRAMEDELAY:                      // S6x delay x number of frames (patdly) */
      DoEEffects(tick, flags, a, _mod, channel, $E0 or inf);
    SS_S7EFFECTS:                       /// S7x instrument / NNA commands */
      DoNNAEffects(_mod, a, inf);
    SS_PANNING:                         /// S8x set panning position */
      DoEEffects(tick, flags, a, _mod, channel, $80 or inf);
    SS_SURROUND:                        /// S9x set surround sound */
      if _mod^.panflag <> 0 then
      begin
        a^.main.panning := PAN_SURROUND;
        _mod^.panning[channel] := PAN_SURROUND;
      end;
    SS_HIOFFSET:                        /// SAy set high order sample offset yxx00h */
      if (tick = 0) then
      begin
        a^.hioffset := inf shl 16;
        a^.main.start := a^.hioffset or a^.soffset;
        if (a^.main.s <> nil) and (a^.main.start > a^.main.s^.length) then
          if (a^.main.s^.flags and (SF_LOOP or SF_BIDI)) <> 0 then
            a^.main.start := a^.main.s^.loopstart else
            a^.main.start := a^.main.s^.length;
      end;
    SS_PATLOOP:                         /// SBx pattern loop */
      DoEEffects(tick, flags, a, _mod, channel, $60 or inf);
    SS_NOTECUT:                         /// SCx notecut */
      begin
        if (inf = 0) then inf := 1;
        DoEEffects(tick, flags, a, _mod, channel, $C0 or inf);
      end;
    SS_NOTEDELAY:                       /// SDx notedelay */
      DoEEffects(tick, flags, a, _mod, channel, $D0 or inf);
    SS_PATDELAY:                        /// SEx patterndelay */
      DoEEffects(tick, flags, a, _mod, channel, $E0 or inf);
  end;
  result := 0;
end;

///========== Impulse Tracker Volume/Pan Column effects */

// * All volume/pan column effects share the same memory space.

function DoVolEffects(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  c, inf            : UBYTE;
begin
  c := UniGetByte();
  inf := UniGetByte();
  if (c = 0) and (inf = 0) then
  begin
    c := a^.voleffect;
    inf := a^.voldata;
  end else
  begin
    a^.voleffect := c;
    a^.voldata := inf;
  end;
  if (c <> 0) then
    case itcol_fx(c) of
      VOL_VOLUME:
        if (tick = 0) then
        begin
          if (inf > 64) then inf := 64;
          a^.tmpvolume := inf;
        end;
      VOL_PANNING:
        if _mod^.panflag <> 0 then
          a^.main.panning := inf;
      VOL_VOLSLIDE:
        DoS3MVolSlide(tick, flags, a, inf);
      VOL_PITCHSLIDEDN:
        if (a^.main.period <> 0) then
          DoS3MSlideDn(tick, a, inf);
      VOL_PITCHSLIDEUP:
        if (a^.main.period <> 0) then
          DoS3MSlideUp(tick, a, inf);
      VOL_PORTAMENTO:
        DoITToneSlide(tick, a, inf);
      VOL_VIBRATO:
        DoITVibrato(tick, a, inf);
    end;
  result := 0;
end;

///========== UltraTracker effects */

function DoULTEffect9(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  offset            : UWORD;
begin
  offset := UniGetWord();
  if (offset <> 0) then
    a^.ultoffset := offset;
  a^.main.start := a^.ultoffset shl 2;
  if (a^.main.s <> nil) and (a^.main.start > a^.main.s^.length) then
    if a^.main.s^.flags and (SF_LOOP or SF_BIDI) <> 0 then
      a^.main.start := a^.main.s^.loopstart
    else a^.main.start := a^.main.s^.length;
  result := 0;
end;

///========== OctaMED effects */

function DoMEDSpeed(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  speed             : UWORD;
begin
  speed := UniGetWord();
  _mod^.bpm := speed;
  //IsTemp(speed, '4');
  result := 0;
end;

function DoMEDEffectF1(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  DoEEffects(tick, flags, a, _mod, channel, $90 or (_mod^.sngspd div 2));
  result := 0;
end;

function DoMEDEffectF2(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  DoEEffects(tick, flags, a, _mod, channel, $D0 or (_mod^.sngspd div 2));
  result := 0;
end;

function DoMEDEffectF3(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  DoEEffects(tick, flags, a, _mod, channel, $90 or (_mod^.sngspd div 3));
  result := 0;
end;

///========== Oktalyzer effects */

function DoOktArp(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
var
  dat, dat2         : UBYTE;
begin
  dat2 := UniGetByte();                 /// arpeggio style */
  dat := UniGetByte();
  if (tick = 0) then
  begin
    if (dat = 0) and ((flags and UF_ARPMEM) <> 0) then
      dat := a^.arpmem
    else
      a^.arpmem := dat;
  end;
  if (a^.main.period <> 0) then
    DoArpeggio(tick, flags, a, dat2);
  result := 0;
end;

///========== General player functions */

function DoNothing(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;
begin
  UniSkipOpcode();
  result := 0;
end;

type
  effect_func = function(tick: UWORD; flags: UWORD; a: PMP_CONTROL; _mod: PMODULE; channel: SWORD): integer;

var
  effects           : array[0..ord(UNI_LAST) - 1] of effect_func =
    (
    DoNothing,                          /// 0 */
    DoNothing,                          /// UNI_NOTE */
    DoNothing,                          /// UNI_INSTRUMENT */
    DoPTEffect0,                        /// UNI_PTEFFECT0 */
    DoPTEffect1,                        /// UNI_PTEFFECT1 */
    DoPTEffect2,                        /// UNI_PTEFFECT2 */
    DoPTEffect3,                        /// UNI_PTEFFECT3 */
    DoPTEffect4,                        /// UNI_PTEFFECT4 */
    DoPTEffect5,                        /// UNI_PTEFFECT5 */
    DoPTEffect6,                        /// UNI_PTEFFECT6 */
    DoPTEffect7,                        /// UNI_PTEFFECT7 */
    DoPTEffect8,                        /// UNI_PTEFFECT8 */
    DoPTEffect9,                        /// UNI_PTEFFECT9 */
    DoPTEffectA,                        /// UNI_PTEFFECTA */
    DoPTEffectB,                        /// UNI_PTEFFECTB */
    DoPTEffectC,                        /// UNI_PTEFFECTC */
    DoPTEffectD,                        /// UNI_PTEFFECTD */
    DoPTEffectE,                        /// UNI_PTEFFECTE */
    DoPTEffectF,                        /// UNI_PTEFFECTF */
    DoS3MEffectA,                       /// UNI_S3MEFFECTA */
    DoS3MEffectD,                       /// UNI_S3MEFFECTD */
    DoS3MEffectE,                       /// UNI_S3MEFFECTE */
    DoS3MEffectF,                       /// UNI_S3MEFFECTF */
    DoS3MEffectI,                       /// UNI_S3MEFFECTI */
    DoS3MEffectQ,                       /// UNI_S3MEFFECTQ */
    DoS3MEffectR,                       /// UNI_S3MEFFECTR */
    DoS3MEffectT,                       /// UNI_S3MEFFECTT */
    DoS3MEffectU,                       /// UNI_S3MEFFECTU */
    DoKeyOff,                           /// UNI_KEYOFF */
    DoKeyFade,                          /// UNI_KEYFADE */
    DoVolEffects,                       /// UNI_VOLEFFECTS */
    DoPTEffect4,                        /// UNI_XMEFFECT4 */
    DoXMEffect6,                        /// UNI_XMEFFECT6 */
    DoXMEffectA,                        /// UNI_XMEFFECTA */
    DoXMEffectE1,                       /// UNI_XMEFFECTE1 */
    DoXMEffectE2,                       /// UNI_XMEFFECTE2 */
    DoXMEffectEA,                       /// UNI_XMEFFECTEA */
    DoXMEffectEB,                       /// UNI_XMEFFECTEB */
    DoXMEffectG,                        /// UNI_XMEFFECTG */
    DoXMEffectH,                        /// UNI_XMEFFECTH */
    DoXMEffectL,                        /// UNI_XMEFFECTL */
    DoXMEffectP,                        /// UNI_XMEFFECTP */
    DoXMEffectX1,                       /// UNI_XMEFFECTX1 */
    DoXMEffectX2,                       /// UNI_XMEFFECTX2 */
    DoITEffectG,                        /// UNI_ITEFFECTG */
    DoITEffectH,                        /// UNI_ITEFFECTH */
    DoITEffectI,                        /// UNI_ITEFFECTI */
    DoITEffectM,                        /// UNI_ITEFFECTM */
    DoITEffectN,                        /// UNI_ITEFFECTN */
    DoITEffectP,                        /// UNI_ITEFFECTP */
    DoITEffectT,                        /// UNI_ITEFFECTT */
    DoITEffectU,                        /// UNI_ITEFFECTU */
    DoITEffectW,                        /// UNI_ITEFFECTW */
    DoITEffectY,                        /// UNI_ITEFFECTY */
    DoNothing,                          /// UNI_ITEFFECTZ */
    DoITEffectS0,                       /// UNI_ITEFFECTS0 */
    DoULTEffect9,                       /// UNI_ULTEFFECT9 */
    DoMEDSpeed,                         /// UNI_MEDSPEED */
    DoMEDEffectF1,                      /// UNI_MEDEFFECTF1 */
    DoMEDEffectF2,                      /// UNI_MEDEFFECTF2 */
    DoMEDEffectF3,                      /// UNI_MEDEFFECTF3 */
    DoOktArp                            /// UNI_OKTARP */
    );

function pt_playeffects(_mod: PMODULE; channel: SWORD; a: PMP_CONTROL): integer;
var
  tick              : UWORD;
  flags             : UWORD;
  c                 : UBYTE;
  explicitslides    : integer;
  f                 : effect_func;
begin
  tick := _mod^.vbtick;
  flags := _mod^.flags;
  explicitslides := 0;
  c := UniGetByte();
  while (c <> 0) do
  begin
    f := effects[c];
    if (@f <> @DoNothing) then a^.sliding := 0;
    explicitslides := explicitslides or f(tick, flags, a, _mod, channel);
    c := UniGetByte();
  end;
  result := explicitslides;
end;

procedure DoNNAEffects(_mod: PMODULE; a: PMP_CONTROL; dat: UBYTE);
var
  t                 : integer;
  aout              : PMP_VOICE;
begin
  dat := dat and $F;
  if a^.slave <> nil then
    aout := a^.slave else aout := nil;
  case (dat) of
    $0:                                 /// past note cut */
      for t := 0 to md_sngchn - 1 do
        if (PMP_VOICEARRAY(_mod^.voice)[t].master = a) then
          PMP_VOICEARRAY(_mod^.voice)[t].main.fadevol := 0;
    $1:                                 /// past note off */
      for t := 0 to md_sngchn - 1 do
        if (PMP_VOICEARRAY(_mod^.voice)[t].master = a) then
        begin
          PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff := PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff or KEY_OFF;
          if ((PMP_VOICEARRAY(_mod^.voice)[t].venv.flg and EF_ON) = 0) or ((PMP_VOICEARRAY(_mod^.voice)[t].venv.flg and EF_LOOP) <> 0) then
            PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff := KEY_KILL;
        end;
    $2:                                 /// past note fade */
      for t := 0 to md_sngchn - 1 do
        if (PMP_VOICEARRAY(_mod^.voice)[t].master = a) then
          PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff := PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff or KEY_FADE;
    $3:                                 /// set NNA note cut */
      a^.main.nna := (a^.main.nna and (not NNA_MASK)) or NNA_CUT;
    $4:                                 /// set NNA note continue */
      a^.main.nna := (a^.main.nna and (not NNA_MASK)) or NNA_CONTINUE;
    $5:                                 /// set NNA note off */
      a^.main.nna := (a^.main.nna and (not NNA_MASK)) or NNA_OFF;
    $6:                                 /// set NNA note fade */
      a^.main.nna := (a^.main.nna and (not NNA_MASK)) or NNA_FADE;
    $7:                                 /// disable volume envelope */
      if (aout <> nil) then
        aout^.main.volflg := aout^.main.volflg and (not EF_ON);
    $8:                                 /// enable volume envelope  */
      if (aout <> nil) then
        aout^.main.volflg := aout^.main.volflg or EF_ON;
    $9:                                 /// disable panning envelope */
      if (aout <> nil) then
        aout^.main.panflg := aout^.main.panflg and (not EF_ON);
    $A:                                 /// enable panning envelope */
      if (aout <> nil) then
        aout^.main.panflg := aout^.main.panflg or EF_ON;
    $B:                                 /// disable pitch envelope */
      if (aout <> nil) then
        aout^.main.pitflg := aout^.main.pitflg and (not EF_ON);
    $C:                                 /// enable pitch envelope */
      if (aout <> nil) then
        aout^.main.pitflg := aout^.main.pitflg or EF_ON;
  end;

end;

procedure pt_UpdateVoices(const _mod: PMODULE; max_volume: integer);
var
  envpan, envvol, envpit, channel: SWORD;
  playperiod        : UWORD;
  vibval, vibdpt    : SLONG;
  tmpvol            : ULONG;
  aout              : PMP_VOICE;
  i                 : PINSTRUMENT;
  s                 : PSAMPLE;
  p1                : integer;
begin
  _mod^.totalchn := 0;
  _mod^.realchn := 0;
  for channel := 0 to md_sngchn - 1 do
  begin
    aout := @PMP_VOICEARRAY(_mod^.voice)[channel];
    i := aout^.main.i;
    s := aout^.main.s;
    if (s = nil) or (s^.length = 0) then continue;
    if (aout^.main.period < 40) then
      aout^.main.period := 40
    else if (aout^.main.period > 50000) then
      aout^.main.period := 50000;
    if (aout^.main.kick = KICK_NOTE) or (aout^.main.kick = KICK_KEYOFF) then
    begin
      Voice_Play_internal(channel, s, InlineIf((aout^.main.start = -1),
        InlineIf((s^.flags and SF_UST_LOOP <> 0), SLONG(s^.loopstart), SLONG(0)), SLONG(aout^.main.start)));

      aout^.main.fadevol := 32768;
      aout^.aswppos := 0;
    end;
    envvol := 256;
    envpan := PAN_CENTER;
    envpit := 32;
    if (i <> nil) and ((aout^.main.kick = KICK_NOTE) or (aout^.main.kick = KICK_ENV)) then
    begin
      if (aout^.main.volflg and EF_ON) <> 0 then
        envvol := StartEnvelope(@aout^.venv, aout^.main.volflg,
          i^.volpts, i^.volsusbeg, i^.volsusend,
          i^.volbeg, i^.volend,
          @i^.volenv,
          aout^.main.keyoff);
      if (aout^.main.panflg and EF_ON) <> 0 then
        envpan := StartEnvelope(@aout^.penv, aout^.main.panflg,
          i^.panpts, i^.pansusbeg, i^.pansusend,
          i^.panbeg, i^.panend,
          @i^.panenv,
          aout^.main.keyoff);
      if (aout^.main.pitflg and EF_ON) <> 0 then
        envpit := StartEnvelope(@aout^.cenv, aout^.main.pitflg,
          i^.pitpts, i^.pitsusbeg, i^.pitsusend,
          i^.pitbeg, i^.pitend,
          @i^.pitenv,
          aout^.main.keyoff);
      if (aout^.cenv.flg and EF_ON) <> 0 then
        aout^.masterperiod := GetPeriod(_mod^.flags,
          aout^.main.note shl 1, aout^.master^.speed);
    end else
    begin
      if (aout^.main.volflg and EF_ON) <> 0 then
        envvol := ProcessEnvelope(aout, @aout^.venv, 256);
      if (aout^.main.panflg and EF_ON) <> 0 then
        envpan := ProcessEnvelope(aout, @aout^.penv, PAN_CENTER);
      if (aout^.main.pitflg and EF_ON) <> 0 then
        envpit := ProcessEnvelope(aout, @aout^.cenv, 32);
    end;
    aout^.main.kick := KICK_ABSENT;
    tmpvol := aout^.main.fadevol;       /// max 32768 */
    tmpvol := tmpvol * aout^.main.chanvol; /// * max 64 */
    tmpvol := tmpvol * aout^.main.outvolume; /// * max 256 */
    tmpvol := tmpvol div (256 * 64);    /// tmpvol is max 32768 again */
    aout^.totalvol := tmpvol shr 2;     /// used to determine samplevolume */
    tmpvol := tmpvol * envvol;          /// * max 256 */
    tmpvol := tmpvol * _mod^.volume;    /// * max 128 */
    tmpvol := tmpvol div (128 * 256 * 128);
    /// fade out */
    if (_mod^.sngpos >= _mod^.numpos) then
      tmpvol := 0
    else
      tmpvol := (tmpvol * max_volume) div 128;

    if (aout^.masterchn <> -1) and (PMP_CONTROLARRAY(_mod^.control)[aout^.masterchn].muted <> 0) then
      Voice_SetVolume_internal(channel, 0)
    else
    begin
      Voice_SetVolume_internal(channel, tmpvol);
      if (tmpvol <> 0) and (aout^.master <> nil) and (aout^.master^.slave = aout) then
        inc(_mod^.realchn);
      inc(_mod^.totalchn);
    end;

    if (aout^.main.panning = PAN_SURROUND) then
      Voice_SetPanning_internal(channel, PAN_SURROUND)
    else
      if (_mod^.panflag <> 0) and ((aout^.penv.flg and EF_ON) <> 0) then
        Voice_SetPanning_internal(channel,
          DoPan(envpan, aout^.main.panning))
      else
        Voice_SetPanning_internal(channel, aout^.main.panning);
    if (aout^.main.period <> 0) and (s^.vibdepth <> 0) then
      case (s^.vibtype) of
        0:
          begin
            vibval := avibtab[s^.avibpos and 127];
            if (aout^.avibpos and $80) <> 0 then vibval := -vibval;
          end;
        1:
          begin
            vibval := 64;
            if (aout^.avibpos and $80) <> 0 then vibval := -vibval;
          end;
        2:
          vibval := 63 - (((aout^.avibpos + 128) and 255) shr 1);
      else
        vibval := (((aout^.avibpos + 128) and 255) shr 1) - 64;
      end
    else
      vibval := 0;
    if (s^.vibflags and AV_IT) <> 0 then
    begin
      if ((aout^.aswppos shr 8) < s^.vibdepth) then
      begin
        aout^.aswppos := aout^.aswppos + s^.vibsweep;
        vibdpt := aout^.aswppos;
      end else
        vibdpt := s^.vibdepth shl 8;
      vibval := (vibval * vibdpt) shr 16;
      if (aout^.mflag <> 0) then
      begin
        if ((_mod^.flags and UF_LINEAR) = 0) then vibval := vibval shr 1;
        aout^.main.period := aout^.main.period - vibval;
      end;
    end else
    begin
      /// do XM style auto-vibrato */
      if ((aout^.main.keyoff and KEY_OFF) = 0) then
      begin
        if (aout^.aswppos < s^.vibsweep) then
        begin
          vibdpt := (aout^.aswppos * s^.vibdepth) div s^.vibsweep;
          inc(aout^.aswppos);
        end else
          vibdpt := s^.vibdepth;
      end else
      begin
        /// keyoff ^. depth becomes 0 if final depth wasn't reached or
        //  stays at final level if depth WAS reached */
        if (aout^.aswppos >= s^.vibsweep) then
          vibdpt := s^.vibdepth
        else
          vibdpt := 0;
      end;
      vibval := (vibval * vibdpt) shr 8;
      aout^.main.period := aout^.main.period - vibval;
    end;
    /// update vibrato position */
    aout^.avibpos := (aout^.avibpos + s^.vibrate) and $FF;
    /// process pitch envelope */
    playperiod := aout^.main.period;
    if ((aout^.main.pitflg and EF_ON) <> 0) and (envpit <> 32) then
    begin
      envpit := envpit - 32;
      if ((aout^.main.note shl 1) + envpit <= 0) then envpit := -(aout^.main.note shl 1);
      p1 := GetPeriod(_mod^.flags, (aout^.main.note shl 1) + envpit,
        aout^.master^.speed) - aout^.masterperiod;
      if (p1 > 0) then
      begin
        if ((playperiod + p1) <= playperiod) then
        begin
          p1 := 0;
          aout^.main.keyoff := aout^.main.keyoff or KEY_OFF;
        end;
      end else if (p1 < 0) then
      begin
        if ((playperiod + p1) >= playperiod) then
        begin
          p1 := 0;
          aout^.main.keyoff := aout^.main.keyoff or KEY_OFF;
        end;
      end;
      playperiod := playperiod + p1;
    end;
    if (aout^.main.fadevol = 0) then    /// check for a dead note (fadevol=0) */
    begin
      Voice_Stop_internal(channel);
      dec(_mod^.totalchn);
      if (tmpvol <> 0) and (aout^.master <> nil) and (aout^.master^.slave = aout) then
        dec(_mod^.realchn);
    end else
    begin
      Voice_SetFrequency_internal(channel,
        getfrequency(_mod^.flags, playperiod));
      /// if keyfade, start substracting fadeoutspeed from fadevol: */
      if (i <> nil) and ((aout^.main.keyoff and KEY_FADE) <> 0) then
      begin
        if (aout^.main.fadevol >= i^.volfade) then
          aout^.main.fadevol := aout^.main.fadevol - i^.volfade
        else
          aout^.main.fadevol := 0;
      end;
    end;
    md_bpm := _mod^.bpm + _mod^.relspd;
    if (md_bpm < 32) then
      md_bpm := 32
    else if ((_mod^.flags and UF_HIGHBPM) = 0) and (md_bpm > 255) then
      md_bpm := 255;
  end;
end;

/// Handles new notes or instruments */

procedure pt_Notes(const _mod: PMODULE);
var
  channel           : SWORD;
  a                 : PMP_CONTROL;
  c, inst           : UBYTE;
  tr, funky         : integer;          /// funky is set to indicate note or instrument change */
  i                 : PINSTRUMENT;
  s                 : PSAMPLE;
begin
  for channel := 0 to _mod^.numchn - 1 do
  begin
    a := @PMP_CONTROLARRAY(_mod^.control)[channel];
    if (_mod^.sngpos >= _mod^.numpos) then
    begin
      tr := _mod^.numtrk;
      _mod^.numrow := 0;
    end else
    begin
      tr := PUWORDARRAY(_mod^.patterns)[(PUWORDARRAY(_mod^.positions)[_mod^.sngpos] * _mod^.numchn) + channel];
      _mod^.numrow := PUWORDARRAY(_mod^.pattrows)[PUWORDARRAY(_mod^.positions)[_mod^.sngpos]];
    end;
    if tr < _mod^.numtrk then a^.row := UniFindRow(PPointerArray(_mod^.tracks)[tr], _mod^.patpos)
    else a^.row := nil;
    a^.newsamp := 0;

    if (_mod^.vbtick = 0) then a^.main.notedelay := 0;
    if (a^.row = nil) then continue;
    UniSetRow(a^.row);
    funky := 0;
    c := UniGetByte();
    while (c <> 0) do
    begin
      case uni_fx(c) of
        UNI_NOTE:
          begin
            funky := funky or 1;
            a^.oldnote := a^.anote;
            a^.anote := UniGetByte();
            a^.main.kick := KICK_NOTE;
            a^.main.start := -1;
            a^.sliding := 0;
            /// retrig tremolo and vibrato waves ? */
            if ((a^.wavecontrol and $80) = 0) then a^.trmpos := 0;
            if ((a^.wavecontrol and $08) = 0) then a^.vibpos := 0;
            if (a^.panbwave = 0) then a^.panbpos := 0;
          end;
        UNI_INSTRUMENT:
          begin
            inst := UniGetByte();
            if (inst >= _mod^.numins) then /// safety valve */
            else
            begin
              funky := funky or 2;
              if (_mod^.flags and UF_INST) <> 0 then a^.main.i := @PINSTRUMENTARRAY(_mod^.instruments)[inst]
              else a^.main.i := nil;
              a^.retrig := 0;
              a^.s3mtremor := 0;
              a^.ultoffset := 0;
              a^.main.sample := inst;
            end;
          end;
      else
        UniSkipOpcode();
      end;
      c := UniGetByte();
    end;
    if (funky <> 0) then
    begin
      s := nil;
      i := a^.main.i;
      if (i <> nil) then
      begin
        if (i^.samplenumber[a^.anote] >= _mod^.numsmp) then continue;
        s := @PSAMPLEARRAY(_mod^.samples)[i^.samplenumber[a^.anote]];
        a^.main.note := i^.samplenote[a^.anote];
      end else
      begin
        a^.main.note := a^.anote;
        s := @PSAMPLEARRAY(_mod^.samples)[a^.main.sample];
      end;
      if (a^.main.s <> s) then
      begin
        a^.main.s := s;
        a^.newsamp := a^.main.period;
      end;
      /// channel or instrument determined panning ? */
      a^.main.panning := _mod^.panning[channel];
      if (s^.flags and SF_OWNPAN) <> 0 then
        a^.main.panning := s^.panning
      else if (i <> nil) and ((i^.flags and IF_OWNPAN) <> 0) then
        a^.main.panning := i^.panning;

      a^.main.handle := s^.handle;
      a^.speed := s^.speed;
      if (i <> nil) then
      begin
        if (_mod^.panflag <> 0) and ((i^.flags and IF_PITCHPAN) <> 0)
          and (a^.main.panning <> PAN_SURROUND) then
        begin
          a^.main.panning := a^.main.panning +
            ((a^.anote - i^.pitpancenter) * i^.pitpansep) div 8;
          if (a^.main.panning < PAN_LEFT) then
            a^.main.panning := PAN_LEFT
          else if (a^.main.panning > PAN_RIGHT) then
            a^.main.panning := PAN_RIGHT;
        end;
        a^.main.pitflg := i^.pitflg;
        a^.main.volflg := i^.volflg;
        a^.main.panflg := i^.panflg;
        a^.main.nna := i^.nnatype;
        a^.dca := i^.dca;
        a^.dct := i^.dct;
      end else
      begin
        a^.main.pitflg := 0;
        a^.main.volflg := 0;
        a^.main.panflg := 0;
        a^.main.nna := 0;
        a^.dca := 0;
        a^.dct := DCT_OFF;
      end;
      if (funky and 2) <> 0 then        /// instrument change */
      begin
        /// IT random volume variations: 0:8 bit fixed, and one bit for
         //  sign. */
        a^.volume := s^.volume;
        a^.tmpvolume := s^.volume;
        if (s <> nil) and (i <> nil) then
        begin
          if (i^.rvolvar <> 0) then
          begin
            a^.tmpvolume := s^.volume +
              ((s^.volume * (i^.rvolvar * getrandom(512)
              )) div 25600);
            a^.volume := a^.tmpvolume;
            if (a^.volume < 0) then
            begin
              a^.volume := 0;
              a^.tmpvolume := 0;
            end
            else if (a^.volume > 64) then
            begin
              a^.volume := 64;
              a^.tmpvolume := 64;
            end;
          end;
          if (_mod^.panflag <> 0) and (a^.main.panning <> PAN_SURROUND) then
          begin
            a^.main.panning := a^.main.panning + ((a^.main.panning * (i^.rpanvar *
              getrandom(512))) div 25600);
            if (a^.main.panning < PAN_LEFT) then
              a^.main.panning := PAN_LEFT
            else if (a^.main.panning > PAN_RIGHT) then
              a^.main.panning := PAN_RIGHT;
          end;
        end;
      end;
      a^.tmpperiod := GetPeriod(_mod^.flags, a^.main.note shl 1, a^.speed);
      a^.wantedperiod := a^.tmpperiod;
      a^.main.keyoff := KEY_KICK;
    end;
  end;
end;

/// Handles effects */

procedure pt_EffectsPass1(const _mod: PMODULE);
var
  channel           : SWORD;
  a                 : PMP_CONTROL;
  aout              : PMP_VOICE;
  explicitslides    : integer;
begin
  for channel := 0 to _mod^.numchn - 1 do
  begin
    a := @PMP_CONTROLARRAY(_mod^.control)[channel];
    aout := a^.slave;
    if (aout <> nil) then
    begin
      a^.main.fadevol := aout^.main.fadevol;
      a^.main.period := aout^.main.period;
      if (a^.main.kick = KICK_KEYOFF) then
        a^.main.keyoff := aout^.main.keyoff;
    end;
    if (a^.row = nil) then continue;
    UniSetRow(a^.row);
    a^.ownper := 0;
    a^.ownvol := 0;
    explicitslides := pt_playeffects(_mod, channel, a);
    /// continue volume slide if necessary for XM and IT */
    if (_mod^.flags and UF_BGSLIDES) <> 0 then
    begin
      if (explicitslides = 0) and (a^.sliding <> 0) then
        DoS3MVolSlide(_mod^.vbtick, _mod^.flags, a, 0)
      else if (a^.tmpvolume <> 0) then
        a^.sliding := explicitslides;
    end;
    if (a^.ownper = 0) then
      a^.main.period := a^.tmpperiod;
    if (a^.ownvol = 0) then
      a^.volume := a^.tmpvolume;
    if (a^.main.s <> nil) then
    begin
      if (a^.main.i <> nil) then
        a^.main.outvolume :=
          (a^.volume * a^.main.s^.globvol * a^.main.i^.globvol) shr 10
      else
        a^.main.outvolume := (a^.volume * a^.main.s^.globvol) shr 4;
      if (a^.main.outvolume > 256) then
        a^.main.outvolume := 256
      else if (a^.main.outvolume < 0) then
        a^.main.outvolume := 0;
    end;
  end;
end;

/// NNA management */

procedure pt_NNA(const _mod: PMODULE);
var
  channel           : SWORD;
  a                 : PMP_CONTROL;
  aout              : PMP_VOICE;
  kill              : integer;
  t                 : integer;
begin       
  for channel := 0 to _mod^.numchn - 1 do
  begin
    a := @PMP_CONTROLARRAY(_mod^.control)[channel];
    if (a^.main.kick = KICK_NOTE) then
    begin
      kill := 0;
      if (a^.slave <> nil) then
      begin
        aout := a^.slave;
        if (aout^.main.nna and NNA_MASK) <> 0 then
        begin
          /// Make sure the old MP_VOICE channel knows it has no
           //  master now ! */
          a^.slave := nil;
          /// assume the channel is taken by NNA */
          aout^.mflag := 0;
          case (aout^.main.nna) of
            NNA_CONTINUE:               /// continue note, do nothing */
              ;
            NNA_OFF:                    /// note off */
              begin
                aout^.main.keyoff := aout^.main.keyoff or KEY_OFF;
                if ((aout^.main.volflg and EF_ON) = 0) or
                  ((aout^.main.volflg and EF_LOOP) <> 0) then
                  aout^.main.keyoff := KEY_KILL;
              end;
            NNA_FADE:
              aout^.main.keyoff := aout^.main.keyoff or KEY_FADE;
          end;
        end;
      end;
      if (a^.dct <> DCT_OFF) then
      begin
        for t := 0 to md_sngchn - 1 do
        begin
          if (Voice_Stopped_internal(t) = 0) and
            (PMP_VOICEARRAY(_mod^.voice)[t].masterchn = channel) and
            (a^.main.sample = PMP_VOICEARRAY(_mod^.voice)[t].main.sample) then
          begin
            kill := 0;
            case (a^.dct) of
              DCT_NOTE:
                if (a^.main.note = PMP_VOICEARRAY(_mod^.voice)[t].main.note) then
                  kill := 1;
              DCT_SAMPLE:
                if (a^.main.handle = PMP_VOICEARRAY(_mod^.voice)[t].main.handle) then
                  kill := 1;
              DCT_INST:
                kill := 1;
            end;
            if (kill <> 0) then
              case (a^.dca) of
                DCA_CUT:
                  PMP_VOICEARRAY(_mod^.voice)[t].main.fadevol := 0;
                DCA_OFF:
                  begin
                    PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff := PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff or KEY_OFF;
                    if ((PMP_VOICEARRAY(_mod^.voice)[t].main.volflg and EF_ON) = 0) or
                      ((PMP_VOICEARRAY(_mod^.voice)[t].main.volflg and EF_LOOP) <> 0) then
                      PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff := KEY_KILL;

                  end;
                DCA_FADE:
                  PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff := PMP_VOICEARRAY(_mod^.voice)[t].main.keyoff or KEY_FADE;
              end;
          end;

        end;
      end;
    end;                                /// if (a^.main.kick==KICK_NOTE) */
  end;
end;

/// Setup module and NNA voices */

procedure pt_SetupVoices(const _mod: PMODULE);
var
  channel           : SWORD;
  a                 : PMP_CONTROL;
  aout              : PMP_VOICE;
  newchn            : integer;

begin

  for channel := 0 to _mod^.numchn - 1 do
  begin

    a := @PMP_CONTROLARRAY(_mod^.control)[channel];

    if (a^.main.notedelay <> 0) then continue;
    if (a^.main.kick = KICK_NOTE) then
    begin
      /// if no channel was cut above, find an empty or quiet channel
      //   here */
      if (_mod^.flags and UF_NNA) <> 0 then
      begin
        if (a^.slave = nil) then
        begin
          newchn := MP_FindEmptyChannel(_mod);
          if newchn <> -1 then
          begin

            a^.slavechn := newchn;
            a^.slave := @PMP_VOICEARRAY(_mod^.voice)[a^.slavechn];
          end;
        end;
      end else
      begin
        a^.slavechn := channel;
        a^.slave := @PMP_VOICEARRAY(_mod^.voice)[a^.slavechn];
      end;
      /// assign parts of MP_VOICE only done for a KICK_NOTE */
      aout := a^.slave;
      if (aout <> nil) then
      begin
        if (aout^.mflag <> 0) and (aout^.master <> nil) then aout^.master^.slave := nil;
        aout^.master := a;
        a^.slave := aout;
        aout^.masterchn := channel;
        aout^.mflag := 1;
      end;
    end else
      aout := a^.slave;
    if (aout <> nil) then
      aout^.main := a^.main;
    a^.main.kick := KICK_ABSENT;

  end;
end;

/// second effect pass */

procedure pt_EffectsPass2(_mod: PMODULE);
var
  channel           : SWORD;
  a                 : PMP_CONTROL;
  c                 : UBYTE;

begin

  for channel := 0 to _mod^.numchn - 1 do
  begin

    a := @PMP_CONTROLARRAY(_mod^.control)[channel];

    if (a^.row = nil) then continue;
    UniSetRow(a^.row);
    c := UniGetByte();
    while (c <> 0) do
    begin
      if (uni_fx(c) = UNI_ITEFFECTS0) then
      begin
        c := UniGetByte();
        if extsound_fx(c shr 4) = SS_S7EFFECTS then
          DoNNAEffects(_mod, a, c and $F);
      end else
        UniSkipOpcode();
      c := UniGetByte();
    end;
  end;
end;

procedure Player_HandleTick();
var
  channel           : SWORD;
  max_volume        : integer;

begin

  //#if 0
  //	// don't handle the very first ticks, this allows the other hardware to
  //	   settle down so we don't loose any starting notes */
  //	if (isfirst) {
  //		isfirst--;
  //		return;
  //	}
  //#endif

  if (pf2 = nil) or (pf2^.forbid <> 0) or (pf2^.sngpos >= pf2^.numpos) then exit;

  /// update time counter (sngtime is in milliseconds (in fact 2^-10)) */
  pf2^.sngremainder := pf2^.sngremainder + (1 shl 9) * 5; /// thus 2.5*(1<<10), since fps=0.4xtempo */
  pf2^.sngtime := pf2^.sngtime + pf2^.sngremainder div pf2^.bpm;
  pf2^.sngremainder := pf2^.sngremainder mod pf2^.bpm;

  inc(pf2^.vbtick);
  if (pf2^.vbtick >= pf2^.sngspd) then
  begin
    if (pf2^.pat_repcrazy <> 0) then
      pf2^.pat_repcrazy := 0             /// play 2 times row 0 */
    else
      inc(pf2^.patpos);
    pf2^.vbtick := 0;

    /// process pattern-delay. pf2^.patdly2 is the counter and pf2^.patdly is
    //   the command memory. */
    if (pf2^.patdly <> 0) then
    begin
      pf2^.patdly2 := pf2^.patdly;
      pf2^.patdly := 0;
    end;
    if (pf2^.patdly2 <> 0) then
    begin
      /// patterndelay active */
      dec(pf2^.patdly2);
      if (pf2^.patdly2 <> 0) then

        /// so turn back pf2^.patpos by 1 */
        if (pf2^.patpos <> 0) then dec(pf2^.patpos);
    end;

    /// do we have to get a new patternpointer ? (when pf2^.patpos reaches the
    //   pattern size, or when a patternbreak is active) */
    if ((pf2^.patpos >= pf2^.numrow) and (pf2^.numrow > 0)) and (pf2^.posjmp = 0) then
      pf2^.posjmp := 3;

    if (pf2^.posjmp <> 0) then
    begin
      if pf2^.numrow <> 0 then
        pf2^.patpos := pf2^.patbrk mod pf2^.numrow else pf2^.patpos := 0;
      pf2^.pat_repcrazy := 0;
      pf2^.sngpos := pf2^.sngpos + (pf2^.posjmp - 2);

      for channel := 0 to pf2^.numchn - 1 do
        PMP_CONTROLARRAY(pf2^.control)[channel].pat_reppos := -1;

      pf2^.patbrk := 0;
      pf2^.posjmp := 0;
      /// handle the "---" (end of song) pattern since it can occur
      //   *inside* the _module in some formats */

      if ((pf2^.sngpos >= pf2^.numpos) or
        (PUWORDARRAY(pf2^.positions)[pf2^.sngpos] = LAST_PATTERN)) then
      begin
        RewindState := true;

        if (pf2^.wrap = 0) then exit;
        pf2^.sngpos := pf2^.reppos;

        if pf2^.sngpos = 0 then
        begin
          //if pf2^.initvolume > 128 then
           // pf2^.volume := 128 else pf2^.volume := pf2^.initvolume;
          pf2^.volume := pf2^.initvolume + RaznVolume;

          if (pf2^.initspeed <> 0) then
          begin
            if pf2^.initspeed < 32 then
              pf2^.sngspd := pf2^.initspeed else pf2^.sngspd := 32;
          end
          else
            pf2^.sngspd := 6;
         { if pf2^.inittempo < 32 then
            pf2^.bpm := 32 else
            pf2^.bpm := pf2^.inittempo;   }

            pf2^.bpm := raznTemp + pf2^.inittempo;

            //IsTemp(pf2^.bpm, '5');
        end;
      end;

      if (pf2^.sngpos < 0) then pf2^.sngpos := pf2^.numpos - 1;
    end;

    if (pf2^.patdly2 = 0) then
      pt_Notes(pf2);
  end;

  /// Fade global volume if enabled and we're playing the last pattern */

  if (((pf2^.sngpos = pf2^.numpos - 1) or
    (PUWORDARRAY(pf2^.positions)[pf2^.sngpos + 1] = LAST_PATTERN)) and
    (pf2^.fadeout <> 0)) then
    if pf2^.numrow <> 0 then
      max_volume := ((pf2^.numrow - pf2^.patpos) * 128) div pf2^.numrow else max_volume := 0
  else
    max_volume := 128;

  pt_EffectsPass1(pf2);
  if (pf2^.flags and UF_NNA) <> 0 then
    pt_NNA(pf2);
  pt_SetupVoices(pf2);
  pt_EffectsPass2(pf2);

  // now set up the actual hardware channel playback information */
  pt_UpdateVoices(pf2, max_volume);
end;

procedure Player_Init_internal(_mod: PMODULE);
var
  t                 : integer;
begin

  for t := 0 to _mod^.numchn - 1 do
  begin
    PMP_CONTROLARRAY(_mod^.control)[t].main.chanvol := _mod^.chanvol[t];
    PMP_CONTROLARRAY(_mod^.control)[t].main.panning := _mod^.panning[t];
  end;

  _mod^.sngtime := 0;
  _mod^.sngremainder := 0;

  _mod^.pat_repcrazy := 0;
  _mod^.sngpos := 0;
  if (_mod^.initspeed <> 0) then
    if _mod^.initspeed < 32 then
      _mod^.sngspd := _mod^.initspeed else _mod^.sngspd := 32
  else
    _mod^.sngspd := 6;
  if _mod^.initvolume > 128 then
    _mod^.volume := 128 else _mod^.volume := _mod^.initvolume;

  _mod^.vbtick := _mod^.sngspd;
  _mod^.patdly := 0;
  _mod^.patdly2 := 0;
  if _mod^.inittempo < 32 then
    _mod^.bpm := 32 else
    _mod^.bpm := _mod^.inittempo;

 // IsTemp(_mod^.bpm, '8');

  _mod^.realchn := 0;

  _mod^.patpos := 0;
  _mod^.posjmp := 2;                    /// make sure the player fetches the first note */
  _mod^.numrow := 0;                    /// -1 FEHLERGEFAHR
  _mod^.patbrk := 0;
end;

function Player_Init(_mod: PMODULE): BOOL;
begin

  _mod^.extspd := 1;
  _mod^.panflag := 1;
  _mod^.wrap := 0;
  _mod^.loop := 1;
  _mod^.fadeout := 0;

  _mod^.relspd := 0;

  /// make sure the player doesn't start with garbage */
  _mod^.control := _mm_calloc(_mod^.numchn, sizeof(MP_CONTROL));

  if _mod^.control = nil then
  begin
    result := 1;
    exit;
  end;

  _mod^.voice := _mm_calloc(md_sngchn, sizeof(MP_VOICE));
  if _mod^.voice = nil then
  begin
    result := 1;
    exit;
  end;

  Player_Init_internal(_mod);
  result := 0;
end;

procedure Player_Exit_internal(_mod: PMODULE);
begin
  if (_mod = nil) then
    exit;

  /// Stop playback if necessary */
  if (_mod = pf2) then
  begin
    Player_Stop_internal();
    pf2 := nil;
  end;

  if (_mod^.control <> nil) then
    free(_mod^.control);
  if (_mod^.voice <> nil) then
    free(_mod^.voice);
  _mod^.control := nil;
  _mod^.voice := nil;
end;

procedure Player_Exit(_mod: PMODULE);
begin
  MUTEX_LOCK(_mm_mutex_vars);
  Player_Exit_internal(_mod);
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_SetVolume(volume: SWORD);
begin
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
    if (volume < 0) then
      pf2^.volume := 0 else if (volume > 128) then pf2^.volume := 128 else pf2^.volume := volume;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

function Player_GetModule(): PMODULE;
begin
  MUTEX_LOCK(_mm_mutex_vars);
  result := pf2;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_Start(_mod: PMODULE);
var
  t                 : integer;
begin

  if (_mod = nil) then
    exit;

  if (MikMod_Active() = 0) then
    MikMod_EnableOutput();

  _mod^.forbid := 0;

  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> _mod) then
  begin
    /// new song is being started, so completely stop out the old one. */
    if (pf2 <> nil) then pf2^.forbid := 1;
    for t := 0 to md_sngchn - 1 do
      Voice_Stop_internal(t);
  end;
  pf2 := _mod;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_Stop_internal();
begin
  if (md_sfxchn = 0) then MikMod_DisableOutput_internal();
  if (pf2 <> nil) then pf2^.forbid := 1;
  pf2 := nil;
end;

procedure Player_Stop();
begin
  MUTEX_LOCK(_mm_mutex_vars);
  Player_Stop_internal();
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

function Player_Active(): BOOL;
begin
  result := 0;
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
    if not (pf2^.sngpos >= pf2^.numpos) then
      result := 1;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_NextPosition();
var
  t                 : integer;
begin
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
  begin
    pf2^.forbid := 1;
    pf2^.posjmp := 3;
    pf2^.patbrk := 0;
    pf2^.vbtick := pf2^.sngspd;
    for t := 0 to md_sngchn - 1 do
    begin
      Voice_Stop_internal(t);
      PMP_VOICEARRAY(pf2^.voice)[t].main.i := nil;
      PMP_VOICEARRAY(pf2^.voice)[t].main.s := nil;
    end;
    for t := 0 to pf2^.numchn - 1 do
    begin
      PMP_CONTROLARRAY(pf2^.control)[t].main.i := nil;
      PMP_CONTROLARRAY(pf2^.control)[t].main.s := nil;
    end;
    pf2^.forbid := 0;
  end;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_PrevPosition();
var
  t                 : integer;
begin
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
  begin
    pf2^.forbid := 1;
    pf2^.posjmp := 1;
    pf2^.patbrk := 0;
    pf2^.vbtick := pf2^.sngspd;
    for t := 0 to md_sngchn - 1 do
    begin
      Voice_Stop_internal(t);
      PMP_VOICEARRAY(pf2^.voice)[t].main.i := nil;
      PMP_VOICEARRAY(pf2^.voice)[t].main.s := nil;
    end;
    for t := 0 to pf2^.numchn - 1 do
    begin
      PMP_CONTROLARRAY(pf2^.control)[t].main.i := nil;
      PMP_CONTROLARRAY(pf2^.control)[t].main.s := nil;
    end;
    pf2^.forbid := 0;
  end;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_SetPosition(pos: UWORD);
var
  t                 : integer;
begin
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
  begin

    pf2^.forbid := 1;
    if (pos >= pf2^.numpos) then pos := pf2^.numpos;
    pf2^.posjmp := 2;
    pf2^.patbrk := 0;
    pf2^.sngpos := pos;
    pf2^.vbtick := pf2^.sngspd;

    t := 0;
    while t < md_sngchn do
    begin
      Voice_Stop_internal(t);
      inc(pf2^.voice, t);
      pf2^.voice^.main.i := nil;
      pf2^.voice^.main.s := nil;
      dec(pf2^.voice, t);
      inc(t);
    end;

    t := 0;
    while t < pf2^.numchn do
    begin
      inc(pf2^.control, t);
      pf2^.control^.main.i := nil;
      pf2^.control^.main.s := nil;
      dec(pf2^.control, t);
      inc(t);
    end;

    pf2^.forbid := 0;

    if (pos = 0) then
      Player_Init_internal(pf2);
  end;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

// Mute lassen wir erstmal raus!

function Player_GetChannelVoice(chan: UBYTE): integer;
begin
  result := 0;
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
    if (chan < pf2^.numchn) then
      result := PMP_CONTROLARRAY(pf2^.control)[chan].slavechn
    else result := -1;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

function Player_GetChannelPeriod(chan: UBYTE): UWORD;
begin
  result := 0;
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
    if (chan < pf2^.numchn) then
      result := PMP_CONTROLARRAY(pf2^.control)[chan].main.period
    else result := 0;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

function Player_Paused_internal(): BOOL;
begin
  if pf2 <> nil then result := pf2^.forbid else result := 1;
end;

function Player_Paused(): BOOL;
begin
  MUTEX_LOCK(_mm_mutex_vars);
  result := Player_Paused_internal();
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_TogglePause();
begin
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
    pf2^.forbid := not pf2^.forbid;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_SetSpeed(speed: UWORD);
begin
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
    if speed <> 0 then
      if speed < 32 then pf2^.sngspd := speed else pf2^.sngspd := 32
    else pf2^.sngspd := 1;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;

procedure Player_SetTempo(tempo: UWORD);
begin
  if (tempo < 32) then tempo := 32;
  MUTEX_LOCK(_mm_mutex_vars);
  if (pf2 <> nil) then
  begin
    if ((pf2^.flags and UF_HIGHBPM) = 0) and (tempo > 255) then tempo := 255;
    pf2^.bpm := tempo;
  end;
  MUTEX_UNLOCK(_mm_mutex_vars);
end;


initialization
  with _drv_win do
  begin
    next := nil;
    Name := 'Windows waveform-audio';
    Version := 'Windows waveform-audio driver v0.1';
    HardVoiceLimit := 0;
    SoftVoiceLimit := 255;
    Alias := 'winmm';
    CommandLine := nil;
    IsPresent := WIN_IsThere;
    SampleLoad := VC2_SampleLoad;
    SampleUnload := VC2_SampleUnload;
    FreeSampleSpace := VC2_SampleSpace;
    RealSampleLength := VC2_SampleLength;
    Init := WIN_Init;
    Exit := WIN_Exit;
    Reset := nil;
    SetNumVoices := VC2_SetNumVoices;
    PlayStart := VC2_PlayStart;
    PlayStop := WIN_PlayStop;
    Update := WIN_Update;
    Pause := nil;
    VoiceSetVolume := VC2_VoiceSetVolume;
    VoiceGetVolume := VC2_VoiceGetVolume;
    VoiceSetFrequency := VC2_VoiceSetFrequency;
    VoiceGetFrequency := VC2_VoiceGetFrequency;
    VoiceSetPanning := VC2_VoiceSetPanning;
    VoiceGetPanning := VC2_VoiceGetPanning;
    VoicePlay := VC2_VoicePlay;
    VoiceStop := VC2_VoiceStop;
    VoiceStopped := VC2_VoiceStopped;
    VoiceGetPosition := VC2_VoiceGetPosition;
    VoiceRealVolume := VC2_VoiceRealVolume;
  end;

  InitMikMod;
  
finalization
   FinalMikMod;  

end.

